from pip._vendor.chardet.sbcharsetprober import SingleByteCharSetModel






BULGARIAN_LANG_MODEL = {
    63: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 1,  
        9: 1,  
        20: 1,  
        11: 1,  
        3: 1,  
        23: 1,  
        15: 1,  
        2: 0,  
        26: 1,  
        12: 1,  
        10: 1,  
        14: 1,  
        6: 1,  
        4: 1,  
        13: 1,  
        7: 1,  
        8: 1,  
        5: 1,  
        19: 0,  
        29: 1,  
        25: 1,  
        22: 0,  
        21: 1,  
        27: 1,  
        24: 1,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    45: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 1,  
        35: 1,  
        43: 0,  
        37: 1,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 0,  
        38: 1,  
        36: 0,  
        41: 1,  
        30: 1,  
        39: 1,  
        28: 1,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 1,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 0,  
        23: 0,  
        15: 0,  
        2: 0,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 0,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 0,  
        19: 0,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    31: {  
        63: 0,  
        45: 1,  
        31: 1,  
        32: 1,  
        35: 2,  
        43: 1,  
        37: 2,  
        44: 2,  
        55: 1,  
        47: 2,  
        40: 1,  
        59: 1,  
        33: 1,  
        46: 2,  
        38: 1,  
        36: 2,  
        41: 1,  
        30: 2,  
        39: 2,  
        28: 2,  
        34: 2,  
        51: 1,  
        48: 2,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 1,  
        57: 2,  
        61: 0,  
        60: 0,  
        56: 1,  
        1: 1,  
        18: 2,  
        9: 2,  
        20: 2,  
        11: 2,  
        3: 1,  
        23: 1,  
        15: 2,  
        2: 0,  
        26: 2,  
        12: 2,  
        10: 3,  
        14: 2,  
        6: 3,  
        4: 0,  
        13: 2,  
        7: 2,  
        8: 2,  
        5: 2,  
        19: 1,  
        29: 2,  
        25: 1,  
        22: 1,  
        21: 1,  
        27: 1,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    32: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 2,  
        35: 1,  
        43: 1,  
        37: 2,  
        44: 1,  
        55: 1,  
        47: 2,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 2,  
        41: 2,  
        30: 1,  
        39: 1,  
        28: 2,  
        34: 2,  
        51: 1,  
        48: 2,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 0,  
        57: 1,  
        61: 2,  
        60: 1,  
        56: 1,  
        1: 3,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 1,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 2,  
        14: 0,  
        6: 0,  
        4: 3,  
        13: 0,  
        7: 2,  
        8: 1,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 3,  
        52: 1,  
        42: 1,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    35: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 0,  
        37: 1,  
        44: 2,  
        55: 0,  
        47: 0,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 1,  
        30: 1,  
        39: 2,  
        28: 2,  
        34: 1,  
        51: 1,  
        48: 2,  
        49: 0,  
        53: 1,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 2,  
        1: 3,  
        18: 1,  
        9: 0,  
        20: 0,  
        11: 1,  
        3: 3,  
        23: 1,  
        15: 2,  
        2: 3,  
        26: 0,  
        12: 1,  
        10: 2,  
        14: 1,  
        6: 2,  
        4: 2,  
        13: 1,  
        7: 2,  
        8: 2,  
        5: 2,  
        19: 1,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 2,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    43: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 0,  
        43: 0,  
        37: 1,  
        44: 2,  
        55: 0,  
        47: 1,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 0,  
        36: 1,  
        41: 1,  
        30: 0,  
        39: 1,  
        28: 1,  
        34: 0,  
        51: 1,  
        48: 1,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 1,  
        61: 1,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 1,  
        9: 1,  
        20: 0,  
        11: 1,  
        3: 3,  
        23: 1,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 1,  
        10: 2,  
        14: 1,  
        6: 1,  
        4: 2,  
        13: 0,  
        7: 2,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 1,  
        17: 2,  
        52: 1,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    37: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 2,  
        43: 1,  
        37: 2,  
        44: 2,  
        55: 2,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 2,  
        39: 1,  
        28: 2,  
        34: 1,  
        51: 1,  
        48: 1,  
        49: 0,  
        53: 1,  
        50: 1,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 1,  
        1: 3,  
        18: 0,  
        9: 2,  
        20: 0,  
        11: 0,  
        3: 3,  
        23: 3,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 0,  
        10: 1,  
        14: 1,  
        6: 2,  
        4: 3,  
        13: 0,  
        7: 2,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 2,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    44: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 1,  
        35: 2,  
        43: 1,  
        37: 1,  
        44: 1,  
        55: 1,  
        47: 1,  
        40: 1,  
        59: 1,  
        33: 2,  
        46: 2,  
        38: 1,  
        36: 2,  
        41: 2,  
        30: 1,  
        39: 2,  
        28: 2,  
        34: 2,  
        51: 1,  
        48: 2,  
        49: 1,  
        53: 2,  
        50: 1,  
        54: 1,  
        57: 1,  
        61: 0,  
        60: 0,  
        56: 1,  
        1: 0,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 2,  
        3: 0,  
        23: 1,  
        15: 1,  
        2: 0,  
        26: 1,  
        12: 2,  
        10: 2,  
        14: 2,  
        6: 2,  
        4: 0,  
        13: 1,  
        7: 2,  
        8: 2,  
        5: 1,  
        19: 1,  
        29: 1,  
        25: 1,  
        22: 0,  
        21: 1,  
        27: 1,  
        24: 1,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    55: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 0,  
        35: 1,  
        43: 0,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 0,  
        38: 0,  
        36: 1,  
        41: 1,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 1,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 1,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 2,  
        13: 1,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 1,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 1,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    47: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 1,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 2,  
        41: 1,  
        30: 1,  
        39: 1,  
        28: 1,  
        34: 1,  
        51: 1,  
        48: 0,  
        49: 1,  
        53: 1,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 0,  
        56: 1,  
        1: 3,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 2,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 1,  
        26: 0,  
        12: 0,  
        10: 2,  
        14: 1,  
        6: 1,  
        4: 1,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 1,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    40: {  
        63: 0,  
        45: 1,  
        31: 1,  
        32: 1,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 2,  
        55: 1,  
        47: 2,  
        40: 1,  
        59: 1,  
        33: 2,  
        46: 2,  
        38: 2,  
        36: 2,  
        41: 1,  
        30: 1,  
        39: 2,  
        28: 2,  
        34: 2,  
        51: 0,  
        48: 1,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 1,  
        57: 1,  
        61: 0,  
        60: 0,  
        56: 2,  
        1: 1,  
        18: 1,  
        9: 3,  
        20: 2,  
        11: 1,  
        3: 1,  
        23: 0,  
        15: 3,  
        2: 0,  
        26: 1,  
        12: 1,  
        10: 2,  
        14: 2,  
        6: 2,  
        4: 0,  
        13: 1,  
        7: 2,  
        8: 2,  
        5: 2,  
        19: 0,  
        29: 1,  
        25: 1,  
        22: 1,  
        21: 1,  
        27: 1,  
        24: 1,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    59: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 1,  
        30: 0,  
        39: 0,  
        28: 1,  
        34: 1,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 1,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 1,  
        1: 0,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 1,  
        23: 0,  
        15: 0,  
        2: 0,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 2,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 0,  
        19: 0,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    33: {  
        63: 0,  
        45: 1,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 0,  
        36: 2,  
        41: 2,  
        30: 2,  
        39: 1,  
        28: 2,  
        34: 1,  
        51: 1,  
        48: 1,  
        49: 1,  
        53: 1,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 0,  
        1: 3,  
        18: 0,  
        9: 1,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 1,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 2,  
        14: 1,  
        6: 2,  
        4: 3,  
        13: 0,  
        7: 3,  
        8: 1,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 0,  
        27: 1,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 2,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    46: {  
        63: 1,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 2,  
        37: 1,  
        44: 2,  
        55: 0,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 0,  
        36: 1,  
        41: 2,  
        30: 1,  
        39: 0,  
        28: 1,  
        34: 1,  
        51: 1,  
        48: 0,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 1,  
        1: 2,  
        18: 0,  
        9: 1,  
        20: 0,  
        11: 0,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 2,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 1,  
        42: 2,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    38: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 2,  
        43: 0,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 1,  
        39: 1,  
        28: 2,  
        34: 1,  
        51: 1,  
        48: 1,  
        49: 0,  
        53: 1,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 0,  
        56: 1,  
        1: 3,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 0,  
        10: 2,  
        14: 0,  
        6: 2,  
        4: 3,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 2,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    36: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 2,  
        35: 1,  
        43: 1,  
        37: 2,  
        44: 2,  
        55: 1,  
        47: 1,  
        40: 2,  
        59: 1,  
        33: 2,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 1,  
        39: 1,  
        28: 2,  
        34: 2,  
        51: 1,  
        48: 1,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 1,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 1,  
        1: 3,  
        18: 0,  
        9: 0,  
        20: 1,  
        11: 0,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 3,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 1,  
        19: 1,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 1,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 2,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    41: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 1,  
        35: 2,  
        43: 1,  
        37: 2,  
        44: 1,  
        55: 1,  
        47: 1,  
        40: 1,  
        59: 1,  
        33: 2,  
        46: 2,  
        38: 2,  
        36: 2,  
        41: 2,  
        30: 1,  
        39: 2,  
        28: 2,  
        34: 2,  
        51: 1,  
        48: 1,  
        49: 1,  
        53: 0,  
        50: 1,  
        54: 1,  
        57: 1,  
        61: 0,  
        60: 0,  
        56: 1,  
        1: 1,  
        18: 2,  
        9: 2,  
        20: 2,  
        11: 1,  
        3: 1,  
        23: 1,  
        15: 1,  
        2: 0,  
        26: 1,  
        12: 2,  
        10: 2,  
        14: 1,  
        6: 1,  
        4: 0,  
        13: 2,  
        7: 2,  
        8: 2,  
        5: 3,  
        19: 1,  
        29: 1,  
        25: 1,  
        22: 1,  
        21: 2,  
        27: 0,  
        24: 2,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    30: {  
        63: 0,  
        45: 1,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 2,  
        39: 2,  
        28: 2,  
        34: 1,  
        51: 2,  
        48: 1,  
        49: 0,  
        53: 1,  
        50: 1,  
        54: 1,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 0,  
        1: 3,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 2,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 1,  
        10: 3,  
        14: 0,  
        6: 1,  
        4: 3,  
        13: 0,  
        7: 3,  
        8: 1,  
        5: 1,  
        19: 2,  
        29: 1,  
        25: 1,  
        22: 0,  
        21: 1,  
        27: 1,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    39: {  
        63: 0,  
        45: 1,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 2,  
        37: 2,  
        44: 2,  
        55: 0,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 0,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 2,  
        39: 1,  
        28: 1,  
        34: 1,  
        51: 1,  
        48: 1,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 1,  
        1: 3,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 1,  
        4: 3,  
        13: 0,  
        7: 0,  
        8: 1,  
        5: 0,  
        19: 3,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    28: {  
        63: 1,  
        45: 0,  
        31: 3,  
        32: 2,  
        35: 2,  
        43: 1,  
        37: 2,  
        44: 2,  
        55: 1,  
        47: 1,  
        40: 2,  
        59: 0,  
        33: 2,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 2,  
        39: 1,  
        28: 2,  
        34: 2,  
        51: 1,  
        48: 1,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 1,  
        56: 1,  
        1: 3,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 1,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 2,  
        10: 3,  
        14: 2,  
        6: 1,  
        4: 3,  
        13: 3,  
        7: 2,  
        8: 0,  
        5: 3,  
        19: 2,  
        29: 2,  
        25: 1,  
        22: 1,  
        21: 1,  
        27: 0,  
        24: 0,  
        17: 3,  
        52: 1,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    34: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 2,  
        35: 1,  
        43: 0,  
        37: 1,  
        44: 2,  
        55: 0,  
        47: 0,  
        40: 2,  
        59: 0,  
        33: 2,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 2,  
        30: 1,  
        39: 2,  
        28: 2,  
        34: 1,  
        51: 1,  
        48: 1,  
        49: 0,  
        53: 1,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 1,  
        60: 0,  
        56: 1,  
        1: 3,  
        18: 1,  
        9: 1,  
        20: 0,  
        11: 0,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 1,  
        10: 1,  
        14: 0,  
        6: 0,  
        4: 3,  
        13: 0,  
        7: 3,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 0,  
        42: 1,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    51: {  
        63: 0,  
        45: 1,  
        31: 1,  
        32: 1,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 2,  
        55: 1,  
        47: 1,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 0,  
        30: 1,  
        39: 1,  
        28: 1,  
        34: 2,  
        51: 0,  
        48: 1,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 1,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 1,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 1,  
        3: 2,  
        23: 1,  
        15: 1,  
        2: 2,  
        26: 1,  
        12: 2,  
        10: 1,  
        14: 1,  
        6: 2,  
        4: 2,  
        13: 1,  
        7: 1,  
        8: 2,  
        5: 1,  
        19: 1,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 2,  
        27: 1,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    48: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 1,  
        43: 0,  
        37: 0,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 2,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 0,  
        36: 1,  
        41: 1,  
        30: 2,  
        39: 1,  
        28: 2,  
        34: 1,  
        51: 1,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 2,  
        14: 0,  
        6: 0,  
        4: 2,  
        13: 0,  
        7: 2,  
        8: 0,  
        5: 0,  
        19: 1,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 1,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    49: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 0,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 1,  
        59: 0,  
        33: 0,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 1,  
        30: 1,  
        39: 1,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 1,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 1,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 1,  
        14: 1,  
        6: 0,  
        4: 2,  
        13: 0,  
        7: 2,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    53: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 0,  
        35: 1,  
        43: 0,  
        37: 0,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 2,  
        59: 0,  
        33: 2,  
        46: 1,  
        38: 1,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 1,  
        28: 2,  
        34: 0,  
        51: 1,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 2,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 0,  
        15: 1,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 1,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 1,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    50: {  
        63: 0,  
        45: 0,  
        31: 2,  
        32: 1,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 1,  
        55: 0,  
        47: 1,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 0,  
        36: 1,  
        41: 1,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 1,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 3,  
        23: 1,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 0,  
        10: 1,  
        14: 0,  
        6: 0,  
        4: 2,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 1,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    54: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 1,  
        55: 0,  
        47: 1,  
        40: 1,  
        59: 0,  
        33: 1,  
        46: 0,  
        38: 0,  
        36: 1,  
        41: 1,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 1,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 2,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 2,  
        26: 0,  
        12: 1,  
        10: 1,  
        14: 1,  
        6: 1,  
        4: 2,  
        13: 1,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 1,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 1,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    57: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 1,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 1,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 2,  
        23: 0,  
        15: 0,  
        2: 1,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 1,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 1,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    61: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 1,  
        35: 1,  
        43: 0,  
        37: 1,  
        44: 0,  
        55: 1,  
        47: 1,  
        40: 0,  
        59: 0,  
        33: 1,  
        46: 2,  
        38: 1,  
        36: 1,  
        41: 0,  
        30: 1,  
        39: 2,  
        28: 1,  
        34: 1,  
        51: 0,  
        48: 0,  
        49: 1,  
        53: 1,  
        50: 1,  
        54: 1,  
        57: 1,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 0,  
        23: 0,  
        15: 0,  
        2: 0,  
        26: 0,  
        12: 0,  
        10: 1,  
        14: 0,  
        6: 1,  
        4: 0,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 0,  
        19: 0,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    60: {  
        63: 0,  
        45: 0,  
        31: 1,  
        32: 1,  
        35: 0,  
        43: 1,  
        37: 1,  
        44: 0,  
        55: 1,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 0,  
        36: 1,  
        41: 0,  
        30: 0,  
        39: 1,  
        28: 1,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 1,  
        9: 1,  
        20: 2,  
        11: 1,  
        3: 0,  
        23: 2,  
        15: 1,  
        2: 1,  
        26: 0,  
        12: 1,  
        10: 1,  
        14: 1,  
        6: 1,  
        4: 0,  
        13: 1,  
        7: 1,  
        8: 1,  
        5: 1,  
        19: 0,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    56: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 1,  
        35: 1,  
        43: 1,  
        37: 1,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 1,  
        46: 1,  
        38: 1,  
        36: 1,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 1,  
        34: 2,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 1,  
        9: 1,  
        20: 1,  
        11: 1,  
        3: 0,  
        23: 0,  
        15: 1,  
        2: 1,  
        26: 1,  
        12: 1,  
        10: 1,  
        14: 2,  
        6: 2,  
        4: 0,  
        13: 2,  
        7: 1,  
        8: 1,  
        5: 1,  
        19: 0,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 0,  
        27: 1,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    1: {  
        63: 1,  
        45: 1,  
        31: 1,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 1,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 1,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 3,  
        23: 3,  
        15: 3,  
        2: 3,  
        26: 3,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 2,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 3,  
        25: 3,  
        22: 3,  
        21: 3,  
        27: 3,  
        24: 3,  
        17: 0,  
        52: 0,  
        42: 1,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    18: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 0,  
        9: 3,  
        20: 1,  
        11: 2,  
        3: 3,  
        23: 1,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 1,  
        10: 3,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 1,  
        7: 3,  
        8: 3,  
        5: 0,  
        19: 3,  
        29: 0,  
        25: 2,  
        22: 1,  
        21: 1,  
        27: 1,  
        24: 3,  
        17: 3,  
        52: 1,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    9: {  
        63: 1,  
        45: 1,  
        31: 0,  
        32: 1,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 1,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 0,  
        20: 2,  
        11: 3,  
        3: 3,  
        23: 1,  
        15: 3,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 3,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 2,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 2,  
        29: 0,  
        25: 2,  
        22: 2,  
        21: 3,  
        27: 2,  
        24: 1,  
        17: 3,  
        52: 1,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    20: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 2,  
        3: 3,  
        23: 0,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 1,  
        10: 3,  
        14: 1,  
        6: 3,  
        4: 3,  
        13: 1,  
        7: 3,  
        8: 2,  
        5: 2,  
        19: 3,  
        29: 1,  
        25: 1,  
        22: 0,  
        21: 1,  
        27: 0,  
        24: 0,  
        17: 3,  
        52: 1,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    11: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 2,  
        9: 3,  
        20: 2,  
        11: 2,  
        3: 3,  
        23: 3,  
        15: 2,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 1,  
        19: 3,  
        29: 1,  
        25: 2,  
        22: 2,  
        21: 2,  
        27: 1,  
        24: 1,  
        17: 3,  
        52: 1,  
        42: 1,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    3: {  
        63: 0,  
        45: 1,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 2,  
        23: 3,  
        15: 3,  
        2: 2,  
        26: 3,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 2,  
        29: 3,  
        25: 3,  
        22: 3,  
        21: 3,  
        27: 3,  
        24: 3,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    23: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 2,  
        20: 1,  
        11: 3,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 2,  
        10: 1,  
        14: 1,  
        6: 3,  
        4: 2,  
        13: 1,  
        7: 1,  
        8: 1,  
        5: 1,  
        19: 2,  
        29: 0,  
        25: 0,  
        22: 1,  
        21: 1,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    15: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 3,  
        23: 1,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 1,  
        25: 2,  
        22: 2,  
        21: 2,  
        27: 2,  
        24: 1,  
        17: 2,  
        52: 1,  
        42: 1,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    2: {  
        63: 1,  
        45: 1,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 1,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 1,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 1,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 1,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 3,  
        23: 3,  
        15: 3,  
        2: 3,  
        26: 3,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 2,  
        29: 3,  
        25: 3,  
        22: 3,  
        21: 3,  
        27: 3,  
        24: 3,  
        17: 2,  
        52: 0,  
        42: 1,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    26: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 1,  
        18: 2,  
        9: 2,  
        20: 1,  
        11: 2,  
        3: 2,  
        23: 0,  
        15: 2,  
        2: 1,  
        26: 0,  
        12: 3,  
        10: 2,  
        14: 2,  
        6: 3,  
        4: 2,  
        13: 1,  
        7: 2,  
        8: 3,  
        5: 3,  
        19: 1,  
        29: 2,  
        25: 1,  
        22: 2,  
        21: 2,  
        27: 1,  
        24: 1,  
        17: 1,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    12: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 1,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 1,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 3,  
        20: 2,  
        11: 1,  
        3: 3,  
        23: 0,  
        15: 2,  
        2: 3,  
        26: 0,  
        12: 1,  
        10: 3,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 1,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 1,  
        25: 1,  
        22: 3,  
        21: 2,  
        27: 1,  
        24: 0,  
        17: 3,  
        52: 1,  
        42: 2,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    10: {  
        63: 1,  
        45: 1,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 1,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 2,  
        3: 3,  
        23: 3,  
        15: 2,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 1,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 2,  
        7: 2,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 2,  
        25: 2,  
        22: 2,  
        21: 2,  
        27: 2,  
        24: 1,  
        17: 3,  
        52: 2,  
        42: 3,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    14: {  
        63: 1,  
        45: 0,  
        31: 1,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 1,  
        11: 1,  
        3: 3,  
        23: 1,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 2,  
        10: 3,  
        14: 1,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 2,  
        8: 2,  
        5: 1,  
        19: 3,  
        29: 2,  
        25: 1,  
        22: 2,  
        21: 2,  
        27: 2,  
        24: 1,  
        17: 3,  
        52: 1,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    6: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 1,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 2,  
        9: 2,  
        20: 3,  
        11: 3,  
        3: 3,  
        23: 2,  
        15: 2,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 2,  
        14: 1,  
        6: 3,  
        4: 3,  
        13: 1,  
        7: 2,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 3,  
        25: 2,  
        22: 3,  
        21: 3,  
        27: 2,  
        24: 1,  
        17: 3,  
        52: 2,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    4: {  
        63: 0,  
        45: 1,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 2,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 3,  
        23: 3,  
        15: 3,  
        2: 3,  
        26: 3,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 2,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 2,  
        29: 3,  
        25: 3,  
        22: 3,  
        21: 3,  
        27: 3,  
        24: 3,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    13: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 1,  
        3: 3,  
        23: 0,  
        15: 1,  
        2: 3,  
        26: 1,  
        12: 2,  
        10: 3,  
        14: 1,  
        6: 2,  
        4: 3,  
        13: 1,  
        7: 3,  
        8: 2,  
        5: 2,  
        19: 3,  
        29: 1,  
        25: 1,  
        22: 2,  
        21: 2,  
        27: 1,  
        24: 1,  
        17: 3,  
        52: 1,  
        42: 2,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    7: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 3,  
        23: 3,  
        15: 2,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 2,  
        7: 1,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 2,  
        25: 3,  
        22: 3,  
        21: 2,  
        27: 3,  
        24: 1,  
        17: 3,  
        52: 1,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    8: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 2,  
        9: 3,  
        20: 2,  
        11: 2,  
        3: 3,  
        23: 0,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 3,  
        8: 1,  
        5: 3,  
        19: 3,  
        29: 2,  
        25: 2,  
        22: 2,  
        21: 2,  
        27: 2,  
        24: 0,  
        17: 3,  
        52: 2,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    5: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 2,  
        11: 2,  
        3: 3,  
        23: 1,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 3,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 2,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 3,  
        29: 1,  
        25: 2,  
        22: 2,  
        21: 2,  
        27: 1,  
        24: 1,  
        17: 3,  
        52: 2,  
        42: 2,  
        16: 3,  
        58: 0,  
        62: 0,  
    },
    19: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 2,  
        23: 3,  
        15: 3,  
        2: 2,  
        26: 2,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 2,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 1,  
        29: 2,  
        25: 2,  
        22: 2,  
        21: 3,  
        27: 3,  
        24: 2,  
        17: 1,  
        52: 0,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    29: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 1,  
        20: 1,  
        11: 0,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 2,  
        10: 2,  
        14: 1,  
        6: 1,  
        4: 3,  
        13: 0,  
        7: 2,  
        8: 2,  
        5: 2,  
        19: 2,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 1,  
        27: 1,  
        24: 0,  
        17: 2,  
        52: 2,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    25: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 3,  
        20: 0,  
        11: 1,  
        3: 2,  
        23: 0,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 1,  
        10: 2,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 1,  
        7: 3,  
        8: 1,  
        5: 2,  
        19: 3,  
        29: 0,  
        25: 1,  
        22: 0,  
        21: 1,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 0,  
        42: 1,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    22: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 2,  
        20: 1,  
        11: 1,  
        3: 3,  
        23: 0,  
        15: 1,  
        2: 3,  
        26: 0,  
        12: 2,  
        10: 1,  
        14: 1,  
        6: 1,  
        4: 2,  
        13: 1,  
        7: 1,  
        8: 1,  
        5: 1,  
        19: 2,  
        29: 1,  
        25: 1,  
        22: 1,  
        21: 1,  
        27: 1,  
        24: 1,  
        17: 2,  
        52: 1,  
        42: 0,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    21: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 1,  
        9: 3,  
        20: 1,  
        11: 0,  
        3: 3,  
        23: 1,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 2,  
        14: 2,  
        6: 3,  
        4: 3,  
        13: 0,  
        7: 2,  
        8: 0,  
        5: 2,  
        19: 3,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 1,  
        24: 0,  
        17: 2,  
        52: 0,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    27: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 0,  
        9: 2,  
        20: 0,  
        11: 1,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 3,  
        10: 2,  
        14: 1,  
        6: 3,  
        4: 2,  
        13: 2,  
        7: 1,  
        8: 0,  
        5: 1,  
        19: 2,  
        29: 1,  
        25: 0,  
        22: 0,  
        21: 1,  
        27: 0,  
        24: 0,  
        17: 2,  
        52: 1,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    24: {  
        63: 1,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 3,  
        18: 0,  
        9: 1,  
        20: 0,  
        11: 0,  
        3: 3,  
        23: 0,  
        15: 0,  
        2: 3,  
        26: 0,  
        12: 1,  
        10: 0,  
        14: 0,  
        6: 2,  
        4: 3,  
        13: 0,  
        7: 1,  
        8: 0,  
        5: 2,  
        19: 3,  
        29: 0,  
        25: 0,  
        22: 1,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 1,  
        52: 0,  
        42: 0,  
        16: 2,  
        58: 0,  
        62: 0,  
    },
    17: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 1,  
        18: 3,  
        9: 3,  
        20: 3,  
        11: 3,  
        3: 2,  
        23: 3,  
        15: 3,  
        2: 1,  
        26: 2,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 3,  
        13: 3,  
        7: 3,  
        8: 3,  
        5: 3,  
        19: 1,  
        29: 1,  
        25: 2,  
        22: 2,  
        21: 3,  
        27: 2,  
        24: 3,  
        17: 0,  
        52: 0,  
        42: 2,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    52: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 1,  
        23: 0,  
        15: 0,  
        2: 0,  
        26: 0,  
        12: 1,  
        10: 0,  
        14: 0,  
        6: 1,  
        4: 3,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 1,  
        19: 0,  
        29: 0,  
        25: 0,  
        22: 1,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 1,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    42: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 1,  
        18: 2,  
        9: 1,  
        20: 2,  
        11: 2,  
        3: 1,  
        23: 2,  
        15: 2,  
        2: 1,  
        26: 1,  
        12: 2,  
        10: 2,  
        14: 2,  
        6: 2,  
        4: 1,  
        13: 1,  
        7: 2,  
        8: 2,  
        5: 2,  
        19: 1,  
        29: 1,  
        25: 1,  
        22: 2,  
        21: 3,  
        27: 1,  
        24: 1,  
        17: 1,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    16: {  
        63: 0,  
        45: 1,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 3,  
        9: 3,  
        20: 2,  
        11: 3,  
        3: 2,  
        23: 1,  
        15: 2,  
        2: 1,  
        26: 2,  
        12: 3,  
        10: 3,  
        14: 3,  
        6: 3,  
        4: 1,  
        13: 2,  
        7: 2,  
        8: 3,  
        5: 3,  
        19: 1,  
        29: 1,  
        25: 3,  
        22: 2,  
        21: 1,  
        27: 1,  
        24: 2,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 1,  
        58: 0,  
        62: 0,  
    },
    58: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 0,  
        23: 0,  
        15: 0,  
        2: 0,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 0,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 0,  
        19: 0,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
    62: {  
        63: 0,  
        45: 0,  
        31: 0,  
        32: 0,  
        35: 0,  
        43: 0,  
        37: 0,  
        44: 0,  
        55: 0,  
        47: 0,  
        40: 0,  
        59: 0,  
        33: 0,  
        46: 0,  
        38: 0,  
        36: 0,  
        41: 0,  
        30: 0,  
        39: 0,  
        28: 0,  
        34: 0,  
        51: 0,  
        48: 0,  
        49: 0,  
        53: 0,  
        50: 0,  
        54: 0,  
        57: 0,  
        61: 0,  
        60: 0,  
        56: 0,  
        1: 0,  
        18: 0,  
        9: 0,  
        20: 0,  
        11: 0,  
        3: 0,  
        23: 0,  
        15: 0,  
        2: 0,  
        26: 0,  
        12: 0,  
        10: 0,  
        14: 0,  
        6: 0,  
        4: 0,  
        13: 0,  
        7: 0,  
        8: 0,  
        5: 0,  
        19: 0,  
        29: 0,  
        25: 0,  
        22: 0,  
        21: 0,  
        27: 0,  
        24: 0,  
        17: 0,  
        52: 0,  
        42: 0,  
        16: 0,  
        58: 0,  
        62: 0,  
    },
}








ISO_8859_5_BULGARIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 77,  
    66: 90,  
    67: 99,  
    68: 100,  
    69: 72,  
    70: 109,  
    71: 107,  
    72: 101,  
    73: 79,  
    74: 185,  
    75: 81,  
    76: 102,  
    77: 76,  
    78: 94,  
    79: 82,  
    80: 110,  
    81: 186,  
    82: 108,  
    83: 91,  
    84: 74,  
    85: 119,  
    86: 84,  
    87: 96,  
    88: 111,  
    89: 187,  
    90: 115,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 65,  
    98: 69,  
    99: 70,  
    100: 66,  
    101: 63,  
    102: 68,  
    103: 112,  
    104: 103,  
    105: 92,  
    106: 194,  
    107: 104,  
    108: 95,  
    109: 86,  
    110: 87,  
    111: 71,  
    112: 116,  
    113: 195,  
    114: 85,  
    115: 93,  
    116: 97,  
    117: 113,  
    118: 196,  
    119: 197,  
    120: 198,  
    121: 199,  
    122: 200,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 194,  
    129: 195,  
    130: 196,  
    131: 197,  
    132: 198,  
    133: 199,  
    134: 200,  
    135: 201,  
    136: 202,  
    137: 203,  
    138: 204,  
    139: 205,  
    140: 206,  
    141: 207,  
    142: 208,  
    143: 209,  
    144: 210,  
    145: 211,  
    146: 212,  
    147: 213,  
    148: 214,  
    149: 215,  
    150: 216,  
    151: 217,  
    152: 218,  
    153: 219,  
    154: 220,  
    155: 221,  
    156: 222,  
    157: 223,  
    158: 224,  
    159: 225,  
    160: 81,  
    161: 226,  
    162: 227,  
    163: 228,  
    164: 229,  
    165: 230,  
    166: 105,  
    167: 231,  
    168: 232,  
    169: 233,  
    170: 234,  
    171: 235,  
    172: 236,  
    173: 45,  
    174: 237,  
    175: 238,  
    176: 31,  
    177: 32,  
    178: 35,  
    179: 43,  
    180: 37,  
    181: 44,  
    182: 55,  
    183: 47,  
    184: 40,  
    185: 59,  
    186: 33,  
    187: 46,  
    188: 38,  
    189: 36,  
    190: 41,  
    191: 30,  
    192: 39,  
    193: 28,  
    194: 34,  
    195: 51,  
    196: 48,  
    197: 49,  
    198: 53,  
    199: 50,  
    200: 54,  
    201: 57,  
    202: 61,  
    203: 239,  
    204: 67,  
    205: 240,  
    206: 60,  
    207: 56,  
    208: 1,  
    209: 18,  
    210: 9,  
    211: 20,  
    212: 11,  
    213: 3,  
    214: 23,  
    215: 15,  
    216: 2,  
    217: 26,  
    218: 12,  
    219: 10,  
    220: 14,  
    221: 6,  
    222: 4,  
    223: 13,  
    224: 7,  
    225: 8,  
    226: 5,  
    227: 19,  
    228: 29,  
    229: 25,  
    230: 22,  
    231: 21,  
    232: 27,  
    233: 24,  
    234: 17,  
    235: 75,  
    236: 52,  
    237: 241,  
    238: 42,  
    239: 16,  
    240: 62,  
    241: 242,  
    242: 243,  
    243: 244,  
    244: 58,  
    245: 245,  
    246: 98,  
    247: 246,  
    248: 247,  
    249: 248,  
    250: 249,  
    251: 250,  
    252: 251,  
    253: 91,  
    254: 252,  
    255: 253,  
}

ISO_8859_5_BULGARIAN_MODEL = SingleByteCharSetModel(
    charset_name="ISO-8859-5",
    language="Bulgarian",
    char_to_order_map=ISO_8859_5_BULGARIAN_CHAR_TO_ORDER,
    language_model=BULGARIAN_LANG_MODEL,
    typical_positive_ratio=0.969392,
    keep_ascii_letters=False,
    alphabet="АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЬЮЯабвгдежзийклмнопрстуфхцчшщъьюя",
)

WINDOWS_1251_BULGARIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 77,  
    66: 90,  
    67: 99,  
    68: 100,  
    69: 72,  
    70: 109,  
    71: 107,  
    72: 101,  
    73: 79,  
    74: 185,  
    75: 81,  
    76: 102,  
    77: 76,  
    78: 94,  
    79: 82,  
    80: 110,  
    81: 186,  
    82: 108,  
    83: 91,  
    84: 74,  
    85: 119,  
    86: 84,  
    87: 96,  
    88: 111,  
    89: 187,  
    90: 115,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 65,  
    98: 69,  
    99: 70,  
    100: 66,  
    101: 63,  
    102: 68,  
    103: 112,  
    104: 103,  
    105: 92,  
    106: 194,  
    107: 104,  
    108: 95,  
    109: 86,  
    110: 87,  
    111: 71,  
    112: 116,  
    113: 195,  
    114: 85,  
    115: 93,  
    116: 97,  
    117: 113,  
    118: 196,  
    119: 197,  
    120: 198,  
    121: 199,  
    122: 200,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 206,  
    129: 207,  
    130: 208,  
    131: 209,  
    132: 210,  
    133: 211,  
    134: 212,  
    135: 213,  
    136: 120,  
    137: 214,  
    138: 215,  
    139: 216,  
    140: 217,  
    141: 218,  
    142: 219,  
    143: 220,  
    144: 221,  
    145: 78,  
    146: 64,  
    147: 83,  
    148: 121,  
    149: 98,  
    150: 117,  
    151: 105,  
    152: 222,  
    153: 223,  
    154: 224,  
    155: 225,  
    156: 226,  
    157: 227,  
    158: 228,  
    159: 229,  
    160: 88,  
    161: 230,  
    162: 231,  
    163: 232,  
    164: 233,  
    165: 122,  
    166: 89,  
    167: 106,  
    168: 234,  
    169: 235,  
    170: 236,  
    171: 237,  
    172: 238,  
    173: 45,  
    174: 239,  
    175: 240,  
    176: 73,  
    177: 80,  
    178: 118,  
    179: 114,  
    180: 241,  
    181: 242,  
    182: 243,  
    183: 244,  
    184: 245,  
    185: 62,  
    186: 58,  
    187: 246,  
    188: 247,  
    189: 248,  
    190: 249,  
    191: 250,  
    192: 31,  
    193: 32,  
    194: 35,  
    195: 43,  
    196: 37,  
    197: 44,  
    198: 55,  
    199: 47,  
    200: 40,  
    201: 59,  
    202: 33,  
    203: 46,  
    204: 38,  
    205: 36,  
    206: 41,  
    207: 30,  
    208: 39,  
    209: 28,  
    210: 34,  
    211: 51,  
    212: 48,  
    213: 49,  
    214: 53,  
    215: 50,  
    216: 54,  
    217: 57,  
    218: 61,  
    219: 251,  
    220: 67,  
    221: 252,  
    222: 60,  
    223: 56,  
    224: 1,  
    225: 18,  
    226: 9,  
    227: 20,  
    228: 11,  
    229: 3,  
    230: 23,  
    231: 15,  
    232: 2,  
    233: 26,  
    234: 12,  
    235: 10,  
    236: 14,  
    237: 6,  
    238: 4,  
    239: 13,  
    240: 7,  
    241: 8,  
    242: 5,  
    243: 19,  
    244: 29,  
    245: 25,  
    246: 22,  
    247: 21,  
    248: 27,  
    249: 24,  
    250: 17,  
    251: 75,  
    252: 52,  
    253: 253,  
    254: 42,  
    255: 16,  
}

WINDOWS_1251_BULGARIAN_MODEL = SingleByteCharSetModel(
    charset_name="windows-1251",
    language="Bulgarian",
    char_to_order_map=WINDOWS_1251_BULGARIAN_CHAR_TO_ORDER,
    language_model=BULGARIAN_LANG_MODEL,
    typical_positive_ratio=0.969392,
    keep_ascii_letters=False,
    alphabet="АБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЬЮЯабвгдежзийклмнопрстуфхцчшщъьюя",
)
