from pip._vendor.chardet.sbcharsetprober import SingleByteCharSetModel






GREEK_LANG_MODEL = {
    60: {  
        60: 2,  
        55: 1,  
        58: 2,  
        36: 1,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 1,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    55: {  
        60: 0,  
        55: 2,  
        58: 2,  
        36: 1,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 1,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 1,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    58: {  
        60: 2,  
        55: 1,  
        58: 1,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 1,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    36: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    61: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 1,  
        21: 2,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 1,  
        8: 2,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    46: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 2,  
        20: 2,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 2,  
        16: 2,  
        10: 0,  
        6: 3,  
        30: 2,  
        4: 0,  
        9: 2,  
        8: 2,  
        14: 0,  
        7: 1,  
        2: 2,  
        12: 0,  
        28: 2,  
        23: 3,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    54: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 2,  
        10: 2,  
        6: 2,  
        30: 0,  
        4: 0,  
        9: 2,  
        8: 0,  
        14: 0,  
        7: 2,  
        2: 3,  
        12: 0,  
        28: 0,  
        23: 2,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    31: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 2,  
        43: 2,  
        41: 1,  
        34: 0,  
        40: 0,  
        52: 2,  
        47: 2,  
        44: 2,  
        53: 2,  
        38: 2,  
        49: 2,  
        59: 1,  
        39: 0,  
        35: 2,  
        48: 2,  
        37: 2,  
        33: 2,  
        45: 2,  
        56: 2,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 2,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 1,  
        5: 0,  
        11: 2,  
        16: 3,  
        10: 2,  
        6: 3,  
        30: 2,  
        4: 0,  
        9: 3,  
        8: 3,  
        14: 2,  
        7: 2,  
        2: 0,  
        12: 3,  
        28: 2,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 2,  
        27: 0,  
    },
    51: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 1,  
        40: 1,  
        52: 0,  
        47: 1,  
        44: 0,  
        53: 1,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 2,  
        22: 2,  
        15: 0,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 2,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    43: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 1,  
        51: 0,  
        43: 2,  
        41: 0,  
        34: 2,  
        40: 1,  
        52: 0,  
        47: 2,  
        44: 1,  
        53: 1,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 1,  
        35: 0,  
        48: 2,  
        37: 0,  
        33: 0,  
        45: 2,  
        56: 0,  
        50: 1,  
        57: 2,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 2,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 2,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 2,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    41: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 2,  
        17: 0,  
        18: 0,  
        22: 2,  
        15: 2,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 2,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 2,  
        19: 1,  
        26: 2,  
        27: 2,  
    },
    34: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 2,  
        41: 2,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 2,  
        44: 2,  
        53: 2,  
        38: 2,  
        49: 2,  
        59: 1,  
        39: 0,  
        35: 2,  
        48: 2,  
        37: 2,  
        33: 2,  
        45: 2,  
        56: 0,  
        50: 2,  
        57: 2,  
        17: 3,  
        18: 0,  
        22: 0,  
        15: 3,  
        1: 0,  
        29: 0,  
        20: 3,  
        21: 2,  
        3: 1,  
        32: 0,  
        13: 0,  
        25: 1,  
        5: 2,  
        11: 3,  
        16: 3,  
        10: 2,  
        6: 3,  
        30: 2,  
        4: 0,  
        9: 3,  
        8: 2,  
        14: 0,  
        7: 2,  
        2: 2,  
        12: 2,  
        28: 2,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 1,  
        27: 0,  
    },
    40: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 1,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 2,  
        47: 0,  
        44: 2,  
        53: 0,  
        38: 2,  
        49: 2,  
        59: 0,  
        39: 0,  
        35: 2,  
        48: 2,  
        37: 2,  
        33: 2,  
        45: 1,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 1,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 1,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    52: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 1,  
        37: 0,  
        33: 0,  
        45: 1,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 2,  
        22: 0,  
        15: 0,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 2,  
        27: 0,  
    },
    47: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 1,  
        43: 1,  
        41: 2,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 0,  
        44: 2,  
        53: 2,  
        38: 2,  
        49: 2,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 2,  
        37: 2,  
        33: 2,  
        45: 0,  
        56: 2,  
        50: 0,  
        57: 2,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 2,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 1,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 2,  
        2: 1,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 1,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    44: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 1,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 1,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 2,  
        37: 0,  
        33: 1,  
        45: 2,  
        56: 0,  
        50: 0,  
        57: 1,  
        17: 3,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 2,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 2,  
        26: 2,  
        27: 2,  
    },
    53: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 2,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 0,  
        37: 2,  
        33: 0,  
        45: 2,  
        56: 0,  
        50: 0,  
        57: 2,  
        17: 2,  
        18: 2,  
        22: 0,  
        15: 2,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 1,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 2,  
        26: 2,  
        27: 0,  
    },
    38: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 2,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 0,  
        38: 2,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 2,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 2,  
        22: 2,  
        15: 2,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 3,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 2,  
        26: 0,  
        27: 0,  
    },
    49: {  
        60: 2,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 2,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 2,  
        17: 0,  
        18: 2,  
        22: 0,  
        15: 2,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 1,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 1,  
        19: 2,  
        26: 0,  
        27: 0,  
    },
    59: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 1,  
        40: 1,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 1,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 2,  
        22: 0,  
        15: 0,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    39: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 1,  
        43: 2,  
        41: 2,  
        34: 2,  
        40: 1,  
        52: 2,  
        47: 2,  
        44: 2,  
        53: 2,  
        38: 2,  
        49: 2,  
        59: 0,  
        39: 0,  
        35: 2,  
        48: 2,  
        37: 2,  
        33: 2,  
        45: 2,  
        56: 2,  
        50: 2,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 2,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 3,  
        11: 2,  
        16: 2,  
        10: 2,  
        6: 2,  
        30: 0,  
        4: 0,  
        9: 2,  
        8: 2,  
        14: 0,  
        7: 0,  
        2: 2,  
        12: 2,  
        28: 1,  
        23: 1,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 2,  
        27: 0,  
    },
    35: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 0,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 2,  
        38: 1,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 2,  
        37: 0,  
        33: 1,  
        45: 0,  
        56: 0,  
        50: 1,  
        57: 2,  
        17: 2,  
        18: 1,  
        22: 1,  
        15: 2,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 2,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 2,  
        42: 0,  
        24: 2,  
        19: 2,  
        26: 0,  
        27: 3,  
    },
    48: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 1,  
        41: 1,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 2,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 2,  
        37: 0,  
        33: 1,  
        45: 1,  
        56: 0,  
        50: 1,  
        57: 1,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 2,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 1,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 3,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 2,  
        19: 0,  
        26: 2,  
        27: 0,  
    },
    37: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 1,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 2,  
        53: 0,  
        38: 2,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 0,  
        37: 2,  
        33: 2,  
        45: 2,  
        56: 0,  
        50: 2,  
        57: 2,  
        17: 0,  
        18: 0,  
        22: 2,  
        15: 2,  
        1: 2,  
        29: 2,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 2,  
        11: 2,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 2,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 3,  
        12: 3,  
        28: 0,  
        23: 2,  
        42: 0,  
        24: 2,  
        19: 0,  
        26: 2,  
        27: 2,  
    },
    33: {  
        60: 0,  
        55: 1,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 2,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 2,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 2,  
        37: 0,  
        33: 1,  
        45: 1,  
        56: 0,  
        50: 0,  
        57: 2,  
        17: 2,  
        18: 2,  
        22: 0,  
        15: 2,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 2,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 0,  
        10: 2,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 2,  
        14: 0,  
        7: 2,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 2,  
        26: 2,  
        27: 3,  
    },
    45: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 2,  
        41: 0,  
        34: 1,  
        40: 2,  
        52: 2,  
        47: 0,  
        44: 0,  
        53: 1,  
        38: 2,  
        49: 2,  
        59: 0,  
        39: 0,  
        35: 2,  
        48: 1,  
        37: 2,  
        33: 2,  
        45: 0,  
        56: 0,  
        50: 1,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 3,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    56: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 1,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 1,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 2,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 2,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 1,  
        27: 1,  
    },
    50: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 1,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 2,  
        40: 2,  
        52: 0,  
        47: 2,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 1,  
        59: 0,  
        39: 1,  
        35: 0,  
        48: 2,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 1,  
        57: 1,  
        17: 2,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 2,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 2,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 2,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    57: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 1,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 1,  
        38: 0,  
        49: 2,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 2,  
        37: 2,  
        33: 2,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 2,  
        14: 2,  
        7: 2,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 1,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    17: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 3,  
        20: 3,  
        21: 3,  
        3: 3,  
        32: 3,  
        13: 0,  
        25: 3,  
        5: 2,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 0,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 3,  
        23: 3,  
        42: 3,  
        24: 2,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    18: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 3,  
        29: 2,  
        20: 3,  
        21: 2,  
        3: 3,  
        32: 2,  
        13: 0,  
        25: 3,  
        5: 0,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 3,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 3,  
        23: 3,  
        42: 3,  
        24: 2,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    22: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 1,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 3,  
        21: 3,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 3,  
        5: 0,  
        11: 3,  
        16: 2,  
        10: 3,  
        6: 3,  
        30: 2,  
        4: 0,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 3,  
        42: 2,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    15: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 3,  
        29: 2,  
        20: 3,  
        21: 3,  
        3: 3,  
        32: 3,  
        13: 3,  
        25: 3,  
        5: 0,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 3,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 1,  
        23: 3,  
        42: 2,  
        24: 3,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    1: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 2,  
        22: 0,  
        15: 3,  
        1: 0,  
        29: 3,  
        20: 3,  
        21: 3,  
        3: 2,  
        32: 3,  
        13: 1,  
        25: 3,  
        5: 3,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 2,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 3,  
        28: 3,  
        23: 3,  
        42: 2,  
        24: 0,  
        19: 2,  
        26: 2,  
        27: 0,  
    },
    29: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 2,  
        22: 3,  
        15: 2,  
        1: 3,  
        29: 0,  
        20: 2,  
        21: 2,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 3,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 2,  
        19: 2,  
        26: 2,  
        27: 2,  
    },
    20: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 3,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 3,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 0,  
        23: 3,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 2,  
        27: 3,  
    },
    21: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 3,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    3: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 0,  
        22: 0,  
        15: 3,  
        1: 2,  
        29: 3,  
        20: 3,  
        21: 3,  
        3: 2,  
        32: 2,  
        13: 0,  
        25: 3,  
        5: 3,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 2,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 3,  
        28: 3,  
        23: 3,  
        42: 2,  
        24: 3,  
        19: 2,  
        26: 3,  
        27: 2,  
    },
    32: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 2,  
        22: 2,  
        15: 2,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 1,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 2,  
        26: 0,  
        27: 2,  
    },
    13: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 3,  
        21: 2,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 3,  
        5: 0,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 2,  
        4: 0,  
        9: 2,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 3,  
        42: 2,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    25: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 3,  
        22: 3,  
        15: 2,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 1,  
        10: 3,  
        6: 2,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 3,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    5: {  
        60: 0,  
        55: 1,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 1,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 0,  
        1: 3,  
        29: 3,  
        20: 3,  
        21: 3,  
        3: 3,  
        32: 2,  
        13: 3,  
        25: 3,  
        5: 0,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 3,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 3,  
        42: 2,  
        24: 3,  
        19: 3,  
        26: 0,  
        27: 3,  
    },
    11: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 3,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 2,  
        5: 3,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 2,  
        30: 0,  
        4: 3,  
        9: 2,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 3,  
        12: 3,  
        28: 2,  
        23: 2,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    16: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 1,  
        20: 2,  
        21: 1,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 2,  
        5: 3,  
        11: 2,  
        16: 3,  
        10: 2,  
        6: 2,  
        30: 0,  
        4: 3,  
        9: 3,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 3,  
        12: 3,  
        28: 2,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    10: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 1,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 3,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 0,  
        10: 3,  
        6: 3,  
        30: 0,  
        4: 3,  
        9: 3,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 2,  
        28: 3,  
        23: 0,  
        42: 2,  
        24: 3,  
        19: 3,  
        26: 2,  
        27: 2,  
    },
    6: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 3,  
        3: 3,  
        32: 2,  
        13: 3,  
        25: 3,  
        5: 3,  
        11: 0,  
        16: 1,  
        10: 0,  
        6: 2,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 3,  
        2: 3,  
        12: 3,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    30: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 3,  
        22: 3,  
        15: 2,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 3,  
        12: 2,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 2,  
        26: 3,  
        27: 1,  
    },
    4: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 2,  
        22: 3,  
        15: 3,  
        1: 2,  
        29: 3,  
        20: 3,  
        21: 3,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 3,  
        5: 3,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 2,  
        4: 2,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 3,  
        28: 3,  
        23: 3,  
        42: 2,  
        24: 2,  
        19: 1,  
        26: 3,  
        27: 2,  
    },
    9: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 3,  
        11: 0,  
        16: 3,  
        10: 0,  
        6: 2,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 2,  
        7: 0,  
        2: 3,  
        12: 3,  
        28: 0,  
        23: 2,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 2,  
        27: 3,  
    },
    8: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 2,  
        20: 3,  
        21: 2,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 3,  
        5: 3,  
        11: 3,  
        16: 1,  
        10: 3,  
        6: 3,  
        30: 2,  
        4: 3,  
        9: 2,  
        8: 2,  
        14: 0,  
        7: 2,  
        2: 3,  
        12: 3,  
        28: 3,  
        23: 3,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    14: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 2,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 0,  
        5: 0,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 0,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 0,  
        12: 0,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    7: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 2,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 3,  
        20: 0,  
        21: 2,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 3,  
        5: 3,  
        11: 3,  
        16: 2,  
        10: 3,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 3,  
        8: 0,  
        14: 0,  
        7: 3,  
        2: 3,  
        12: 3,  
        28: 3,  
        23: 3,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 2,  
    },
    2: {  
        60: 0,  
        55: 2,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 2,  
        13: 3,  
        25: 0,  
        5: 3,  
        11: 2,  
        16: 2,  
        10: 3,  
        6: 0,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 3,  
        2: 3,  
        12: 3,  
        28: 2,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    12: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 2,  
        22: 3,  
        15: 2,  
        1: 3,  
        29: 2,  
        20: 3,  
        21: 2,  
        3: 2,  
        32: 2,  
        13: 2,  
        25: 3,  
        5: 2,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 3,  
        4: 3,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 3,  
        42: 2,  
        24: 2,  
        19: 2,  
        26: 0,  
        27: 2,  
    },
    28: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 3,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 2,  
        5: 3,  
        11: 0,  
        16: 2,  
        10: 0,  
        6: 1,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 3,  
        12: 3,  
        28: 1,  
        23: 0,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 2,  
        27: 2,  
    },
    23: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 3,  
        18: 2,  
        22: 3,  
        15: 3,  
        1: 3,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 2,  
        5: 3,  
        11: 0,  
        16: 2,  
        10: 2,  
        6: 3,  
        30: 0,  
        4: 3,  
        9: 0,  
        8: 3,  
        14: 0,  
        7: 0,  
        2: 3,  
        12: 3,  
        28: 0,  
        23: 2,  
        42: 0,  
        24: 3,  
        19: 3,  
        26: 3,  
        27: 3,  
    },
    42: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 2,  
        18: 2,  
        22: 1,  
        15: 2,  
        1: 2,  
        29: 0,  
        20: 0,  
        21: 0,  
        3: 3,  
        32: 0,  
        13: 3,  
        25: 0,  
        5: 2,  
        11: 0,  
        16: 0,  
        10: 0,  
        6: 0,  
        30: 0,  
        4: 2,  
        9: 0,  
        8: 0,  
        14: 0,  
        7: 0,  
        2: 2,  
        12: 1,  
        28: 0,  
        23: 0,  
        42: 0,  
        24: 2,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    24: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 1,  
        18: 0,  
        22: 2,  
        15: 0,  
        1: 0,  
        29: 2,  
        20: 3,  
        21: 2,  
        3: 0,  
        32: 0,  
        13: 0,  
        25: 3,  
        5: 2,  
        11: 0,  
        16: 2,  
        10: 3,  
        6: 3,  
        30: 0,  
        4: 0,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 2,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    19: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 3,  
        20: 3,  
        21: 3,  
        3: 1,  
        32: 2,  
        13: 2,  
        25: 2,  
        5: 2,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 1,  
        4: 2,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 3,  
        42: 2,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    26: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 2,  
        29: 2,  
        20: 2,  
        21: 1,  
        3: 3,  
        32: 0,  
        13: 2,  
        25: 3,  
        5: 0,  
        11: 3,  
        16: 3,  
        10: 3,  
        6: 3,  
        30: 2,  
        4: 3,  
        9: 3,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 2,  
        23: 2,  
        42: 2,  
        24: 2,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
    27: {  
        60: 0,  
        55: 0,  
        58: 0,  
        36: 0,  
        61: 0,  
        46: 0,  
        54: 0,  
        31: 0,  
        51: 0,  
        43: 0,  
        41: 0,  
        34: 0,  
        40: 0,  
        52: 0,  
        47: 0,  
        44: 0,  
        53: 0,  
        38: 0,  
        49: 0,  
        59: 0,  
        39: 0,  
        35: 0,  
        48: 0,  
        37: 0,  
        33: 0,  
        45: 0,  
        56: 0,  
        50: 0,  
        57: 0,  
        17: 0,  
        18: 0,  
        22: 0,  
        15: 0,  
        1: 0,  
        29: 1,  
        20: 0,  
        21: 3,  
        3: 0,  
        32: 0,  
        13: 1,  
        25: 2,  
        5: 2,  
        11: 0,  
        16: 2,  
        10: 3,  
        6: 3,  
        30: 1,  
        4: 0,  
        9: 2,  
        8: 3,  
        14: 3,  
        7: 3,  
        2: 3,  
        12: 0,  
        28: 1,  
        23: 1,  
        42: 0,  
        24: 0,  
        19: 0,  
        26: 0,  
        27: 0,  
    },
}








WINDOWS_1253_GREEK_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 82,  
    66: 100,  
    67: 104,  
    68: 94,  
    69: 98,  
    70: 101,  
    71: 116,  
    72: 102,  
    73: 111,  
    74: 187,  
    75: 117,  
    76: 92,  
    77: 88,  
    78: 113,  
    79: 85,  
    80: 79,  
    81: 118,  
    82: 105,  
    83: 83,  
    84: 67,  
    85: 114,  
    86: 119,  
    87: 95,  
    88: 99,  
    89: 109,  
    90: 188,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 72,  
    98: 70,  
    99: 80,  
    100: 81,  
    101: 60,  
    102: 96,  
    103: 93,  
    104: 89,  
    105: 68,  
    106: 120,  
    107: 97,  
    108: 77,  
    109: 86,  
    110: 69,  
    111: 55,  
    112: 78,  
    113: 115,  
    114: 65,  
    115: 66,  
    116: 58,  
    117: 76,  
    118: 106,  
    119: 103,  
    120: 87,  
    121: 107,  
    122: 112,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 255,  
    129: 255,  
    130: 255,  
    131: 255,  
    132: 255,  
    133: 255,  
    134: 255,  
    135: 255,  
    136: 255,  
    137: 255,  
    138: 255,  
    139: 255,  
    140: 255,  
    141: 255,  
    142: 255,  
    143: 255,  
    144: 255,  
    145: 255,  
    146: 255,  
    147: 255,  
    148: 255,  
    149: 255,  
    150: 255,  
    151: 255,  
    152: 255,  
    153: 255,  
    154: 255,  
    155: 255,  
    156: 255,  
    157: 255,  
    158: 255,  
    159: 255,  
    160: 253,  
    161: 233,  
    162: 61,  
    163: 253,  
    164: 253,  
    165: 253,  
    166: 253,  
    167: 253,  
    168: 253,  
    169: 253,  
    170: 253,  
    171: 253,  
    172: 253,  
    173: 74,  
    174: 253,  
    175: 253,  
    176: 253,  
    177: 253,  
    178: 253,  
    179: 253,  
    180: 247,  
    181: 253,  
    182: 253,  
    183: 36,  
    184: 46,  
    185: 71,  
    186: 73,  
    187: 253,  
    188: 54,  
    189: 253,  
    190: 108,  
    191: 123,  
    192: 110,  
    193: 31,  
    194: 51,  
    195: 43,  
    196: 41,  
    197: 34,  
    198: 91,  
    199: 40,  
    200: 52,  
    201: 47,  
    202: 44,  
    203: 53,  
    204: 38,  
    205: 49,  
    206: 59,  
    207: 39,  
    208: 35,  
    209: 48,  
    210: 250,  
    211: 37,  
    212: 33,  
    213: 45,  
    214: 56,  
    215: 50,  
    216: 84,  
    217: 57,  
    218: 120,  
    219: 121,  
    220: 17,  
    221: 18,  
    222: 22,  
    223: 15,  
    224: 124,  
    225: 1,  
    226: 29,  
    227: 20,  
    228: 21,  
    229: 3,  
    230: 32,  
    231: 13,  
    232: 25,  
    233: 5,  
    234: 11,  
    235: 16,  
    236: 10,  
    237: 6,  
    238: 30,  
    239: 4,  
    240: 9,  
    241: 8,  
    242: 14,  
    243: 7,  
    244: 2,  
    245: 12,  
    246: 28,  
    247: 23,  
    248: 42,  
    249: 24,  
    250: 64,  
    251: 75,  
    252: 19,  
    253: 26,  
    254: 27,  
    255: 253,  
}

WINDOWS_1253_GREEK_MODEL = SingleByteCharSetModel(
    charset_name="windows-1253",
    language="Greek",
    char_to_order_map=WINDOWS_1253_GREEK_CHAR_TO_ORDER,
    language_model=GREEK_LANG_MODEL,
    typical_positive_ratio=0.982851,
    keep_ascii_letters=False,
    alphabet="ΆΈΉΊΌΎΏΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩάέήίαβγδεζηθικλμνξοπρςστυφχψωόύώ",
)

ISO_8859_7_GREEK_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 82,  
    66: 100,  
    67: 104,  
    68: 94,  
    69: 98,  
    70: 101,  
    71: 116,  
    72: 102,  
    73: 111,  
    74: 187,  
    75: 117,  
    76: 92,  
    77: 88,  
    78: 113,  
    79: 85,  
    80: 79,  
    81: 118,  
    82: 105,  
    83: 83,  
    84: 67,  
    85: 114,  
    86: 119,  
    87: 95,  
    88: 99,  
    89: 109,  
    90: 188,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 72,  
    98: 70,  
    99: 80,  
    100: 81,  
    101: 60,  
    102: 96,  
    103: 93,  
    104: 89,  
    105: 68,  
    106: 120,  
    107: 97,  
    108: 77,  
    109: 86,  
    110: 69,  
    111: 55,  
    112: 78,  
    113: 115,  
    114: 65,  
    115: 66,  
    116: 58,  
    117: 76,  
    118: 106,  
    119: 103,  
    120: 87,  
    121: 107,  
    122: 112,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 255,  
    129: 255,  
    130: 255,  
    131: 255,  
    132: 255,  
    133: 255,  
    134: 255,  
    135: 255,  
    136: 255,  
    137: 255,  
    138: 255,  
    139: 255,  
    140: 255,  
    141: 255,  
    142: 255,  
    143: 255,  
    144: 255,  
    145: 255,  
    146: 255,  
    147: 255,  
    148: 255,  
    149: 255,  
    150: 255,  
    151: 255,  
    152: 255,  
    153: 255,  
    154: 255,  
    155: 255,  
    156: 255,  
    157: 255,  
    158: 255,  
    159: 255,  
    160: 253,  
    161: 233,  
    162: 90,  
    163: 253,  
    164: 253,  
    165: 253,  
    166: 253,  
    167: 253,  
    168: 253,  
    169: 253,  
    170: 253,  
    171: 253,  
    172: 253,  
    173: 74,  
    174: 253,  
    175: 253,  
    176: 253,  
    177: 253,  
    178: 253,  
    179: 253,  
    180: 247,  
    181: 248,  
    182: 61,  
    183: 36,  
    184: 46,  
    185: 71,  
    186: 73,  
    187: 253,  
    188: 54,  
    189: 253,  
    190: 108,  
    191: 123,  
    192: 110,  
    193: 31,  
    194: 51,  
    195: 43,  
    196: 41,  
    197: 34,  
    198: 91,  
    199: 40,  
    200: 52,  
    201: 47,  
    202: 44,  
    203: 53,  
    204: 38,  
    205: 49,  
    206: 59,  
    207: 39,  
    208: 35,  
    209: 48,  
    210: 250,  
    211: 37,  
    212: 33,  
    213: 45,  
    214: 56,  
    215: 50,  
    216: 84,  
    217: 57,  
    218: 120,  
    219: 121,  
    220: 17,  
    221: 18,  
    222: 22,  
    223: 15,  
    224: 124,  
    225: 1,  
    226: 29,  
    227: 20,  
    228: 21,  
    229: 3,  
    230: 32,  
    231: 13,  
    232: 25,  
    233: 5,  
    234: 11,  
    235: 16,  
    236: 10,  
    237: 6,  
    238: 30,  
    239: 4,  
    240: 9,  
    241: 8,  
    242: 14,  
    243: 7,  
    244: 2,  
    245: 12,  
    246: 28,  
    247: 23,  
    248: 42,  
    249: 24,  
    250: 64,  
    251: 75,  
    252: 19,  
    253: 26,  
    254: 27,  
    255: 253,  
}

ISO_8859_7_GREEK_MODEL = SingleByteCharSetModel(
    charset_name="ISO-8859-7",
    language="Greek",
    char_to_order_map=ISO_8859_7_GREEK_CHAR_TO_ORDER,
    language_model=GREEK_LANG_MODEL,
    typical_positive_ratio=0.982851,
    keep_ascii_letters=False,
    alphabet="ΆΈΉΊΌΎΏΑΒΓΔΕΖΗΘΙΚΛΜΝΞΟΠΡΣΤΥΦΧΨΩάέήίαβγδεζηθικλμνξοπρςστυφχψωόύώ",
)
