from pip._vendor.chardet.sbcharsetprober import SingleByteCharSetModel






HEBREW_LANG_MODEL = {
    50: {  
        50: 0,  
        60: 1,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 2,  
        54: 2,  
        49: 0,  
        51: 2,  
        43: 1,  
        44: 2,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 1,  
        7: 0,  
        10: 1,  
        5: 0,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    60: {  
        50: 1,  
        60: 1,  
        61: 0,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 0,  
        49: 1,  
        51: 1,  
        43: 1,  
        44: 2,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 1,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    61: {  
        50: 1,  
        60: 0,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 1,  
        49: 2,  
        51: 1,  
        43: 1,  
        44: 0,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 1,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    42: {  
        50: 1,  
        60: 1,  
        61: 2,  
        42: 1,  
        53: 1,  
        56: 2,  
        54: 2,  
        49: 1,  
        51: 2,  
        43: 2,  
        44: 2,  
        63: 1,  
        34: 1,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 1,  
        52: 2,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    53: {  
        50: 1,  
        60: 2,  
        61: 1,  
        42: 1,  
        53: 0,  
        56: 1,  
        54: 2,  
        49: 2,  
        51: 1,  
        43: 2,  
        44: 2,  
        63: 1,  
        34: 0,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    56: {  
        50: 1,  
        60: 1,  
        61: 1,  
        42: 2,  
        53: 2,  
        56: 2,  
        54: 1,  
        49: 1,  
        51: 0,  
        43: 1,  
        44: 1,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    54: {  
        50: 1,  
        60: 1,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 1,  
        49: 1,  
        51: 0,  
        43: 1,  
        44: 2,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 2,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    49: {  
        50: 1,  
        60: 1,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 2,  
        49: 1,  
        51: 2,  
        43: 1,  
        44: 1,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    51: {  
        50: 2,  
        60: 1,  
        61: 1,  
        42: 2,  
        53: 1,  
        56: 1,  
        54: 1,  
        49: 2,  
        51: 1,  
        43: 1,  
        44: 1,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 2,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    43: {  
        50: 1,  
        60: 1,  
        61: 0,  
        42: 2,  
        53: 1,  
        56: 1,  
        54: 1,  
        49: 1,  
        51: 1,  
        43: 1,  
        44: 2,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 2,  
        58: 0,  
        40: 2,  
    },
    44: {  
        50: 1,  
        60: 1,  
        61: 0,  
        42: 2,  
        53: 2,  
        56: 1,  
        54: 0,  
        49: 1,  
        51: 1,  
        43: 1,  
        44: 1,  
        63: 1,  
        34: 1,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 2,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    63: {  
        50: 1,  
        60: 1,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 1,  
        49: 0,  
        51: 1,  
        43: 2,  
        44: 1,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    34: {  
        50: 1,  
        60: 0,  
        61: 1,  
        42: 0,  
        53: 1,  
        56: 0,  
        54: 1,  
        49: 1,  
        51: 0,  
        43: 1,  
        44: 1,  
        63: 0,  
        34: 2,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 1,  
        20: 1,  
        16: 1,  
        3: 1,  
        2: 1,  
        24: 1,  
        14: 1,  
        22: 1,  
        1: 2,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 2,  
        23: 0,  
        12: 1,  
        19: 1,  
        13: 1,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 1,  
        17: 1,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    55: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 1,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 1,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 2,  
        25: 0,  
        15: 0,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 1,  
        12: 1,  
        19: 1,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 1,  
        10: 1,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    48: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 1,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    39: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 1,  
        17: 1,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    57: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    30: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 1,  
        31: 0,  
        29: 0,  
        35: 1,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 2,  
        20: 2,  
        16: 2,  
        3: 2,  
        2: 2,  
        24: 2,  
        14: 2,  
        22: 2,  
        1: 2,  
        25: 2,  
        15: 2,  
        4: 2,  
        11: 1,  
        6: 2,  
        23: 0,  
        12: 2,  
        19: 2,  
        13: 2,  
        26: 0,  
        18: 2,  
        27: 0,  
        21: 2,  
        17: 2,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    59: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 1,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 1,  
        20: 1,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 1,  
        14: 0,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 2,  
        11: 0,  
        6: 2,  
        23: 0,  
        12: 1,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 1,  
        10: 1,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    41: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 2,  
        20: 1,  
        16: 2,  
        3: 1,  
        2: 1,  
        24: 1,  
        14: 1,  
        22: 1,  
        1: 1,  
        25: 1,  
        15: 1,  
        4: 2,  
        11: 0,  
        6: 2,  
        23: 0,  
        12: 2,  
        19: 1,  
        13: 0,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 2,  
        17: 1,  
        7: 2,  
        10: 2,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    33: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 1,  
        59: 0,  
        41: 0,  
        33: 1,  
        37: 0,  
        36: 1,  
        31: 0,  
        29: 1,  
        35: 0,  
        62: 0,  
        28: 1,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 2,  
        20: 2,  
        16: 2,  
        3: 1,  
        2: 1,  
        24: 2,  
        14: 1,  
        22: 1,  
        1: 3,  
        25: 1,  
        15: 2,  
        4: 2,  
        11: 2,  
        6: 2,  
        23: 2,  
        12: 2,  
        19: 2,  
        13: 1,  
        26: 0,  
        18: 2,  
        27: 1,  
        21: 2,  
        17: 2,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    37: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 1,  
        31: 1,  
        29: 1,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 2,  
        20: 1,  
        16: 2,  
        3: 2,  
        2: 1,  
        24: 1,  
        14: 2,  
        22: 1,  
        1: 3,  
        25: 2,  
        15: 1,  
        4: 2,  
        11: 2,  
        6: 1,  
        23: 2,  
        12: 2,  
        19: 1,  
        13: 2,  
        26: 1,  
        18: 1,  
        27: 1,  
        21: 1,  
        17: 1,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    36: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 1,  
        31: 1,  
        29: 1,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 2,  
        20: 1,  
        16: 2,  
        3: 2,  
        2: 1,  
        24: 1,  
        14: 2,  
        22: 1,  
        1: 2,  
        25: 2,  
        15: 1,  
        4: 2,  
        11: 2,  
        6: 2,  
        23: 2,  
        12: 2,  
        19: 2,  
        13: 1,  
        26: 1,  
        18: 1,  
        27: 2,  
        21: 1,  
        17: 1,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    31: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 1,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 1,  
        31: 0,  
        29: 2,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 2,  
        20: 2,  
        16: 2,  
        3: 2,  
        2: 1,  
        24: 2,  
        14: 2,  
        22: 2,  
        1: 3,  
        25: 1,  
        15: 2,  
        4: 2,  
        11: 2,  
        6: 2,  
        23: 2,  
        12: 2,  
        19: 2,  
        13: 2,  
        26: 2,  
        18: 2,  
        27: 1,  
        21: 2,  
        17: 2,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    29: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 1,  
        29: 2,  
        35: 0,  
        62: 0,  
        28: 1,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 2,  
        20: 2,  
        16: 2,  
        3: 3,  
        2: 2,  
        24: 2,  
        14: 2,  
        22: 1,  
        1: 2,  
        25: 2,  
        15: 2,  
        4: 2,  
        11: 2,  
        6: 2,  
        23: 2,  
        12: 2,  
        19: 1,  
        13: 2,  
        26: 1,  
        18: 2,  
        27: 1,  
        21: 2,  
        17: 2,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    35: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 1,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 2,  
        20: 1,  
        16: 2,  
        3: 2,  
        2: 1,  
        24: 1,  
        14: 1,  
        22: 1,  
        1: 1,  
        25: 1,  
        15: 2,  
        4: 2,  
        11: 2,  
        6: 2,  
        23: 2,  
        12: 2,  
        19: 2,  
        13: 2,  
        26: 1,  
        18: 2,  
        27: 1,  
        21: 2,  
        17: 2,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    62: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 1,  
        20: 1,  
        16: 1,  
        3: 1,  
        2: 1,  
        24: 1,  
        14: 1,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 2,  
        11: 1,  
        6: 1,  
        23: 1,  
        12: 1,  
        19: 1,  
        13: 1,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 1,  
        17: 1,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    28: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 3,  
        59: 0,  
        41: 1,  
        33: 3,  
        37: 2,  
        36: 2,  
        31: 3,  
        29: 3,  
        35: 2,  
        62: 1,  
        28: 0,  
        38: 2,  
        45: 1,  
        9: 2,  
        8: 2,  
        20: 1,  
        16: 2,  
        3: 1,  
        2: 2,  
        24: 1,  
        14: 1,  
        22: 1,  
        1: 2,  
        25: 2,  
        15: 2,  
        4: 2,  
        11: 1,  
        6: 2,  
        23: 1,  
        12: 2,  
        19: 1,  
        13: 2,  
        26: 1,  
        18: 1,  
        27: 1,  
        21: 1,  
        17: 1,  
        7: 2,  
        10: 2,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    38: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 2,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 1,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    45: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 1,  
        36: 2,  
        31: 1,  
        29: 2,  
        35: 1,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 1,  
        16: 0,  
        3: 1,  
        2: 2,  
        24: 0,  
        14: 1,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 1,  
        6: 1,  
        23: 0,  
        12: 1,  
        19: 0,  
        13: 1,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 1,  
        10: 0,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    9: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 2,  
        41: 2,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 2,  
        26: 3,  
        18: 3,  
        27: 1,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    8: {  
        50: 0,  
        60: 0,  
        61: 1,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 3,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 2,  
        15: 3,  
        4: 3,  
        11: 2,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 1,  
        18: 3,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 1,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    20: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 2,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 1,  
        37: 1,  
        36: 1,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 0,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 3,  
        20: 2,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 2,  
        22: 2,  
        1: 3,  
        25: 1,  
        15: 1,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 2,  
        13: 3,  
        26: 2,  
        18: 2,  
        27: 1,  
        21: 1,  
        17: 1,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 0,  
    },
    16: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 1,  
        14: 2,  
        22: 2,  
        1: 3,  
        25: 2,  
        15: 2,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 2,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 0,  
        21: 2,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    3: {  
        50: 0,  
        60: 0,  
        61: 1,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 0,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 1,  
        59: 1,  
        41: 2,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 3,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 1,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 0,  
        18: 3,  
        27: 1,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 1,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
    2: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 1,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 1,  
        36: 1,  
        31: 2,  
        29: 2,  
        35: 3,  
        62: 0,  
        28: 3,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 3,  
        18: 3,  
        27: 3,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 1,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
    24: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 1,  
        33: 1,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 2,  
        20: 2,  
        16: 2,  
        3: 3,  
        2: 3,  
        24: 2,  
        14: 2,  
        22: 1,  
        1: 3,  
        25: 1,  
        15: 3,  
        4: 3,  
        11: 2,  
        6: 3,  
        23: 2,  
        12: 2,  
        19: 1,  
        13: 2,  
        26: 1,  
        18: 1,  
        27: 0,  
        21: 2,  
        17: 3,  
        7: 3,  
        10: 1,  
        5: 2,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 1,  
    },
    14: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 1,  
        41: 2,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 3,  
        20: 2,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 2,  
        22: 2,  
        1: 3,  
        25: 1,  
        15: 2,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 3,  
        13: 1,  
        26: 2,  
        18: 2,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    22: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 1,  
        36: 1,  
        31: 2,  
        29: 1,  
        35: 1,  
        62: 1,  
        28: 1,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 1,  
        3: 3,  
        2: 3,  
        24: 2,  
        14: 3,  
        22: 2,  
        1: 3,  
        25: 1,  
        15: 2,  
        4: 3,  
        11: 2,  
        6: 2,  
        23: 2,  
        12: 3,  
        19: 2,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 1,  
        21: 2,  
        17: 2,  
        7: 3,  
        10: 2,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 1,  
    },
    1: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 1,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 3,  
        18: 3,  
        27: 3,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 1,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
    25: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 2,  
        35: 0,  
        62: 0,  
        28: 1,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 0,  
        24: 0,  
        14: 1,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 1,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 1,  
    },
    15: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 3,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 2,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 2,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 2,  
        26: 3,  
        18: 3,  
        27: 1,  
        21: 2,  
        17: 2,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    4: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 3,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 1,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    11: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 1,  
        20: 1,  
        16: 0,  
        3: 1,  
        2: 1,  
        24: 1,  
        14: 1,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 1,  
        6: 1,  
        23: 0,  
        12: 1,  
        19: 0,  
        13: 1,  
        26: 0,  
        18: 1,  
        27: 1,  
        21: 1,  
        17: 1,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
    6: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 2,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 0,  
        18: 3,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 1,  
    },
    23: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 0,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 1,  
        20: 1,  
        16: 1,  
        3: 1,  
        2: 1,  
        24: 0,  
        14: 1,  
        22: 1,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 1,  
        6: 1,  
        23: 0,  
        12: 1,  
        19: 1,  
        13: 1,  
        26: 1,  
        18: 1,  
        27: 0,  
        21: 0,  
        17: 1,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 1,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
    12: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 2,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    19: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 1,  
        36: 2,  
        31: 2,  
        29: 1,  
        35: 1,  
        62: 2,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 1,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 2,  
        15: 3,  
        4: 3,  
        11: 2,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 2,  
        13: 3,  
        26: 3,  
        18: 3,  
        27: 0,  
        21: 2,  
        17: 3,  
        7: 3,  
        10: 1,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    13: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 1,  
        59: 1,  
        41: 2,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 1,  
        22: 3,  
        1: 3,  
        25: 2,  
        15: 2,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 3,  
        13: 2,  
        26: 1,  
        18: 2,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    26: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 1,  
        24: 0,  
        14: 1,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 1,  
        13: 0,  
        26: 1,  
        18: 1,  
        27: 0,  
        21: 0,  
        17: 1,  
        7: 1,  
        10: 1,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 1,  
    },
    18: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 1,  
        36: 2,  
        31: 1,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 2,  
        20: 3,  
        16: 2,  
        3: 3,  
        2: 3,  
        24: 2,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 2,  
        15: 3,  
        4: 3,  
        11: 2,  
        6: 2,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 2,  
        18: 2,  
        27: 2,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 0,  
    },
    27: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 1,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 1,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 1,  
        10: 0,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 1,  
    },
    21: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 1,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 2,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 1,  
        14: 3,  
        22: 2,  
        1: 3,  
        25: 1,  
        15: 1,  
        4: 3,  
        11: 2,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 1,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 2,  
        21: 2,  
        17: 3,  
        7: 3,  
        10: 0,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    17: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 1,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 1,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 2,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 2,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 1,  
        15: 1,  
        4: 3,  
        11: 2,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 2,  
        21: 3,  
        17: 2,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 1,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    7: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 2,  
        48: 1,  
        39: 0,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 1,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 2,  
        62: 1,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 3,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 3,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 3,  
        21: 3,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
    10: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 1,  
        59: 0,  
        41: 0,  
        33: 1,  
        37: 1,  
        36: 1,  
        31: 1,  
        29: 1,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 3,  
        45: 2,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 3,  
        3: 3,  
        2: 3,  
        24: 2,  
        14: 3,  
        22: 3,  
        1: 3,  
        25: 3,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 2,  
        12: 3,  
        19: 2,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 1,  
        21: 2,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 1,  
    },
    5: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 1,  
        55: 0,  
        48: 1,  
        39: 1,  
        57: 0,  
        30: 2,  
        59: 0,  
        41: 0,  
        33: 2,  
        37: 2,  
        36: 2,  
        31: 2,  
        29: 2,  
        35: 1,  
        62: 1,  
        28: 2,  
        38: 0,  
        45: 0,  
        9: 3,  
        8: 3,  
        20: 3,  
        16: 2,  
        3: 3,  
        2: 3,  
        24: 2,  
        14: 3,  
        22: 2,  
        1: 3,  
        25: 2,  
        15: 3,  
        4: 3,  
        11: 3,  
        6: 3,  
        23: 3,  
        12: 3,  
        19: 2,  
        13: 3,  
        26: 2,  
        18: 3,  
        27: 1,  
        21: 2,  
        17: 3,  
        7: 3,  
        10: 3,  
        5: 3,  
        32: 1,  
        52: 1,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 2,  
    },
    32: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 1,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 1,  
        20: 1,  
        16: 1,  
        3: 1,  
        2: 1,  
        24: 0,  
        14: 1,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 1,  
        13: 1,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 1,  
        17: 0,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    52: {  
        50: 1,  
        60: 0,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 0,  
        49: 0,  
        51: 1,  
        43: 2,  
        44: 2,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 1,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    47: {  
        50: 1,  
        60: 1,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 1,  
        54: 1,  
        49: 1,  
        51: 1,  
        43: 1,  
        44: 1,  
        63: 1,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 2,  
        8: 1,  
        20: 1,  
        16: 1,  
        3: 1,  
        2: 1,  
        24: 1,  
        14: 1,  
        22: 1,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 1,  
        19: 1,  
        13: 1,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 1,  
        17: 1,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    46: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 1,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 1,  
        20: 1,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 1,  
        17: 0,  
        7: 1,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 0,  
        40: 0,  
    },
    58: {  
        50: 0,  
        60: 0,  
        61: 0,  
        42: 0,  
        53: 0,  
        56: 0,  
        54: 0,  
        49: 0,  
        51: 0,  
        43: 0,  
        44: 0,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 0,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 0,  
        2: 0,  
        24: 0,  
        14: 0,  
        22: 0,  
        1: 0,  
        25: 0,  
        15: 0,  
        4: 0,  
        11: 0,  
        6: 0,  
        23: 0,  
        12: 0,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 0,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 0,  
        10: 0,  
        5: 0,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 0,  
        58: 2,  
        40: 0,  
    },
    40: {  
        50: 1,  
        60: 1,  
        61: 1,  
        42: 1,  
        53: 1,  
        56: 0,  
        54: 1,  
        49: 0,  
        51: 1,  
        43: 1,  
        44: 1,  
        63: 0,  
        34: 0,  
        55: 0,  
        48: 0,  
        39: 0,  
        57: 0,  
        30: 0,  
        59: 0,  
        41: 0,  
        33: 0,  
        37: 0,  
        36: 0,  
        31: 0,  
        29: 0,  
        35: 0,  
        62: 0,  
        28: 0,  
        38: 0,  
        45: 0,  
        9: 1,  
        8: 0,  
        20: 0,  
        16: 0,  
        3: 1,  
        2: 1,  
        24: 1,  
        14: 0,  
        22: 0,  
        1: 1,  
        25: 0,  
        15: 1,  
        4: 1,  
        11: 0,  
        6: 1,  
        23: 0,  
        12: 1,  
        19: 0,  
        13: 0,  
        26: 0,  
        18: 1,  
        27: 0,  
        21: 0,  
        17: 0,  
        7: 1,  
        10: 1,  
        5: 1,  
        32: 0,  
        52: 0,  
        47: 0,  
        46: 1,  
        58: 0,  
        40: 2,  
    },
}








WINDOWS_1255_HEBREW_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 69,  
    66: 91,  
    67: 79,  
    68: 80,  
    69: 92,  
    70: 89,  
    71: 97,  
    72: 90,  
    73: 68,  
    74: 111,  
    75: 112,  
    76: 82,  
    77: 73,  
    78: 95,  
    79: 85,  
    80: 78,  
    81: 121,  
    82: 86,  
    83: 71,  
    84: 67,  
    85: 102,  
    86: 107,  
    87: 84,  
    88: 114,  
    89: 103,  
    90: 115,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 50,  
    98: 74,  
    99: 60,  
    100: 61,  
    101: 42,  
    102: 76,  
    103: 70,  
    104: 64,  
    105: 53,  
    106: 105,  
    107: 93,  
    108: 56,  
    109: 65,  
    110: 54,  
    111: 49,  
    112: 66,  
    113: 110,  
    114: 51,  
    115: 43,  
    116: 44,  
    117: 63,  
    118: 81,  
    119: 77,  
    120: 98,  
    121: 75,  
    122: 108,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 124,  
    129: 202,  
    130: 203,  
    131: 204,  
    132: 205,  
    133: 40,  
    134: 58,  
    135: 206,  
    136: 207,  
    137: 208,  
    138: 209,  
    139: 210,  
    140: 211,  
    141: 212,  
    142: 213,  
    143: 214,  
    144: 215,  
    145: 83,  
    146: 52,  
    147: 47,  
    148: 46,  
    149: 72,  
    150: 32,  
    151: 94,  
    152: 216,  
    153: 113,  
    154: 217,  
    155: 109,  
    156: 218,  
    157: 219,  
    158: 220,  
    159: 221,  
    160: 34,  
    161: 116,  
    162: 222,  
    163: 118,  
    164: 100,  
    165: 223,  
    166: 224,  
    167: 117,  
    168: 119,  
    169: 104,  
    170: 125,  
    171: 225,  
    172: 226,  
    173: 87,  
    174: 99,  
    175: 227,  
    176: 106,  
    177: 122,  
    178: 123,  
    179: 228,  
    180: 55,  
    181: 229,  
    182: 230,  
    183: 101,  
    184: 231,  
    185: 232,  
    186: 120,  
    187: 233,  
    188: 48,  
    189: 39,  
    190: 57,  
    191: 234,  
    192: 30,  
    193: 59,  
    194: 41,  
    195: 88,  
    196: 33,  
    197: 37,  
    198: 36,  
    199: 31,  
    200: 29,  
    201: 35,  
    202: 235,  
    203: 62,  
    204: 28,  
    205: 236,  
    206: 126,  
    207: 237,  
    208: 238,  
    209: 38,  
    210: 45,  
    211: 239,  
    212: 240,  
    213: 241,  
    214: 242,  
    215: 243,  
    216: 127,  
    217: 244,  
    218: 245,  
    219: 246,  
    220: 247,  
    221: 248,  
    222: 249,  
    223: 250,  
    224: 9,  
    225: 8,  
    226: 20,  
    227: 16,  
    228: 3,  
    229: 2,  
    230: 24,  
    231: 14,  
    232: 22,  
    233: 1,  
    234: 25,  
    235: 15,  
    236: 4,  
    237: 11,  
    238: 6,  
    239: 23,  
    240: 12,  
    241: 19,  
    242: 13,  
    243: 26,  
    244: 18,  
    245: 27,  
    246: 21,  
    247: 17,  
    248: 7,  
    249: 10,  
    250: 5,  
    251: 251,  
    252: 252,  
    253: 128,  
    254: 96,  
    255: 253,  
}

WINDOWS_1255_HEBREW_MODEL = SingleByteCharSetModel(
    charset_name="windows-1255",
    language="Hebrew",
    char_to_order_map=WINDOWS_1255_HEBREW_CHAR_TO_ORDER,
    language_model=HEBREW_LANG_MODEL,
    typical_positive_ratio=0.984004,
    keep_ascii_letters=False,
    alphabet="אבגדהוזחטיךכלםמןנסעףפץצקרשתװױײ",
)
