from pip._vendor.chardet.sbcharsetprober import SingleByteCharSetModel






HUNGARIAN_LANG_MODEL = {
    28: {  
        28: 0,  
        40: 1,  
        54: 1,  
        45: 2,  
        32: 1,  
        50: 1,  
        49: 2,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 2,  
        41: 2,  
        34: 1,  
        35: 2,  
        47: 1,  
        46: 2,  
        43: 2,  
        33: 2,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 2,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 2,  
        1: 1,  
        27: 1,  
        12: 1,  
        20: 1,  
        9: 1,  
        22: 1,  
        7: 2,  
        6: 2,  
        13: 2,  
        4: 2,  
        8: 0,  
        23: 2,  
        10: 2,  
        5: 1,  
        3: 1,  
        21: 1,  
        19: 1,  
        62: 1,  
        16: 0,  
        11: 3,  
        51: 1,  
        44: 0,  
        61: 1,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    40: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 0,  
        35: 1,  
        47: 2,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 0,  
        52: 0,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 3,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 2,  
        22: 1,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 1,  
        10: 2,  
        5: 0,  
        3: 0,  
        21: 3,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 2,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 1,  
    },
    54: {  
        28: 1,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 0,  
        49: 0,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 0,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 2,  
        37: 1,  
        57: 1,  
        48: 0,  
        55: 1,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 1,  
        27: 0,  
        12: 0,  
        20: 1,  
        9: 1,  
        22: 0,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 1,  
        5: 3,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 1,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    45: {  
        28: 2,  
        40: 1,  
        54: 0,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 0,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 3,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 1,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 0,  
        8: 1,  
        23: 0,  
        10: 2,  
        5: 0,  
        3: 0,  
        21: 2,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 1,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 1,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 0,  
    },
    32: {  
        28: 1,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 1,  
        49: 2,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 2,  
        41: 2,  
        34: 2,  
        35: 2,  
        47: 1,  
        46: 1,  
        43: 2,  
        33: 2,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 1,  
        18: 1,  
        26: 1,  
        17: 2,  
        1: 1,  
        27: 1,  
        12: 3,  
        20: 1,  
        9: 1,  
        22: 1,  
        7: 1,  
        6: 2,  
        13: 2,  
        4: 2,  
        8: 0,  
        23: 1,  
        10: 2,  
        5: 2,  
        3: 1,  
        21: 2,  
        19: 1,  
        62: 1,  
        16: 0,  
        11: 3,  
        51: 1,  
        44: 1,  
        61: 0,  
        58: 1,  
        59: 1,  
        60: 0,  
        63: 1,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 1,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    50: {  
        28: 1,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 1,  
        50: 1,  
        49: 0,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 0,  
        43: 1,  
        33: 0,  
        37: 1,  
        57: 1,  
        48: 0,  
        55: 1,  
        52: 0,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 1,  
        12: 0,  
        20: 0,  
        9: 2,  
        22: 1,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 2,  
        5: 0,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 0,  
        58: 1,  
        59: 1,  
        60: 0,  
        63: 1,  
        14: 1,  
        15: 1,  
        30: 0,  
        25: 0,  
        24: 2,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 1,  
    },
    49: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 2,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 1,  
        22: 0,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 2,  
        5: 0,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 2,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 1,  
        15: 1,  
        30: 0,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 0,  
    },
    38: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 0,  
        32: 1,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 1,  
        53: 0,  
        36: 0,  
        41: 1,  
        34: 0,  
        35: 0,  
        47: 1,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 0,  
        55: 1,  
        52: 0,  
        2: 3,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 2,  
        22: 1,  
        7: 0,  
        6: 1,  
        13: 1,  
        4: 0,  
        8: 3,  
        23: 0,  
        10: 1,  
        5: 0,  
        3: 0,  
        21: 2,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 2,  
        44: 2,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 1,  
        30: 2,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 1,  
    },
    39: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 2,  
        41: 2,  
        34: 1,  
        35: 2,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 2,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 0,  
        52: 2,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 2,  
        1: 0,  
        27: 1,  
        12: 2,  
        20: 1,  
        9: 0,  
        22: 1,  
        7: 1,  
        6: 2,  
        13: 2,  
        4: 1,  
        8: 0,  
        23: 1,  
        10: 2,  
        5: 2,  
        3: 2,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 1,  
        44: 1,  
        61: 0,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    53: {  
        28: 2,  
        40: 0,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 0,  
        49: 0,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 0,  
        43: 0,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 0,  
        55: 0,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 1,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 0,  
        8: 1,  
        23: 0,  
        10: 0,  
        5: 0,  
        3: 0,  
        21: 2,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 0,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 1,  
        30: 0,  
        25: 2,  
        24: 2,  
        31: 1,  
        29: 0,  
        42: 1,  
        56: 0,  
    },
    36: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 0,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 0,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 1,  
        12: 0,  
        20: 1,  
        9: 3,  
        22: 0,  
        7: 0,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 2,  
        23: 0,  
        10: 2,  
        5: 0,  
        3: 0,  
        21: 1,  
        19: 1,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 2,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 2,  
        30: 1,  
        25: 1,  
        24: 2,  
        31: 1,  
        29: 2,  
        42: 1,  
        56: 0,  
    },
    41: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 2,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 3,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 2,  
        22: 1,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 0,  
        5: 0,  
        3: 0,  
        21: 2,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 2,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 0,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    34: {  
        28: 2,  
        40: 1,  
        54: 0,  
        45: 0,  
        32: 2,  
        50: 1,  
        49: 0,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 3,  
        18: 0,  
        26: 1,  
        17: 0,  
        1: 3,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 3,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 1,  
        4: 1,  
        8: 3,  
        23: 0,  
        10: 1,  
        5: 0,  
        3: 0,  
        21: 2,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 2,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 2,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 1,  
    },
    35: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 2,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 2,  
        52: 1,  
        2: 3,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 3,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 2,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 1,  
        8: 2,  
        23: 0,  
        10: 0,  
        5: 0,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 2,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 1,  
        15: 2,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 0,  
        29: 0,  
        42: 1,  
        56: 0,  
    },
    47: {  
        28: 1,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 2,  
        41: 2,  
        34: 2,  
        35: 2,  
        47: 1,  
        46: 1,  
        43: 2,  
        33: 2,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 1,  
        1: 1,  
        27: 1,  
        12: 1,  
        20: 1,  
        9: 1,  
        22: 1,  
        7: 2,  
        6: 2,  
        13: 1,  
        4: 1,  
        8: 1,  
        23: 1,  
        10: 2,  
        5: 1,  
        3: 2,  
        21: 1,  
        19: 0,  
        62: 1,  
        16: 0,  
        11: 1,  
        51: 1,  
        44: 1,  
        61: 0,  
        58: 1,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    46: {  
        28: 1,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 0,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 2,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 1,  
        12: 0,  
        20: 1,  
        9: 2,  
        22: 0,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 1,  
        8: 2,  
        23: 0,  
        10: 2,  
        5: 1,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 2,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 0,  
        63: 1,  
        14: 3,  
        15: 2,  
        30: 0,  
        25: 1,  
        24: 1,  
        31: 0,  
        29: 1,  
        42: 1,  
        56: 0,  
    },
    43: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 1,  
        43: 1,  
        33: 2,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 1,  
        9: 2,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 0,  
        5: 0,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 2,  
        44: 1,  
        61: 1,  
        58: 2,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 2,  
        30: 1,  
        25: 2,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    33: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 1,  
        43: 1,  
        33: 2,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 3,  
        2: 2,  
        18: 0,  
        26: 1,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 1,  
        9: 2,  
        22: 0,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 0,  
        8: 2,  
        23: 1,  
        10: 0,  
        5: 0,  
        3: 1,  
        21: 1,  
        19: 1,  
        62: 0,  
        16: 1,  
        11: 3,  
        51: 2,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 1,  
    },
    37: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 1,  
        43: 2,  
        33: 1,  
        37: 2,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 2,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 1,  
        9: 2,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 1,  
        5: 1,  
        3: 0,  
        21: 2,  
        19: 0,  
        62: 0,  
        16: 1,  
        11: 1,  
        51: 2,  
        44: 2,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 2,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 2,  
        31: 1,  
        29: 1,  
        42: 1,  
        56: 1,  
    },
    57: {  
        28: 1,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 2,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 1,  
        1: 1,  
        27: 0,  
        12: 2,  
        20: 0,  
        9: 0,  
        22: 1,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 0,  
        23: 1,  
        10: 1,  
        5: 1,  
        3: 1,  
        21: 0,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 1,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    48: {  
        28: 2,  
        40: 0,  
        54: 0,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 0,  
        38: 0,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 0,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 0,  
        2: 3,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 2,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 2,  
        22: 0,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 0,  
        8: 2,  
        23: 0,  
        10: 0,  
        5: 0,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 2,  
        44: 2,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 0,  
        63: 1,  
        14: 2,  
        15: 2,  
        30: 1,  
        25: 0,  
        24: 1,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    55: {  
        28: 2,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 1,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 0,  
        52: 2,  
        2: 1,  
        18: 0,  
        26: 0,  
        17: 1,  
        1: 1,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 0,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 0,  
        8: 1,  
        23: 1,  
        10: 0,  
        5: 0,  
        3: 0,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 1,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    52: {  
        28: 2,  
        40: 1,  
        54: 0,  
        45: 1,  
        32: 2,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 2,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 2,  
        46: 1,  
        43: 1,  
        33: 2,  
        37: 1,  
        57: 1,  
        48: 1,  
        55: 1,  
        52: 1,  
        2: 1,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 1,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 1,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 1,  
        8: 1,  
        23: 0,  
        10: 1,  
        5: 2,  
        3: 0,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 2,  
        44: 1,  
        61: 1,  
        58: 1,  
        59: 1,  
        60: 1,  
        63: 1,  
        14: 1,  
        15: 1,  
        30: 0,  
        25: 0,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    2: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 2,  
        27: 2,  
        12: 3,  
        20: 3,  
        9: 3,  
        22: 3,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 2,  
        23: 3,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 1,  
        16: 2,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    18: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 1,  
        17: 1,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 1,  
        9: 3,  
        22: 2,  
        7: 2,  
        6: 2,  
        13: 1,  
        4: 2,  
        8: 3,  
        23: 1,  
        10: 3,  
        5: 2,  
        3: 1,  
        21: 3,  
        19: 1,  
        62: 0,  
        16: 1,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 3,  
        24: 2,  
        31: 2,  
        29: 2,  
        42: 2,  
        56: 1,  
    },
    26: {  
        28: 0,  
        40: 0,  
        54: 1,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 1,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 2,  
        18: 1,  
        26: 2,  
        17: 1,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 3,  
        9: 3,  
        22: 1,  
        7: 2,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 3,  
        23: 1,  
        10: 2,  
        5: 3,  
        3: 2,  
        21: 2,  
        19: 1,  
        62: 0,  
        16: 1,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 2,  
        15: 2,  
        30: 2,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    17: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 2,  
        26: 1,  
        17: 2,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 2,  
        9: 3,  
        22: 3,  
        7: 2,  
        6: 1,  
        13: 2,  
        4: 3,  
        8: 3,  
        23: 1,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 0,  
        16: 2,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 3,  
        25: 3,  
        24: 3,  
        31: 2,  
        29: 2,  
        42: 2,  
        56: 1,  
    },
    1: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 2,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 2,  
        27: 3,  
        12: 3,  
        20: 3,  
        9: 3,  
        22: 3,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 2,  
        23: 3,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 2,  
        19: 3,  
        62: 2,  
        16: 2,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    27: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 1,  
        26: 1,  
        17: 1,  
        1: 3,  
        27: 2,  
        12: 1,  
        20: 1,  
        9: 3,  
        22: 2,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 3,  
        23: 0,  
        10: 3,  
        5: 1,  
        3: 1,  
        21: 2,  
        19: 1,  
        62: 0,  
        16: 1,  
        11: 0,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 1,  
        25: 1,  
        24: 3,  
        31: 1,  
        29: 2,  
        42: 1,  
        56: 1,  
    },
    12: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 2,  
        17: 2,  
        1: 3,  
        27: 2,  
        12: 3,  
        20: 3,  
        9: 3,  
        22: 3,  
        7: 2,  
        6: 3,  
        13: 2,  
        4: 3,  
        8: 3,  
        23: 1,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 0,  
        16: 3,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 3,  
        24: 2,  
        31: 2,  
        29: 2,  
        42: 2,  
        56: 1,  
    },
    20: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 1,  
        26: 1,  
        17: 0,  
        1: 3,  
        27: 0,  
        12: 1,  
        20: 2,  
        9: 3,  
        22: 1,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 3,  
        23: 0,  
        10: 1,  
        5: 2,  
        3: 1,  
        21: 3,  
        19: 1,  
        62: 0,  
        16: 2,  
        11: 0,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 3,  
        25: 2,  
        24: 2,  
        31: 2,  
        29: 1,  
        42: 1,  
        56: 1,  
    },
    9: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 3,  
        27: 3,  
        12: 3,  
        20: 3,  
        9: 2,  
        22: 2,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 2,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 1,  
        16: 1,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 2,  
        30: 1,  
        25: 3,  
        24: 1,  
        31: 2,  
        29: 1,  
        42: 0,  
        56: 1,  
    },
    22: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 2,  
        26: 1,  
        17: 3,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 2,  
        9: 1,  
        22: 2,  
        7: 2,  
        6: 2,  
        13: 1,  
        4: 2,  
        8: 3,  
        23: 1,  
        10: 2,  
        5: 2,  
        3: 3,  
        21: 3,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 1,  
        25: 3,  
        24: 3,  
        31: 3,  
        29: 2,  
        42: 1,  
        56: 1,  
    },
    7: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 2,  
        17: 1,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 2,  
        9: 3,  
        22: 2,  
        7: 3,  
        6: 3,  
        13: 1,  
        4: 3,  
        8: 3,  
        23: 1,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 2,  
        62: 0,  
        16: 2,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 3,  
        25: 2,  
        24: 3,  
        31: 1,  
        29: 3,  
        42: 1,  
        56: 1,  
    },
    6: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 1,  
        41: 0,  
        34: 0,  
        35: 1,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 2,  
        26: 3,  
        17: 3,  
        1: 3,  
        27: 3,  
        12: 3,  
        20: 3,  
        9: 3,  
        22: 3,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 3,  
        23: 2,  
        10: 2,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 0,  
        16: 3,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 3,  
        25: 3,  
        24: 3,  
        31: 2,  
        29: 2,  
        42: 3,  
        56: 1,  
    },
    13: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 2,  
        17: 1,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 2,  
        9: 3,  
        22: 2,  
        7: 1,  
        6: 3,  
        13: 3,  
        4: 2,  
        8: 3,  
        23: 3,  
        10: 2,  
        5: 2,  
        3: 2,  
        21: 3,  
        19: 1,  
        62: 0,  
        16: 1,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 2,  
        24: 2,  
        31: 2,  
        29: 2,  
        42: 1,  
        56: 2,  
    },
    4: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 3,  
        27: 2,  
        12: 3,  
        20: 3,  
        9: 3,  
        22: 2,  
        7: 3,  
        6: 2,  
        13: 2,  
        4: 3,  
        8: 3,  
        23: 2,  
        10: 2,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 2,  
        62: 1,  
        16: 3,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 2,  
        24: 3,  
        31: 2,  
        29: 3,  
        42: 2,  
        56: 1,  
    },
    8: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 1,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 2,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 2,  
        27: 2,  
        12: 3,  
        20: 3,  
        9: 2,  
        22: 2,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 1,  
        23: 3,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 2,  
        19: 3,  
        62: 1,  
        16: 1,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 2,  
        30: 1,  
        25: 1,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    23: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 1,  
        26: 2,  
        17: 1,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 2,  
        9: 3,  
        22: 2,  
        7: 2,  
        6: 3,  
        13: 1,  
        4: 2,  
        8: 3,  
        23: 3,  
        10: 3,  
        5: 2,  
        3: 2,  
        21: 3,  
        19: 2,  
        62: 0,  
        16: 1,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 2,  
        24: 2,  
        31: 1,  
        29: 2,  
        42: 1,  
        56: 1,  
    },
    10: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 3,  
        27: 2,  
        12: 3,  
        20: 2,  
        9: 3,  
        22: 3,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 3,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 1,  
        16: 2,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 3,  
        24: 3,  
        31: 3,  
        29: 3,  
        42: 2,  
        56: 2,  
    },
    5: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 2,  
        17: 2,  
        1: 3,  
        27: 2,  
        12: 2,  
        20: 2,  
        9: 3,  
        22: 1,  
        7: 3,  
        6: 2,  
        13: 3,  
        4: 3,  
        8: 3,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 2,  
        62: 0,  
        16: 1,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 3,  
        25: 3,  
        24: 3,  
        31: 3,  
        29: 3,  
        42: 2,  
        56: 1,  
    },
    3: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 3,  
        26: 2,  
        17: 1,  
        1: 3,  
        27: 2,  
        12: 1,  
        20: 3,  
        9: 3,  
        22: 3,  
        7: 3,  
        6: 3,  
        13: 2,  
        4: 3,  
        8: 3,  
        23: 1,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 0,  
        16: 3,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 3,  
        24: 3,  
        31: 3,  
        29: 3,  
        42: 3,  
        56: 2,  
    },
    21: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 2,  
        26: 2,  
        17: 3,  
        1: 2,  
        27: 1,  
        12: 3,  
        20: 2,  
        9: 2,  
        22: 2,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 1,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 1,  
        19: 3,  
        62: 1,  
        16: 1,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 2,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 0,  
        31: 1,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    19: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 2,  
        26: 1,  
        17: 1,  
        1: 3,  
        27: 1,  
        12: 1,  
        20: 1,  
        9: 3,  
        22: 1,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 3,  
        23: 1,  
        10: 1,  
        5: 2,  
        3: 2,  
        21: 2,  
        19: 2,  
        62: 0,  
        16: 1,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 2,  
        24: 2,  
        31: 1,  
        29: 2,  
        42: 1,  
        56: 1,  
    },
    62: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 1,  
        26: 1,  
        17: 0,  
        1: 1,  
        27: 1,  
        12: 0,  
        20: 0,  
        9: 1,  
        22: 0,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 1,  
        23: 1,  
        10: 1,  
        5: 1,  
        3: 1,  
        21: 1,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 1,  
        30: 1,  
        25: 1,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    16: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 2,  
        26: 1,  
        17: 1,  
        1: 3,  
        27: 2,  
        12: 2,  
        20: 2,  
        9: 3,  
        22: 2,  
        7: 2,  
        6: 2,  
        13: 2,  
        4: 3,  
        8: 3,  
        23: 2,  
        10: 2,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 3,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 2,  
        25: 2,  
        24: 3,  
        31: 2,  
        29: 2,  
        42: 1,  
        56: 2,  
    },
    11: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 3,  
        18: 2,  
        26: 1,  
        17: 3,  
        1: 3,  
        27: 1,  
        12: 2,  
        20: 2,  
        9: 3,  
        22: 1,  
        7: 3,  
        6: 2,  
        13: 3,  
        4: 3,  
        8: 3,  
        23: 1,  
        10: 2,  
        5: 3,  
        3: 3,  
        21: 3,  
        19: 2,  
        62: 0,  
        16: 1,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 3,  
        15: 3,  
        30: 3,  
        25: 3,  
        24: 3,  
        31: 2,  
        29: 3,  
        42: 2,  
        56: 1,  
    },
    51: {  
        28: 0,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 0,  
        50: 1,  
        49: 2,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 2,  
        34: 1,  
        35: 2,  
        47: 0,  
        46: 1,  
        43: 2,  
        33: 2,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 1,  
        1: 0,  
        27: 0,  
        12: 1,  
        20: 1,  
        9: 0,  
        22: 1,  
        7: 1,  
        6: 2,  
        13: 2,  
        4: 0,  
        8: 0,  
        23: 1,  
        10: 1,  
        5: 1,  
        3: 1,  
        21: 0,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 1,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    44: {  
        28: 0,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 1,  
        50: 0,  
        49: 2,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 2,  
        34: 1,  
        35: 2,  
        47: 0,  
        46: 1,  
        43: 2,  
        33: 2,  
        37: 2,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 1,  
        1: 0,  
        27: 0,  
        12: 1,  
        20: 1,  
        9: 0,  
        22: 1,  
        7: 1,  
        6: 2,  
        13: 1,  
        4: 2,  
        8: 0,  
        23: 1,  
        10: 2,  
        5: 3,  
        3: 1,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 0,  
        44: 1,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    61: {  
        28: 0,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 0,  
        50: 1,  
        49: 1,  
        38: 0,  
        39: 0,  
        53: 1,  
        36: 0,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 0,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 0,  
        27: 0,  
        12: 2,  
        20: 0,  
        9: 0,  
        22: 0,  
        7: 0,  
        6: 0,  
        13: 1,  
        4: 0,  
        8: 0,  
        23: 0,  
        10: 1,  
        5: 0,  
        3: 1,  
        21: 0,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    58: {  
        28: 1,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 0,  
        50: 1,  
        49: 1,  
        38: 1,  
        39: 1,  
        53: 1,  
        36: 1,  
        41: 2,  
        34: 1,  
        35: 1,  
        47: 0,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 1,  
        26: 1,  
        17: 1,  
        1: 0,  
        27: 0,  
        12: 0,  
        20: 2,  
        9: 0,  
        22: 0,  
        7: 1,  
        6: 1,  
        13: 0,  
        4: 1,  
        8: 0,  
        23: 1,  
        10: 1,  
        5: 1,  
        3: 0,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 0,  
        44: 1,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    59: {  
        28: 0,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 0,  
        50: 0,  
        49: 1,  
        38: 1,  
        39: 0,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 0,  
        46: 1,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 0,  
        26: 1,  
        17: 1,  
        1: 0,  
        27: 0,  
        12: 0,  
        20: 0,  
        9: 0,  
        22: 0,  
        7: 1,  
        6: 1,  
        13: 1,  
        4: 1,  
        8: 0,  
        23: 0,  
        10: 2,  
        5: 1,  
        3: 1,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    60: {  
        28: 0,  
        40: 1,  
        54: 1,  
        45: 1,  
        32: 0,  
        50: 1,  
        49: 1,  
        38: 0,  
        39: 0,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 0,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 0,  
        26: 0,  
        17: 0,  
        1: 0,  
        27: 0,  
        12: 2,  
        20: 0,  
        9: 0,  
        22: 2,  
        7: 0,  
        6: 0,  
        13: 0,  
        4: 1,  
        8: 0,  
        23: 0,  
        10: 1,  
        5: 1,  
        3: 1,  
        21: 0,  
        19: 0,  
        62: 0,  
        16: 0,  
        11: 0,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    63: {  
        28: 0,  
        40: 1,  
        54: 0,  
        45: 1,  
        32: 0,  
        50: 0,  
        49: 1,  
        38: 1,  
        39: 0,  
        53: 1,  
        36: 1,  
        41: 1,  
        34: 1,  
        35: 1,  
        47: 0,  
        46: 0,  
        43: 1,  
        33: 1,  
        37: 1,  
        57: 0,  
        48: 1,  
        55: 0,  
        52: 1,  
        2: 0,  
        18: 1,  
        26: 0,  
        17: 1,  
        1: 0,  
        27: 0,  
        12: 1,  
        20: 0,  
        9: 0,  
        22: 0,  
        7: 0,  
        6: 1,  
        13: 0,  
        4: 1,  
        8: 0,  
        23: 0,  
        10: 1,  
        5: 1,  
        3: 1,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 1,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    14: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 3,  
        26: 3,  
        17: 3,  
        1: 1,  
        27: 2,  
        12: 3,  
        20: 2,  
        9: 2,  
        22: 3,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 1,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 2,  
        19: 3,  
        62: 0,  
        16: 1,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 2,  
        30: 1,  
        25: 0,  
        24: 1,  
        31: 0,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    15: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 3,  
        26: 2,  
        17: 3,  
        1: 1,  
        27: 1,  
        12: 3,  
        20: 3,  
        9: 2,  
        22: 2,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 1,  
        23: 3,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 0,  
        19: 3,  
        62: 0,  
        16: 0,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 1,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    30: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 0,  
        18: 1,  
        26: 2,  
        17: 1,  
        1: 0,  
        27: 1,  
        12: 3,  
        20: 0,  
        9: 0,  
        22: 1,  
        7: 1,  
        6: 2,  
        13: 2,  
        4: 3,  
        8: 0,  
        23: 1,  
        10: 3,  
        5: 2,  
        3: 3,  
        21: 0,  
        19: 3,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    25: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 2,  
        18: 3,  
        26: 2,  
        17: 3,  
        1: 1,  
        27: 2,  
        12: 2,  
        20: 2,  
        9: 2,  
        22: 2,  
        7: 3,  
        6: 3,  
        13: 2,  
        4: 3,  
        8: 1,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 1,  
        19: 2,  
        62: 0,  
        16: 0,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 1,  
        30: 1,  
        25: 0,  
        24: 1,  
        31: 1,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    24: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 0,  
        18: 3,  
        26: 1,  
        17: 2,  
        1: 0,  
        27: 1,  
        12: 2,  
        20: 1,  
        9: 0,  
        22: 1,  
        7: 3,  
        6: 3,  
        13: 3,  
        4: 3,  
        8: 0,  
        23: 2,  
        10: 3,  
        5: 3,  
        3: 3,  
        21: 0,  
        19: 3,  
        62: 0,  
        16: 0,  
        11: 3,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    31: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 1,  
        26: 2,  
        17: 1,  
        1: 1,  
        27: 2,  
        12: 3,  
        20: 1,  
        9: 1,  
        22: 3,  
        7: 1,  
        6: 3,  
        13: 1,  
        4: 2,  
        8: 0,  
        23: 1,  
        10: 3,  
        5: 3,  
        3: 2,  
        21: 1,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 1,  
        15: 1,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    29: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 1,  
        26: 1,  
        17: 2,  
        1: 1,  
        27: 1,  
        12: 3,  
        20: 2,  
        9: 1,  
        22: 1,  
        7: 3,  
        6: 3,  
        13: 1,  
        4: 3,  
        8: 0,  
        23: 1,  
        10: 2,  
        5: 2,  
        3: 2,  
        21: 0,  
        19: 2,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 1,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
    42: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 2,  
        26: 1,  
        17: 2,  
        1: 1,  
        27: 1,  
        12: 1,  
        20: 1,  
        9: 1,  
        22: 1,  
        7: 2,  
        6: 3,  
        13: 1,  
        4: 2,  
        8: 1,  
        23: 1,  
        10: 2,  
        5: 2,  
        3: 2,  
        21: 1,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 1,  
        30: 1,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 1,  
        42: 0,  
        56: 0,  
    },
    56: {  
        28: 0,  
        40: 0,  
        54: 0,  
        45: 0,  
        32: 0,  
        50: 0,  
        49: 0,  
        38: 0,  
        39: 0,  
        53: 0,  
        36: 0,  
        41: 0,  
        34: 0,  
        35: 0,  
        47: 0,  
        46: 0,  
        43: 0,  
        33: 0,  
        37: 0,  
        57: 0,  
        48: 0,  
        55: 0,  
        52: 0,  
        2: 1,  
        18: 1,  
        26: 0,  
        17: 1,  
        1: 1,  
        27: 1,  
        12: 1,  
        20: 1,  
        9: 1,  
        22: 1,  
        7: 1,  
        6: 1,  
        13: 0,  
        4: 2,  
        8: 0,  
        23: 0,  
        10: 1,  
        5: 1,  
        3: 1,  
        21: 0,  
        19: 1,  
        62: 0,  
        16: 0,  
        11: 2,  
        51: 0,  
        44: 0,  
        61: 0,  
        58: 0,  
        59: 0,  
        60: 0,  
        63: 0,  
        14: 0,  
        15: 0,  
        30: 0,  
        25: 0,  
        24: 0,  
        31: 0,  
        29: 0,  
        42: 0,  
        56: 0,  
    },
}








WINDOWS_1250_HUNGARIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 28,  
    66: 40,  
    67: 54,  
    68: 45,  
    69: 32,  
    70: 50,  
    71: 49,  
    72: 38,  
    73: 39,  
    74: 53,  
    75: 36,  
    76: 41,  
    77: 34,  
    78: 35,  
    79: 47,  
    80: 46,  
    81: 72,  
    82: 43,  
    83: 33,  
    84: 37,  
    85: 57,  
    86: 48,  
    87: 64,  
    88: 68,  
    89: 55,  
    90: 52,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 2,  
    98: 18,  
    99: 26,  
    100: 17,  
    101: 1,  
    102: 27,  
    103: 12,  
    104: 20,  
    105: 9,  
    106: 22,  
    107: 7,  
    108: 6,  
    109: 13,  
    110: 4,  
    111: 8,  
    112: 23,  
    113: 67,  
    114: 10,  
    115: 5,  
    116: 3,  
    117: 21,  
    118: 19,  
    119: 65,  
    120: 62,  
    121: 16,  
    122: 11,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 161,  
    129: 162,  
    130: 163,  
    131: 164,  
    132: 165,  
    133: 166,  
    134: 167,  
    135: 168,  
    136: 169,  
    137: 170,  
    138: 171,  
    139: 172,  
    140: 173,  
    141: 174,  
    142: 175,  
    143: 176,  
    144: 177,  
    145: 178,  
    146: 179,  
    147: 180,  
    148: 78,  
    149: 181,  
    150: 69,  
    151: 182,  
    152: 183,  
    153: 184,  
    154: 185,  
    155: 186,  
    156: 187,  
    157: 188,  
    158: 189,  
    159: 190,  
    160: 191,  
    161: 192,  
    162: 193,  
    163: 194,  
    164: 195,  
    165: 196,  
    166: 197,  
    167: 76,  
    168: 198,  
    169: 199,  
    170: 200,  
    171: 201,  
    172: 202,  
    173: 203,  
    174: 204,  
    175: 205,  
    176: 81,  
    177: 206,  
    178: 207,  
    179: 208,  
    180: 209,  
    181: 210,  
    182: 211,  
    183: 212,  
    184: 213,  
    185: 214,  
    186: 215,  
    187: 216,  
    188: 217,  
    189: 218,  
    190: 219,  
    191: 220,  
    192: 221,  
    193: 51,  
    194: 83,  
    195: 222,  
    196: 80,  
    197: 223,  
    198: 224,  
    199: 225,  
    200: 226,  
    201: 44,  
    202: 227,  
    203: 228,  
    204: 229,  
    205: 61,  
    206: 230,  
    207: 231,  
    208: 232,  
    209: 233,  
    210: 234,  
    211: 58,  
    212: 235,  
    213: 66,  
    214: 59,  
    215: 236,  
    216: 237,  
    217: 238,  
    218: 60,  
    219: 70,  
    220: 63,  
    221: 239,  
    222: 240,  
    223: 241,  
    224: 84,  
    225: 14,  
    226: 75,  
    227: 242,  
    228: 71,  
    229: 82,  
    230: 243,  
    231: 73,  
    232: 244,  
    233: 15,  
    234: 85,  
    235: 79,  
    236: 86,  
    237: 30,  
    238: 77,  
    239: 87,  
    240: 245,  
    241: 246,  
    242: 247,  
    243: 25,  
    244: 74,  
    245: 42,  
    246: 24,  
    247: 248,  
    248: 249,  
    249: 250,  
    250: 31,  
    251: 56,  
    252: 29,  
    253: 251,  
    254: 252,  
    255: 253,  
}

WINDOWS_1250_HUNGARIAN_MODEL = SingleByteCharSetModel(
    charset_name="windows-1250",
    language="Hungarian",
    char_to_order_map=WINDOWS_1250_HUNGARIAN_CHAR_TO_ORDER,
    language_model=HUNGARIAN_LANG_MODEL,
    typical_positive_ratio=0.947368,
    keep_ascii_letters=True,
    alphabet="ABCDEFGHIJKLMNOPRSTUVZabcdefghijklmnoprstuvzÁÉÍÓÖÚÜáéíóöúüŐőŰű",
)

ISO_8859_2_HUNGARIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 28,  
    66: 40,  
    67: 54,  
    68: 45,  
    69: 32,  
    70: 50,  
    71: 49,  
    72: 38,  
    73: 39,  
    74: 53,  
    75: 36,  
    76: 41,  
    77: 34,  
    78: 35,  
    79: 47,  
    80: 46,  
    81: 71,  
    82: 43,  
    83: 33,  
    84: 37,  
    85: 57,  
    86: 48,  
    87: 64,  
    88: 68,  
    89: 55,  
    90: 52,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 2,  
    98: 18,  
    99: 26,  
    100: 17,  
    101: 1,  
    102: 27,  
    103: 12,  
    104: 20,  
    105: 9,  
    106: 22,  
    107: 7,  
    108: 6,  
    109: 13,  
    110: 4,  
    111: 8,  
    112: 23,  
    113: 67,  
    114: 10,  
    115: 5,  
    116: 3,  
    117: 21,  
    118: 19,  
    119: 65,  
    120: 62,  
    121: 16,  
    122: 11,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 159,  
    129: 160,  
    130: 161,  
    131: 162,  
    132: 163,  
    133: 164,  
    134: 165,  
    135: 166,  
    136: 167,  
    137: 168,  
    138: 169,  
    139: 170,  
    140: 171,  
    141: 172,  
    142: 173,  
    143: 174,  
    144: 175,  
    145: 176,  
    146: 177,  
    147: 178,  
    148: 179,  
    149: 180,  
    150: 181,  
    151: 182,  
    152: 183,  
    153: 184,  
    154: 185,  
    155: 186,  
    156: 187,  
    157: 188,  
    158: 189,  
    159: 190,  
    160: 191,  
    161: 192,  
    162: 193,  
    163: 194,  
    164: 195,  
    165: 196,  
    166: 197,  
    167: 75,  
    168: 198,  
    169: 199,  
    170: 200,  
    171: 201,  
    172: 202,  
    173: 203,  
    174: 204,  
    175: 205,  
    176: 79,  
    177: 206,  
    178: 207,  
    179: 208,  
    180: 209,  
    181: 210,  
    182: 211,  
    183: 212,  
    184: 213,  
    185: 214,  
    186: 215,  
    187: 216,  
    188: 217,  
    189: 218,  
    190: 219,  
    191: 220,  
    192: 221,  
    193: 51,  
    194: 81,  
    195: 222,  
    196: 78,  
    197: 223,  
    198: 224,  
    199: 225,  
    200: 226,  
    201: 44,  
    202: 227,  
    203: 228,  
    204: 229,  
    205: 61,  
    206: 230,  
    207: 231,  
    208: 232,  
    209: 233,  
    210: 234,  
    211: 58,  
    212: 235,  
    213: 66,  
    214: 59,  
    215: 236,  
    216: 237,  
    217: 238,  
    218: 60,  
    219: 69,  
    220: 63,  
    221: 239,  
    222: 240,  
    223: 241,  
    224: 82,  
    225: 14,  
    226: 74,  
    227: 242,  
    228: 70,  
    229: 80,  
    230: 243,  
    231: 72,  
    232: 244,  
    233: 15,  
    234: 83,  
    235: 77,  
    236: 84,  
    237: 30,  
    238: 76,  
    239: 85,  
    240: 245,  
    241: 246,  
    242: 247,  
    243: 25,  
    244: 73,  
    245: 42,  
    246: 24,  
    247: 248,  
    248: 249,  
    249: 250,  
    250: 31,  
    251: 56,  
    252: 29,  
    253: 251,  
    254: 252,  
    255: 253,  
}

ISO_8859_2_HUNGARIAN_MODEL = SingleByteCharSetModel(
    charset_name="ISO-8859-2",
    language="Hungarian",
    char_to_order_map=ISO_8859_2_HUNGARIAN_CHAR_TO_ORDER,
    language_model=HUNGARIAN_LANG_MODEL,
    typical_positive_ratio=0.947368,
    keep_ascii_letters=True,
    alphabet="ABCDEFGHIJKLMNOPRSTUVZabcdefghijklmnoprstuvzÁÉÍÓÖÚÜáéíóöúüŐőŰű",
)
