from pip._vendor.chardet.sbcharsetprober import SingleByteCharSetModel






RUSSIAN_LANG_MODEL = {
    37: {  
        37: 0,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 1,  
        56: 1,  
        51: 1,  
        42: 1,  
        60: 1,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 2,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 1,  
        55: 1,  
        58: 1,  
        50: 1,  
        57: 1,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 1,  
        43: 1,  
        3: 1,  
        21: 2,  
        10: 2,  
        19: 2,  
        13: 2,  
        2: 0,  
        24: 1,  
        20: 1,  
        4: 0,  
        23: 1,  
        11: 2,  
        8: 3,  
        12: 2,  
        5: 2,  
        1: 0,  
        15: 2,  
        9: 2,  
        7: 2,  
        6: 2,  
        14: 2,  
        39: 2,  
        26: 2,  
        28: 0,  
        22: 1,  
        25: 2,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 0,  
        16: 0,  
    },
    44: {  
        37: 1,  
        44: 0,  
        33: 1,  
        46: 1,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 1,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 1,  
        3: 2,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 1,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 0,  
        5: 0,  
        1: 3,  
        15: 0,  
        9: 2,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 2,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 1,  
    },
    33: {  
        37: 2,  
        44: 0,  
        33: 1,  
        46: 0,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 1,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 0,  
        59: 0,  
        43: 1,  
        3: 2,  
        21: 1,  
        10: 1,  
        19: 1,  
        13: 2,  
        2: 3,  
        24: 0,  
        20: 2,  
        4: 2,  
        23: 0,  
        11: 1,  
        8: 2,  
        12: 2,  
        5: 2,  
        1: 3,  
        15: 2,  
        9: 2,  
        7: 3,  
        6: 2,  
        14: 2,  
        39: 0,  
        26: 1,  
        28: 1,  
        22: 2,  
        25: 1,  
        29: 0,  
        54: 1,  
        18: 3,  
        17: 1,  
        30: 2,  
        27: 0,  
        16: 1,  
    },
    46: {  
        37: 1,  
        44: 1,  
        33: 0,  
        46: 0,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 0,  
        10: 1,  
        19: 0,  
        13: 2,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 1,  
        5: 1,  
        1: 3,  
        15: 0,  
        9: 2,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 1,  
        30: 1,  
        27: 1,  
        16: 0,  
    },
    41: {  
        37: 1,  
        44: 0,  
        33: 1,  
        46: 0,  
        41: 0,  
        48: 2,  
        56: 1,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 0,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 1,  
        32: 1,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 1,  
        50: 1,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 0,  
        59: 0,  
        43: 1,  
        3: 3,  
        21: 0,  
        10: 2,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 3,  
        20: 1,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 1,  
        5: 1,  
        1: 3,  
        15: 0,  
        9: 2,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 1,  
    },
    48: {  
        37: 1,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 1,  
        56: 1,  
        51: 1,  
        42: 1,  
        60: 1,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 2,  
        34: 1,  
        35: 1,  
        45: 2,  
        32: 2,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 1,  
        58: 1,  
        50: 1,  
        57: 1,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 1,  
        3: 0,  
        21: 0,  
        10: 2,  
        19: 2,  
        13: 2,  
        2: 2,  
        24: 1,  
        20: 1,  
        4: 0,  
        23: 2,  
        11: 1,  
        8: 2,  
        12: 2,  
        5: 1,  
        1: 0,  
        15: 1,  
        9: 1,  
        7: 3,  
        6: 0,  
        14: 0,  
        39: 1,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 2,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 1,  
        16: 0,  
    },
    56: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 1,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 1,  
        10: 0,  
        19: 1,  
        13: 1,  
        2: 2,  
        24: 1,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 1,  
        5: 0,  
        1: 2,  
        15: 0,  
        9: 1,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 2,  
        16: 0,  
    },
    51: {  
        37: 1,  
        44: 0,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 1,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 2,  
        19: 0,  
        13: 2,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 1,  
        12: 1,  
        5: 2,  
        1: 2,  
        15: 0,  
        9: 1,  
        7: 0,  
        6: 0,  
        14: 1,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 1,  
    },
    42: {  
        37: 1,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 2,  
        56: 1,  
        51: 1,  
        42: 1,  
        60: 1,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 2,  
        40: 1,  
        52: 0,  
        53: 1,  
        55: 1,  
        58: 1,  
        50: 1,  
        57: 0,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 1,  
        43: 1,  
        3: 1,  
        21: 2,  
        10: 2,  
        19: 2,  
        13: 2,  
        2: 2,  
        24: 0,  
        20: 2,  
        4: 1,  
        23: 0,  
        11: 1,  
        8: 2,  
        12: 2,  
        5: 2,  
        1: 1,  
        15: 1,  
        9: 2,  
        7: 2,  
        6: 2,  
        14: 1,  
        39: 1,  
        26: 2,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 1,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 1,  
        16: 0,  
    },
    60: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 1,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 0,  
        31: 1,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 1,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 1,  
        58: 1,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 1,  
        24: 0,  
        20: 0,  
        4: 0,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 2,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 0,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    36: {  
        37: 2,  
        44: 0,  
        33: 1,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 1,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 0,  
        31: 1,  
        34: 2,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 1,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 0,  
        10: 1,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 0,  
        5: 1,  
        1: 3,  
        15: 0,  
        9: 2,  
        7: 2,  
        6: 2,  
        14: 2,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 0,  
    },
    49: {  
        37: 2,  
        44: 0,  
        33: 0,  
        46: 1,  
        41: 0,  
        48: 1,  
        56: 1,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 0,  
        34: 1,  
        35: 1,  
        45: 0,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 1,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 0,  
        59: 1,  
        43: 1,  
        3: 2,  
        21: 0,  
        10: 0,  
        19: 1,  
        13: 0,  
        2: 2,  
        24: 1,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 1,  
        12: 0,  
        5: 1,  
        1: 2,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 1,  
        30: 2,  
        27: 2,  
        16: 1,  
    },
    38: {  
        37: 1,  
        44: 1,  
        33: 1,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 1,  
        55: 1,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 0,  
        47: 1,  
        59: 0,  
        43: 1,  
        3: 3,  
        21: 0,  
        10: 0,  
        19: 1,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 0,  
        8: 1,  
        12: 1,  
        5: 2,  
        1: 3,  
        15: 0,  
        9: 1,  
        7: 1,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 3,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 1,  
    },
    31: {  
        37: 2,  
        44: 0,  
        33: 0,  
        46: 1,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 1,  
        42: 2,  
        60: 0,  
        36: 1,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 1,  
        55: 1,  
        58: 1,  
        50: 1,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 1,  
        59: 0,  
        43: 1,  
        3: 3,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 3,  
        15: 0,  
        9: 1,  
        7: 0,  
        6: 0,  
        14: 3,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 2,  
        30: 1,  
        27: 1,  
        16: 1,  
    },
    34: {  
        37: 0,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 2,  
        48: 1,  
        56: 1,  
        51: 1,  
        42: 1,  
        60: 1,  
        36: 1,  
        49: 2,  
        38: 1,  
        31: 2,  
        34: 1,  
        35: 1,  
        45: 2,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 1,  
        55: 1,  
        58: 0,  
        50: 1,  
        57: 1,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 1,  
        3: 1,  
        21: 2,  
        10: 1,  
        19: 2,  
        13: 2,  
        2: 0,  
        24: 1,  
        20: 1,  
        4: 0,  
        23: 1,  
        11: 2,  
        8: 2,  
        12: 1,  
        5: 3,  
        1: 0,  
        15: 2,  
        9: 2,  
        7: 2,  
        6: 2,  
        14: 1,  
        39: 1,  
        26: 2,  
        28: 1,  
        22: 2,  
        25: 2,  
        29: 1,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    35: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 0,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 2,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 0,  
        59: 0,  
        43: 1,  
        3: 2,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 0,  
        5: 1,  
        1: 3,  
        15: 0,  
        9: 3,  
        7: 1,  
        6: 1,  
        14: 2,  
        39: 1,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 2,  
        30: 1,  
        27: 0,  
        16: 2,  
    },
    45: {  
        37: 2,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 2,  
        56: 1,  
        51: 0,  
        42: 2,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 2,  
        35: 0,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 1,  
        58: 1,  
        50: 1,  
        57: 1,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 1,  
        59: 1,  
        43: 1,  
        3: 3,  
        21: 0,  
        10: 1,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 1,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 3,  
        15: 0,  
        9: 1,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 2,  
        17: 0,  
        30: 1,  
        27: 1,  
        16: 2,  
    },
    32: {  
        37: 1,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 2,  
        52: 1,  
        53: 0,  
        55: 1,  
        58: 1,  
        50: 1,  
        57: 1,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 1,  
        59: 1,  
        43: 1,  
        3: 2,  
        21: 1,  
        10: 2,  
        19: 1,  
        13: 2,  
        2: 3,  
        24: 1,  
        20: 1,  
        4: 2,  
        23: 0,  
        11: 2,  
        8: 2,  
        12: 2,  
        5: 2,  
        1: 2,  
        15: 2,  
        9: 2,  
        7: 1,  
        6: 3,  
        14: 2,  
        39: 1,  
        26: 1,  
        28: 1,  
        22: 1,  
        25: 0,  
        29: 0,  
        54: 1,  
        18: 1,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 1,  
    },
    40: {  
        37: 1,  
        44: 0,  
        33: 1,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 2,  
        35: 0,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 1,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 1,  
        47: 1,  
        59: 1,  
        43: 1,  
        3: 3,  
        21: 1,  
        10: 2,  
        19: 0,  
        13: 0,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 1,  
        8: 1,  
        12: 0,  
        5: 0,  
        1: 3,  
        15: 0,  
        9: 2,  
        7: 1,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 1,  
        54: 0,  
        18: 3,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 1,  
    },
    52: {  
        37: 1,  
        44: 1,  
        33: 1,  
        46: 1,  
        41: 1,  
        48: 1,  
        56: 1,  
        51: 0,  
        42: 0,  
        60: 1,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 1,  
        58: 0,  
        50: 1,  
        57: 1,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 1,  
        43: 0,  
        3: 1,  
        21: 2,  
        10: 2,  
        19: 1,  
        13: 2,  
        2: 1,  
        24: 2,  
        20: 2,  
        4: 2,  
        23: 1,  
        11: 1,  
        8: 2,  
        12: 2,  
        5: 1,  
        1: 2,  
        15: 1,  
        9: 2,  
        7: 2,  
        6: 2,  
        14: 0,  
        39: 1,  
        26: 1,  
        28: 1,  
        22: 2,  
        25: 1,  
        29: 1,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 2,  
        27: 1,  
        16: 0,  
    },
    53: {  
        37: 1,  
        44: 1,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 0,  
        31: 0,  
        34: 1,  
        35: 0,  
        45: 1,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 0,  
        5: 0,  
        1: 2,  
        15: 0,  
        9: 2,  
        7: 0,  
        6: 1,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 1,  
        30: 2,  
        27: 0,  
        16: 0,  
    },
    55: {  
        37: 1,  
        44: 0,  
        33: 1,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 0,  
        10: 2,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 2,  
        12: 1,  
        5: 0,  
        1: 2,  
        15: 0,  
        9: 2,  
        7: 0,  
        6: 0,  
        14: 1,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 1,  
        30: 1,  
        27: 0,  
        16: 0,  
    },
    58: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 1,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 1,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 1,  
        21: 0,  
        10: 1,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 0,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 1,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 0,  
        30: 0,  
        27: 1,  
        16: 0,  
    },
    50: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 0,  
        35: 1,  
        45: 0,  
        32: 0,  
        40: 1,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 1,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 2,  
        23: 0,  
        11: 0,  
        8: 1,  
        12: 0,  
        5: 0,  
        1: 1,  
        15: 0,  
        9: 1,  
        7: 0,  
        6: 3,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 1,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    57: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 1,  
        38: 0,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 1,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 0,  
        10: 1,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 1,  
        23: 0,  
        11: 1,  
        8: 2,  
        12: 1,  
        5: 1,  
        1: 2,  
        15: 2,  
        9: 1,  
        7: 0,  
        6: 2,  
        14: 2,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 0,  
        16: 0,  
    },
    63: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 1,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 1,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 1,  
        24: 0,  
        20: 0,  
        4: 1,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 1,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 1,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    62: {  
        37: 0,  
        44: 0,  
        33: 1,  
        46: 1,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 1,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 0,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 1,  
        58: 1,  
        50: 0,  
        57: 1,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 0,  
        24: 0,  
        20: 0,  
        4: 0,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 0,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 0,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    61: {  
        37: 0,  
        44: 1,  
        33: 1,  
        46: 0,  
        41: 1,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 0,  
        38: 1,  
        31: 1,  
        34: 1,  
        35: 0,  
        45: 0,  
        32: 1,  
        40: 0,  
        52: 0,  
        53: 1,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 1,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 1,  
        43: 1,  
        3: 0,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 0,  
        24: 0,  
        20: 0,  
        4: 0,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 0,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 0,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    47: {  
        37: 0,  
        44: 0,  
        33: 1,  
        46: 0,  
        41: 1,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 1,  
        36: 1,  
        49: 1,  
        38: 1,  
        31: 1,  
        34: 0,  
        35: 1,  
        45: 1,  
        32: 1,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 1,  
        21: 1,  
        10: 2,  
        19: 1,  
        13: 2,  
        2: 0,  
        24: 1,  
        20: 0,  
        4: 0,  
        23: 2,  
        11: 2,  
        8: 2,  
        12: 2,  
        5: 2,  
        1: 0,  
        15: 1,  
        9: 2,  
        7: 1,  
        6: 3,  
        14: 1,  
        39: 1,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    59: {  
        37: 1,  
        44: 1,  
        33: 0,  
        46: 0,  
        41: 1,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 0,  
        35: 0,  
        45: 1,  
        32: 0,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 1,  
        57: 0,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 1,  
        10: 0,  
        19: 1,  
        13: 1,  
        2: 0,  
        24: 1,  
        20: 0,  
        4: 0,  
        23: 0,  
        11: 1,  
        8: 2,  
        12: 1,  
        5: 2,  
        1: 0,  
        15: 1,  
        9: 1,  
        7: 1,  
        6: 0,  
        14: 0,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    43: {  
        37: 0,  
        44: 0,  
        33: 1,  
        46: 1,  
        41: 0,  
        48: 1,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 1,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 1,  
        40: 1,  
        52: 0,  
        53: 0,  
        55: 1,  
        58: 0,  
        50: 1,  
        57: 0,  
        63: 1,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 1,  
        43: 1,  
        3: 0,  
        21: 1,  
        10: 1,  
        19: 1,  
        13: 1,  
        2: 0,  
        24: 0,  
        20: 1,  
        4: 0,  
        23: 1,  
        11: 1,  
        8: 1,  
        12: 1,  
        5: 2,  
        1: 0,  
        15: 1,  
        9: 1,  
        7: 1,  
        6: 0,  
        14: 0,  
        39: 0,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 1,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    3: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 1,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 3,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 3,  
        4: 3,  
        23: 3,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 2,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 2,  
        26: 3,  
        28: 3,  
        22: 3,  
        25: 3,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 2,  
        27: 3,  
        16: 3,  
    },
    21: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 1,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 2,  
        19: 1,  
        13: 2,  
        2: 3,  
        24: 2,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 1,  
        9: 3,  
        7: 3,  
        6: 2,  
        14: 3,  
        39: 0,  
        26: 2,  
        28: 1,  
        22: 1,  
        25: 2,  
        29: 3,  
        54: 2,  
        18: 3,  
        17: 2,  
        30: 1,  
        27: 2,  
        16: 3,  
    },
    10: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 2,  
        19: 2,  
        13: 3,  
        2: 3,  
        24: 1,  
        20: 3,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 1,  
        26: 2,  
        28: 2,  
        22: 2,  
        25: 3,  
        29: 2,  
        54: 2,  
        18: 3,  
        17: 3,  
        30: 1,  
        27: 1,  
        16: 3,  
    },
    19: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 2,  
        19: 1,  
        13: 3,  
        2: 3,  
        24: 0,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 0,  
        9: 3,  
        7: 2,  
        6: 2,  
        14: 3,  
        39: 1,  
        26: 1,  
        28: 1,  
        22: 2,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 1,  
        30: 1,  
        27: 1,  
        16: 0,  
    },
    13: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 3,  
        19: 2,  
        13: 2,  
        2: 3,  
        24: 2,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 1,  
        26: 2,  
        28: 3,  
        22: 2,  
        25: 2,  
        29: 1,  
        54: 2,  
        18: 3,  
        17: 3,  
        30: 1,  
        27: 2,  
        16: 3,  
    },
    2: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 3,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 3,  
        4: 2,  
        23: 3,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 3,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 2,  
        39: 2,  
        26: 3,  
        28: 3,  
        22: 3,  
        25: 3,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 2,  
        16: 3,  
    },
    24: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 1,  
        19: 2,  
        13: 3,  
        2: 3,  
        24: 2,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 2,  
        12: 1,  
        5: 3,  
        1: 2,  
        15: 1,  
        9: 2,  
        7: 2,  
        6: 1,  
        14: 3,  
        39: 1,  
        26: 0,  
        28: 1,  
        22: 2,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 2,  
        30: 1,  
        27: 1,  
        16: 1,  
    },
    20: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 3,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 2,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 3,  
        15: 0,  
        9: 3,  
        7: 2,  
        6: 2,  
        14: 3,  
        39: 0,  
        26: 0,  
        28: 1,  
        22: 2,  
        25: 1,  
        29: 0,  
        54: 2,  
        18: 3,  
        17: 2,  
        30: 1,  
        27: 1,  
        16: 3,  
    },
    4: {  
        37: 1,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 1,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 3,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 3,  
        4: 3,  
        23: 3,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 3,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 2,  
        39: 2,  
        26: 3,  
        28: 3,  
        22: 3,  
        25: 3,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 2,  
        27: 3,  
        16: 3,  
    },
    23: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 1,  
        21: 1,  
        10: 1,  
        19: 2,  
        13: 3,  
        2: 2,  
        24: 0,  
        20: 2,  
        4: 1,  
        23: 0,  
        11: 2,  
        8: 2,  
        12: 2,  
        5: 3,  
        1: 2,  
        15: 1,  
        9: 2,  
        7: 3,  
        6: 3,  
        14: 1,  
        39: 2,  
        26: 1,  
        28: 2,  
        22: 3,  
        25: 2,  
        29: 1,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 1,  
        16: 2,  
    },
    11: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 3,  
        19: 1,  
        13: 1,  
        2: 3,  
        24: 2,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 3,  
        12: 1,  
        5: 3,  
        1: 3,  
        15: 0,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 1,  
        26: 2,  
        28: 2,  
        22: 1,  
        25: 2,  
        29: 0,  
        54: 0,  
        18: 1,  
        17: 1,  
        30: 1,  
        27: 1,  
        16: 1,  
    },
    8: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 2,  
        19: 3,  
        13: 2,  
        2: 3,  
        24: 3,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 1,  
        7: 3,  
        6: 2,  
        14: 3,  
        39: 2,  
        26: 2,  
        28: 1,  
        22: 3,  
        25: 2,  
        29: 1,  
        54: 0,  
        18: 3,  
        17: 3,  
        30: 1,  
        27: 3,  
        16: 3,  
    },
    12: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 2,  
        19: 2,  
        13: 1,  
        2: 3,  
        24: 1,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 2,  
        7: 3,  
        6: 2,  
        14: 3,  
        39: 2,  
        26: 2,  
        28: 2,  
        22: 2,  
        25: 1,  
        29: 1,  
        54: 0,  
        18: 3,  
        17: 2,  
        30: 2,  
        27: 1,  
        16: 3,  
    },
    5: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 2,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 2,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 2,  
        12: 1,  
        5: 3,  
        1: 3,  
        15: 1,  
        9: 2,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 2,  
        26: 2,  
        28: 3,  
        22: 3,  
        25: 2,  
        29: 2,  
        54: 1,  
        18: 3,  
        17: 3,  
        30: 1,  
        27: 3,  
        16: 3,  
    },
    1: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 3,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 3,  
        4: 3,  
        23: 3,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 3,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 2,  
        39: 2,  
        26: 3,  
        28: 2,  
        22: 3,  
        25: 3,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 2,  
        27: 3,  
        16: 3,  
    },
    15: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 3,  
        12: 1,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 3,  
        7: 2,  
        6: 2,  
        14: 3,  
        39: 1,  
        26: 0,  
        28: 2,  
        22: 2,  
        25: 1,  
        29: 1,  
        54: 0,  
        18: 3,  
        17: 2,  
        30: 1,  
        27: 1,  
        16: 3,  
    },
    9: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 2,  
        12: 3,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 2,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 2,  
        26: 3,  
        28: 2,  
        22: 2,  
        25: 3,  
        29: 2,  
        54: 0,  
        18: 3,  
        17: 3,  
        30: 2,  
        27: 2,  
        16: 3,  
    },
    7: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 1,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 3,  
        19: 2,  
        13: 3,  
        2: 3,  
        24: 2,  
        20: 2,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 3,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 3,  
        39: 2,  
        26: 3,  
        28: 2,  
        22: 3,  
        25: 2,  
        29: 1,  
        54: 2,  
        18: 3,  
        17: 3,  
        30: 2,  
        27: 3,  
        16: 3,  
    },
    6: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 2,  
        10: 3,  
        19: 2,  
        13: 2,  
        2: 3,  
        24: 1,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 3,  
        7: 3,  
        6: 2,  
        14: 3,  
        39: 2,  
        26: 2,  
        28: 2,  
        22: 2,  
        25: 2,  
        29: 2,  
        54: 2,  
        18: 3,  
        17: 3,  
        30: 2,  
        27: 2,  
        16: 3,  
    },
    14: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 3,  
        10: 3,  
        19: 3,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 3,  
        4: 2,  
        23: 2,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 2,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 1,  
        39: 2,  
        26: 3,  
        28: 2,  
        22: 3,  
        25: 3,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 2,  
        27: 3,  
        16: 2,  
    },
    39: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 0,  
        19: 1,  
        13: 0,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 1,  
        8: 2,  
        12: 1,  
        5: 1,  
        1: 3,  
        15: 1,  
        9: 2,  
        7: 2,  
        6: 2,  
        14: 2,  
        39: 2,  
        26: 0,  
        28: 0,  
        22: 1,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 2,  
        17: 1,  
        30: 2,  
        27: 1,  
        16: 1,  
    },
    26: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 0,  
        10: 3,  
        19: 1,  
        13: 1,  
        2: 2,  
        24: 0,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 1,  
        8: 2,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 1,  
        9: 3,  
        7: 2,  
        6: 2,  
        14: 2,  
        39: 1,  
        26: 1,  
        28: 1,  
        22: 1,  
        25: 2,  
        29: 0,  
        54: 1,  
        18: 0,  
        17: 1,  
        30: 1,  
        27: 1,  
        16: 0,  
    },
    28: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 2,  
        19: 1,  
        13: 1,  
        2: 3,  
        24: 0,  
        20: 1,  
        4: 3,  
        23: 0,  
        11: 2,  
        8: 1,  
        12: 1,  
        5: 1,  
        1: 3,  
        15: 0,  
        9: 1,  
        7: 0,  
        6: 1,  
        14: 3,  
        39: 0,  
        26: 0,  
        28: 1,  
        22: 0,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 3,  
        17: 1,  
        30: 0,  
        27: 1,  
        16: 0,  
    },
    22: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 1,  
        19: 0,  
        13: 0,  
        2: 3,  
        24: 1,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 2,  
        12: 1,  
        5: 3,  
        1: 2,  
        15: 0,  
        9: 2,  
        7: 1,  
        6: 3,  
        14: 3,  
        39: 1,  
        26: 1,  
        28: 0,  
        22: 1,  
        25: 2,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 3,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    25: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 1,  
        10: 2,  
        19: 1,  
        13: 0,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 3,  
        8: 3,  
        12: 2,  
        5: 3,  
        1: 3,  
        15: 2,  
        9: 2,  
        7: 1,  
        6: 2,  
        14: 3,  
        39: 2,  
        26: 1,  
        28: 1,  
        22: 1,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 3,  
        30: 1,  
        27: 1,  
        16: 0,  
    },
    29: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 3,  
        21: 0,  
        10: 1,  
        19: 0,  
        13: 0,  
        2: 3,  
        24: 0,  
        20: 0,  
        4: 3,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 1,  
        5: 2,  
        1: 1,  
        15: 0,  
        9: 2,  
        7: 0,  
        6: 0,  
        14: 2,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 2,  
        30: 0,  
        27: 0,  
        16: 0,  
    },
    54: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 0,  
        10: 0,  
        19: 0,  
        13: 0,  
        2: 2,  
        24: 0,  
        20: 0,  
        4: 0,  
        23: 0,  
        11: 0,  
        8: 0,  
        12: 0,  
        5: 0,  
        1: 0,  
        15: 0,  
        9: 0,  
        7: 0,  
        6: 0,  
        14: 0,  
        39: 0,  
        26: 0,  
        28: 0,  
        22: 0,  
        25: 0,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 1,  
        16: 2,  
    },
    18: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 3,  
        10: 3,  
        19: 2,  
        13: 2,  
        2: 3,  
        24: 2,  
        20: 2,  
        4: 2,  
        23: 3,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 1,  
        15: 3,  
        9: 3,  
        7: 3,  
        6: 3,  
        14: 1,  
        39: 0,  
        26: 3,  
        28: 2,  
        22: 3,  
        25: 3,  
        29: 2,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 0,  
        16: 2,  
    },
    17: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 2,  
        10: 2,  
        19: 2,  
        13: 2,  
        2: 3,  
        24: 1,  
        20: 3,  
        4: 2,  
        23: 0,  
        11: 3,  
        8: 0,  
        12: 3,  
        5: 3,  
        1: 2,  
        15: 2,  
        9: 1,  
        7: 3,  
        6: 2,  
        14: 0,  
        39: 2,  
        26: 1,  
        28: 2,  
        22: 2,  
        25: 3,  
        29: 2,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 3,  
        16: 3,  
    },
    30: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 1,  
        31: 1,  
        34: 0,  
        35: 0,  
        45: 1,  
        32: 1,  
        40: 0,  
        52: 0,  
        53: 1,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 1,  
        10: 1,  
        19: 1,  
        13: 2,  
        2: 1,  
        24: 0,  
        20: 1,  
        4: 0,  
        23: 2,  
        11: 2,  
        8: 2,  
        12: 2,  
        5: 2,  
        1: 0,  
        15: 2,  
        9: 2,  
        7: 2,  
        6: 3,  
        14: 1,  
        39: 2,  
        26: 1,  
        28: 0,  
        22: 0,  
        25: 1,  
        29: 0,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 1,  
        16: 1,  
    },
    27: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 2,  
        21: 3,  
        10: 1,  
        19: 2,  
        13: 3,  
        2: 1,  
        24: 2,  
        20: 2,  
        4: 1,  
        23: 1,  
        11: 2,  
        8: 2,  
        12: 2,  
        5: 2,  
        1: 1,  
        15: 2,  
        9: 2,  
        7: 3,  
        6: 3,  
        14: 0,  
        39: 1,  
        26: 2,  
        28: 2,  
        22: 2,  
        25: 2,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 1,  
        27: 2,  
        16: 1,  
    },
    16: {  
        37: 0,  
        44: 0,  
        33: 0,  
        46: 0,  
        41: 0,  
        48: 0,  
        56: 0,  
        51: 0,  
        42: 0,  
        60: 0,  
        36: 0,  
        49: 0,  
        38: 0,  
        31: 0,  
        34: 0,  
        35: 0,  
        45: 0,  
        32: 0,  
        40: 0,  
        52: 0,  
        53: 0,  
        55: 0,  
        58: 0,  
        50: 0,  
        57: 0,  
        63: 0,  
        62: 0,  
        61: 0,  
        47: 0,  
        59: 0,  
        43: 0,  
        3: 0,  
        21: 2,  
        10: 3,  
        19: 2,  
        13: 3,  
        2: 3,  
        24: 3,  
        20: 3,  
        4: 2,  
        23: 2,  
        11: 3,  
        8: 3,  
        12: 3,  
        5: 3,  
        1: 0,  
        15: 2,  
        9: 2,  
        7: 3,  
        6: 3,  
        14: 1,  
        39: 1,  
        26: 3,  
        28: 2,  
        22: 2,  
        25: 2,  
        29: 3,  
        54: 0,  
        18: 0,  
        17: 0,  
        30: 0,  
        27: 2,  
        16: 2,  
    },
}








IBM866_RUSSIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 142,  
    66: 143,  
    67: 144,  
    68: 145,  
    69: 146,  
    70: 147,  
    71: 148,  
    72: 149,  
    73: 150,  
    74: 151,  
    75: 152,  
    76: 74,  
    77: 153,  
    78: 75,  
    79: 154,  
    80: 155,  
    81: 156,  
    82: 157,  
    83: 158,  
    84: 159,  
    85: 160,  
    86: 161,  
    87: 162,  
    88: 163,  
    89: 164,  
    90: 165,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 71,  
    98: 172,  
    99: 66,  
    100: 173,  
    101: 65,  
    102: 174,  
    103: 76,  
    104: 175,  
    105: 64,  
    106: 176,  
    107: 177,  
    108: 77,  
    109: 72,  
    110: 178,  
    111: 69,  
    112: 67,  
    113: 179,  
    114: 78,  
    115: 73,  
    116: 180,  
    117: 181,  
    118: 79,  
    119: 182,  
    120: 183,  
    121: 184,  
    122: 185,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 37,  
    129: 44,  
    130: 33,  
    131: 46,  
    132: 41,  
    133: 48,  
    134: 56,  
    135: 51,  
    136: 42,  
    137: 60,  
    138: 36,  
    139: 49,  
    140: 38,  
    141: 31,  
    142: 34,  
    143: 35,  
    144: 45,  
    145: 32,  
    146: 40,  
    147: 52,  
    148: 53,  
    149: 55,  
    150: 58,  
    151: 50,  
    152: 57,  
    153: 63,  
    154: 70,  
    155: 62,  
    156: 61,  
    157: 47,  
    158: 59,  
    159: 43,  
    160: 3,  
    161: 21,  
    162: 10,  
    163: 19,  
    164: 13,  
    165: 2,  
    166: 24,  
    167: 20,  
    168: 4,  
    169: 23,  
    170: 11,  
    171: 8,  
    172: 12,  
    173: 5,  
    174: 1,  
    175: 15,  
    176: 191,  
    177: 192,  
    178: 193,  
    179: 194,  
    180: 195,  
    181: 196,  
    182: 197,  
    183: 198,  
    184: 199,  
    185: 200,  
    186: 201,  
    187: 202,  
    188: 203,  
    189: 204,  
    190: 205,  
    191: 206,  
    192: 207,  
    193: 208,  
    194: 209,  
    195: 210,  
    196: 211,  
    197: 212,  
    198: 213,  
    199: 214,  
    200: 215,  
    201: 216,  
    202: 217,  
    203: 218,  
    204: 219,  
    205: 220,  
    206: 221,  
    207: 222,  
    208: 223,  
    209: 224,  
    210: 225,  
    211: 226,  
    212: 227,  
    213: 228,  
    214: 229,  
    215: 230,  
    216: 231,  
    217: 232,  
    218: 233,  
    219: 234,  
    220: 235,  
    221: 236,  
    222: 237,  
    223: 238,  
    224: 9,  
    225: 7,  
    226: 6,  
    227: 14,  
    228: 39,  
    229: 26,  
    230: 28,  
    231: 22,  
    232: 25,  
    233: 29,  
    234: 54,  
    235: 18,  
    236: 17,  
    237: 30,  
    238: 27,  
    239: 16,  
    240: 239,  
    241: 68,  
    242: 240,  
    243: 241,  
    244: 242,  
    245: 243,  
    246: 244,  
    247: 245,  
    248: 246,  
    249: 247,  
    250: 248,  
    251: 249,  
    252: 250,  
    253: 251,  
    254: 252,  
    255: 255,  
}

IBM866_RUSSIAN_MODEL = SingleByteCharSetModel(
    charset_name="IBM866",
    language="Russian",
    char_to_order_map=IBM866_RUSSIAN_CHAR_TO_ORDER,
    language_model=RUSSIAN_LANG_MODEL,
    typical_positive_ratio=0.976601,
    keep_ascii_letters=False,
    alphabet="ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё",
)

WINDOWS_1251_RUSSIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 142,  
    66: 143,  
    67: 144,  
    68: 145,  
    69: 146,  
    70: 147,  
    71: 148,  
    72: 149,  
    73: 150,  
    74: 151,  
    75: 152,  
    76: 74,  
    77: 153,  
    78: 75,  
    79: 154,  
    80: 155,  
    81: 156,  
    82: 157,  
    83: 158,  
    84: 159,  
    85: 160,  
    86: 161,  
    87: 162,  
    88: 163,  
    89: 164,  
    90: 165,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 71,  
    98: 172,  
    99: 66,  
    100: 173,  
    101: 65,  
    102: 174,  
    103: 76,  
    104: 175,  
    105: 64,  
    106: 176,  
    107: 177,  
    108: 77,  
    109: 72,  
    110: 178,  
    111: 69,  
    112: 67,  
    113: 179,  
    114: 78,  
    115: 73,  
    116: 180,  
    117: 181,  
    118: 79,  
    119: 182,  
    120: 183,  
    121: 184,  
    122: 185,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 191,  
    129: 192,  
    130: 193,  
    131: 194,  
    132: 195,  
    133: 196,  
    134: 197,  
    135: 198,  
    136: 199,  
    137: 200,  
    138: 201,  
    139: 202,  
    140: 203,  
    141: 204,  
    142: 205,  
    143: 206,  
    144: 207,  
    145: 208,  
    146: 209,  
    147: 210,  
    148: 211,  
    149: 212,  
    150: 213,  
    151: 214,  
    152: 215,  
    153: 216,  
    154: 217,  
    155: 218,  
    156: 219,  
    157: 220,  
    158: 221,  
    159: 222,  
    160: 223,  
    161: 224,  
    162: 225,  
    163: 226,  
    164: 227,  
    165: 228,  
    166: 229,  
    167: 230,  
    168: 231,  
    169: 232,  
    170: 233,  
    171: 234,  
    172: 235,  
    173: 236,  
    174: 237,  
    175: 238,  
    176: 239,  
    177: 240,  
    178: 241,  
    179: 242,  
    180: 243,  
    181: 244,  
    182: 245,  
    183: 246,  
    184: 68,  
    185: 247,  
    186: 248,  
    187: 249,  
    188: 250,  
    189: 251,  
    190: 252,  
    191: 253,  
    192: 37,  
    193: 44,  
    194: 33,  
    195: 46,  
    196: 41,  
    197: 48,  
    198: 56,  
    199: 51,  
    200: 42,  
    201: 60,  
    202: 36,  
    203: 49,  
    204: 38,  
    205: 31,  
    206: 34,  
    207: 35,  
    208: 45,  
    209: 32,  
    210: 40,  
    211: 52,  
    212: 53,  
    213: 55,  
    214: 58,  
    215: 50,  
    216: 57,  
    217: 63,  
    218: 70,  
    219: 62,  
    220: 61,  
    221: 47,  
    222: 59,  
    223: 43,  
    224: 3,  
    225: 21,  
    226: 10,  
    227: 19,  
    228: 13,  
    229: 2,  
    230: 24,  
    231: 20,  
    232: 4,  
    233: 23,  
    234: 11,  
    235: 8,  
    236: 12,  
    237: 5,  
    238: 1,  
    239: 15,  
    240: 9,  
    241: 7,  
    242: 6,  
    243: 14,  
    244: 39,  
    245: 26,  
    246: 28,  
    247: 22,  
    248: 25,  
    249: 29,  
    250: 54,  
    251: 18,  
    252: 17,  
    253: 30,  
    254: 27,  
    255: 16,  
}

WINDOWS_1251_RUSSIAN_MODEL = SingleByteCharSetModel(
    charset_name="windows-1251",
    language="Russian",
    char_to_order_map=WINDOWS_1251_RUSSIAN_CHAR_TO_ORDER,
    language_model=RUSSIAN_LANG_MODEL,
    typical_positive_ratio=0.976601,
    keep_ascii_letters=False,
    alphabet="ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё",
)

IBM855_RUSSIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 142,  
    66: 143,  
    67: 144,  
    68: 145,  
    69: 146,  
    70: 147,  
    71: 148,  
    72: 149,  
    73: 150,  
    74: 151,  
    75: 152,  
    76: 74,  
    77: 153,  
    78: 75,  
    79: 154,  
    80: 155,  
    81: 156,  
    82: 157,  
    83: 158,  
    84: 159,  
    85: 160,  
    86: 161,  
    87: 162,  
    88: 163,  
    89: 164,  
    90: 165,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 71,  
    98: 172,  
    99: 66,  
    100: 173,  
    101: 65,  
    102: 174,  
    103: 76,  
    104: 175,  
    105: 64,  
    106: 176,  
    107: 177,  
    108: 77,  
    109: 72,  
    110: 178,  
    111: 69,  
    112: 67,  
    113: 179,  
    114: 78,  
    115: 73,  
    116: 180,  
    117: 181,  
    118: 79,  
    119: 182,  
    120: 183,  
    121: 184,  
    122: 185,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 191,  
    129: 192,  
    130: 193,  
    131: 194,  
    132: 68,  
    133: 195,  
    134: 196,  
    135: 197,  
    136: 198,  
    137: 199,  
    138: 200,  
    139: 201,  
    140: 202,  
    141: 203,  
    142: 204,  
    143: 205,  
    144: 206,  
    145: 207,  
    146: 208,  
    147: 209,  
    148: 210,  
    149: 211,  
    150: 212,  
    151: 213,  
    152: 214,  
    153: 215,  
    154: 216,  
    155: 217,  
    156: 27,  
    157: 59,  
    158: 54,  
    159: 70,  
    160: 3,  
    161: 37,  
    162: 21,  
    163: 44,  
    164: 28,  
    165: 58,  
    166: 13,  
    167: 41,  
    168: 2,  
    169: 48,  
    170: 39,  
    171: 53,  
    172: 19,  
    173: 46,  
    174: 218,  
    175: 219,  
    176: 220,  
    177: 221,  
    178: 222,  
    179: 223,  
    180: 224,  
    181: 26,  
    182: 55,  
    183: 4,  
    184: 42,  
    185: 225,  
    186: 226,  
    187: 227,  
    188: 228,  
    189: 23,  
    190: 60,  
    191: 229,  
    192: 230,  
    193: 231,  
    194: 232,  
    195: 233,  
    196: 234,  
    197: 235,  
    198: 11,  
    199: 36,  
    200: 236,  
    201: 237,  
    202: 238,  
    203: 239,  
    204: 240,  
    205: 241,  
    206: 242,  
    207: 243,  
    208: 8,  
    209: 49,  
    210: 12,  
    211: 38,  
    212: 5,  
    213: 31,  
    214: 1,  
    215: 34,  
    216: 15,  
    217: 244,  
    218: 245,  
    219: 246,  
    220: 247,  
    221: 35,  
    222: 16,  
    223: 248,  
    224: 43,  
    225: 9,  
    226: 45,  
    227: 7,  
    228: 32,  
    229: 6,  
    230: 40,  
    231: 14,  
    232: 52,  
    233: 24,  
    234: 56,  
    235: 10,  
    236: 33,  
    237: 17,  
    238: 61,  
    239: 249,  
    240: 250,  
    241: 18,  
    242: 62,  
    243: 20,  
    244: 51,  
    245: 25,  
    246: 57,  
    247: 30,  
    248: 47,  
    249: 29,  
    250: 63,  
    251: 22,  
    252: 50,  
    253: 251,  
    254: 252,  
    255: 255,  
}

IBM855_RUSSIAN_MODEL = SingleByteCharSetModel(
    charset_name="IBM855",
    language="Russian",
    char_to_order_map=IBM855_RUSSIAN_CHAR_TO_ORDER,
    language_model=RUSSIAN_LANG_MODEL,
    typical_positive_ratio=0.976601,
    keep_ascii_letters=False,
    alphabet="ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё",
)

KOI8_R_RUSSIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 142,  
    66: 143,  
    67: 144,  
    68: 145,  
    69: 146,  
    70: 147,  
    71: 148,  
    72: 149,  
    73: 150,  
    74: 151,  
    75: 152,  
    76: 74,  
    77: 153,  
    78: 75,  
    79: 154,  
    80: 155,  
    81: 156,  
    82: 157,  
    83: 158,  
    84: 159,  
    85: 160,  
    86: 161,  
    87: 162,  
    88: 163,  
    89: 164,  
    90: 165,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 71,  
    98: 172,  
    99: 66,  
    100: 173,  
    101: 65,  
    102: 174,  
    103: 76,  
    104: 175,  
    105: 64,  
    106: 176,  
    107: 177,  
    108: 77,  
    109: 72,  
    110: 178,  
    111: 69,  
    112: 67,  
    113: 179,  
    114: 78,  
    115: 73,  
    116: 180,  
    117: 181,  
    118: 79,  
    119: 182,  
    120: 183,  
    121: 184,  
    122: 185,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 191,  
    129: 192,  
    130: 193,  
    131: 194,  
    132: 195,  
    133: 196,  
    134: 197,  
    135: 198,  
    136: 199,  
    137: 200,  
    138: 201,  
    139: 202,  
    140: 203,  
    141: 204,  
    142: 205,  
    143: 206,  
    144: 207,  
    145: 208,  
    146: 209,  
    147: 210,  
    148: 211,  
    149: 212,  
    150: 213,  
    151: 214,  
    152: 215,  
    153: 216,  
    154: 217,  
    155: 218,  
    156: 219,  
    157: 220,  
    158: 221,  
    159: 222,  
    160: 223,  
    161: 224,  
    162: 225,  
    163: 68,  
    164: 226,  
    165: 227,  
    166: 228,  
    167: 229,  
    168: 230,  
    169: 231,  
    170: 232,  
    171: 233,  
    172: 234,  
    173: 235,  
    174: 236,  
    175: 237,  
    176: 238,  
    177: 239,  
    178: 240,  
    179: 241,  
    180: 242,  
    181: 243,  
    182: 244,  
    183: 245,  
    184: 246,  
    185: 247,  
    186: 248,  
    187: 249,  
    188: 250,  
    189: 251,  
    190: 252,  
    191: 253,  
    192: 27,  
    193: 3,  
    194: 21,  
    195: 28,  
    196: 13,  
    197: 2,  
    198: 39,  
    199: 19,  
    200: 26,  
    201: 4,  
    202: 23,  
    203: 11,  
    204: 8,  
    205: 12,  
    206: 5,  
    207: 1,  
    208: 15,  
    209: 16,  
    210: 9,  
    211: 7,  
    212: 6,  
    213: 14,  
    214: 24,  
    215: 10,  
    216: 17,  
    217: 18,  
    218: 20,  
    219: 25,  
    220: 30,  
    221: 29,  
    222: 22,  
    223: 54,  
    224: 59,  
    225: 37,  
    226: 44,  
    227: 58,  
    228: 41,  
    229: 48,  
    230: 53,  
    231: 46,  
    232: 55,  
    233: 42,  
    234: 60,  
    235: 36,  
    236: 49,  
    237: 38,  
    238: 31,  
    239: 34,  
    240: 35,  
    241: 43,  
    242: 45,  
    243: 32,  
    244: 40,  
    245: 52,  
    246: 56,  
    247: 33,  
    248: 61,  
    249: 62,  
    250: 51,  
    251: 57,  
    252: 47,  
    253: 63,  
    254: 50,  
    255: 70,  
}

KOI8_R_RUSSIAN_MODEL = SingleByteCharSetModel(
    charset_name="KOI8-R",
    language="Russian",
    char_to_order_map=KOI8_R_RUSSIAN_CHAR_TO_ORDER,
    language_model=RUSSIAN_LANG_MODEL,
    typical_positive_ratio=0.976601,
    keep_ascii_letters=False,
    alphabet="ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё",
)

MACCYRILLIC_RUSSIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 142,  
    66: 143,  
    67: 144,  
    68: 145,  
    69: 146,  
    70: 147,  
    71: 148,  
    72: 149,  
    73: 150,  
    74: 151,  
    75: 152,  
    76: 74,  
    77: 153,  
    78: 75,  
    79: 154,  
    80: 155,  
    81: 156,  
    82: 157,  
    83: 158,  
    84: 159,  
    85: 160,  
    86: 161,  
    87: 162,  
    88: 163,  
    89: 164,  
    90: 165,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 71,  
    98: 172,  
    99: 66,  
    100: 173,  
    101: 65,  
    102: 174,  
    103: 76,  
    104: 175,  
    105: 64,  
    106: 176,  
    107: 177,  
    108: 77,  
    109: 72,  
    110: 178,  
    111: 69,  
    112: 67,  
    113: 179,  
    114: 78,  
    115: 73,  
    116: 180,  
    117: 181,  
    118: 79,  
    119: 182,  
    120: 183,  
    121: 184,  
    122: 185,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 37,  
    129: 44,  
    130: 33,  
    131: 46,  
    132: 41,  
    133: 48,  
    134: 56,  
    135: 51,  
    136: 42,  
    137: 60,  
    138: 36,  
    139: 49,  
    140: 38,  
    141: 31,  
    142: 34,  
    143: 35,  
    144: 45,  
    145: 32,  
    146: 40,  
    147: 52,  
    148: 53,  
    149: 55,  
    150: 58,  
    151: 50,  
    152: 57,  
    153: 63,  
    154: 70,  
    155: 62,  
    156: 61,  
    157: 47,  
    158: 59,  
    159: 43,  
    160: 191,  
    161: 192,  
    162: 193,  
    163: 194,  
    164: 195,  
    165: 196,  
    166: 197,  
    167: 198,  
    168: 199,  
    169: 200,  
    170: 201,  
    171: 202,  
    172: 203,  
    173: 204,  
    174: 205,  
    175: 206,  
    176: 207,  
    177: 208,  
    178: 209,  
    179: 210,  
    180: 211,  
    181: 212,  
    182: 213,  
    183: 214,  
    184: 215,  
    185: 216,  
    186: 217,  
    187: 218,  
    188: 219,  
    189: 220,  
    190: 221,  
    191: 222,  
    192: 223,  
    193: 224,  
    194: 225,  
    195: 226,  
    196: 227,  
    197: 228,  
    198: 229,  
    199: 230,  
    200: 231,  
    201: 232,  
    202: 233,  
    203: 234,  
    204: 235,  
    205: 236,  
    206: 237,  
    207: 238,  
    208: 239,  
    209: 240,  
    210: 241,  
    211: 242,  
    212: 243,  
    213: 244,  
    214: 245,  
    215: 246,  
    216: 247,  
    217: 248,  
    218: 249,  
    219: 250,  
    220: 251,  
    221: 252,  
    222: 68,  
    223: 16,  
    224: 3,  
    225: 21,  
    226: 10,  
    227: 19,  
    228: 13,  
    229: 2,  
    230: 24,  
    231: 20,  
    232: 4,  
    233: 23,  
    234: 11,  
    235: 8,  
    236: 12,  
    237: 5,  
    238: 1,  
    239: 15,  
    240: 9,  
    241: 7,  
    242: 6,  
    243: 14,  
    244: 39,  
    245: 26,  
    246: 28,  
    247: 22,  
    248: 25,  
    249: 29,  
    250: 54,  
    251: 18,  
    252: 17,  
    253: 30,  
    254: 27,  
    255: 255,  
}

MACCYRILLIC_RUSSIAN_MODEL = SingleByteCharSetModel(
    charset_name="MacCyrillic",
    language="Russian",
    char_to_order_map=MACCYRILLIC_RUSSIAN_CHAR_TO_ORDER,
    language_model=RUSSIAN_LANG_MODEL,
    typical_positive_ratio=0.976601,
    keep_ascii_letters=False,
    alphabet="ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё",
)

ISO_8859_5_RUSSIAN_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 254,  
    11: 255,  
    12: 255,  
    13: 254,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 253,  
    33: 253,  
    34: 253,  
    35: 253,  
    36: 253,  
    37: 253,  
    38: 253,  
    39: 253,  
    40: 253,  
    41: 253,  
    42: 253,  
    43: 253,  
    44: 253,  
    45: 253,  
    46: 253,  
    47: 253,  
    48: 252,  
    49: 252,  
    50: 252,  
    51: 252,  
    52: 252,  
    53: 252,  
    54: 252,  
    55: 252,  
    56: 252,  
    57: 252,  
    58: 253,  
    59: 253,  
    60: 253,  
    61: 253,  
    62: 253,  
    63: 253,  
    64: 253,  
    65: 142,  
    66: 143,  
    67: 144,  
    68: 145,  
    69: 146,  
    70: 147,  
    71: 148,  
    72: 149,  
    73: 150,  
    74: 151,  
    75: 152,  
    76: 74,  
    77: 153,  
    78: 75,  
    79: 154,  
    80: 155,  
    81: 156,  
    82: 157,  
    83: 158,  
    84: 159,  
    85: 160,  
    86: 161,  
    87: 162,  
    88: 163,  
    89: 164,  
    90: 165,  
    91: 253,  
    92: 253,  
    93: 253,  
    94: 253,  
    95: 253,  
    96: 253,  
    97: 71,  
    98: 172,  
    99: 66,  
    100: 173,  
    101: 65,  
    102: 174,  
    103: 76,  
    104: 175,  
    105: 64,  
    106: 176,  
    107: 177,  
    108: 77,  
    109: 72,  
    110: 178,  
    111: 69,  
    112: 67,  
    113: 179,  
    114: 78,  
    115: 73,  
    116: 180,  
    117: 181,  
    118: 79,  
    119: 182,  
    120: 183,  
    121: 184,  
    122: 185,  
    123: 253,  
    124: 253,  
    125: 253,  
    126: 253,  
    127: 253,  
    128: 191,  
    129: 192,  
    130: 193,  
    131: 194,  
    132: 195,  
    133: 196,  
    134: 197,  
    135: 198,  
    136: 199,  
    137: 200,  
    138: 201,  
    139: 202,  
    140: 203,  
    141: 204,  
    142: 205,  
    143: 206,  
    144: 207,  
    145: 208,  
    146: 209,  
    147: 210,  
    148: 211,  
    149: 212,  
    150: 213,  
    151: 214,  
    152: 215,  
    153: 216,  
    154: 217,  
    155: 218,  
    156: 219,  
    157: 220,  
    158: 221,  
    159: 222,  
    160: 223,  
    161: 224,  
    162: 225,  
    163: 226,  
    164: 227,  
    165: 228,  
    166: 229,  
    167: 230,  
    168: 231,  
    169: 232,  
    170: 233,  
    171: 234,  
    172: 235,  
    173: 236,  
    174: 237,  
    175: 238,  
    176: 37,  
    177: 44,  
    178: 33,  
    179: 46,  
    180: 41,  
    181: 48,  
    182: 56,  
    183: 51,  
    184: 42,  
    185: 60,  
    186: 36,  
    187: 49,  
    188: 38,  
    189: 31,  
    190: 34,  
    191: 35,  
    192: 45,  
    193: 32,  
    194: 40,  
    195: 52,  
    196: 53,  
    197: 55,  
    198: 58,  
    199: 50,  
    200: 57,  
    201: 63,  
    202: 70,  
    203: 62,  
    204: 61,  
    205: 47,  
    206: 59,  
    207: 43,  
    208: 3,  
    209: 21,  
    210: 10,  
    211: 19,  
    212: 13,  
    213: 2,  
    214: 24,  
    215: 20,  
    216: 4,  
    217: 23,  
    218: 11,  
    219: 8,  
    220: 12,  
    221: 5,  
    222: 1,  
    223: 15,  
    224: 9,  
    225: 7,  
    226: 6,  
    227: 14,  
    228: 39,  
    229: 26,  
    230: 28,  
    231: 22,  
    232: 25,  
    233: 29,  
    234: 54,  
    235: 18,  
    236: 17,  
    237: 30,  
    238: 27,  
    239: 16,  
    240: 239,  
    241: 68,  
    242: 240,  
    243: 241,  
    244: 242,  
    245: 243,  
    246: 244,  
    247: 245,  
    248: 246,  
    249: 247,  
    250: 248,  
    251: 249,  
    252: 250,  
    253: 251,  
    254: 252,  
    255: 255,  
}

ISO_8859_5_RUSSIAN_MODEL = SingleByteCharSetModel(
    charset_name="ISO-8859-5",
    language="Russian",
    char_to_order_map=ISO_8859_5_RUSSIAN_CHAR_TO_ORDER,
    language_model=RUSSIAN_LANG_MODEL,
    typical_positive_ratio=0.976601,
    keep_ascii_letters=False,
    alphabet="ЁАБВГДЕЖЗИЙКЛМНОПРСТУФХЦЧШЩЪЫЬЭЮЯабвгдежзийклмнопрстуфхцчшщъыьэюяё",
)
