from pip._vendor.chardet.sbcharsetprober import SingleByteCharSetModel






TURKISH_LANG_MODEL = {
    23: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 0,  
        12: 2,  
        2: 3,  
        18: 0,  
        27: 1,  
        25: 1,  
        3: 1,  
        24: 0,  
        10: 2,  
        5: 1,  
        13: 1,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 1,  
        8: 1,  
        9: 1,  
        14: 1,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 3,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 0,  
        19: 0,  
    },
    37: {  
        23: 0,  
        37: 0,  
        47: 2,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 1,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 1,  
        31: 0,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 2,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 0,  
        13: 1,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 1,  
        19: 1,  
    },
    47: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 1,  
        20: 0,  
        46: 1,  
        42: 0,  
        48: 1,  
        44: 1,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 2,  
        10: 1,  
        5: 2,  
        13: 2,  
        4: 2,  
        15: 1,  
        26: 0,  
        7: 2,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 0,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 0,  
        41: 1,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    39: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 1,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 2,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 1,  
        13: 3,  
        4: 0,  
        15: 1,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 1,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 1,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 1,  
        41: 0,  
        6: 1,  
        40: 1,  
        19: 0,  
    },
    29: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 1,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 0,  
        12: 2,  
        2: 3,  
        18: 0,  
        27: 1,  
        25: 0,  
        3: 1,  
        24: 1,  
        10: 0,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 1,  
        9: 1,  
        14: 1,  
        32: 1,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    52: {  
        23: 0,  
        37: 1,  
        47: 1,  
        39: 1,  
        29: 1,  
        52: 2,  
        36: 0,  
        45: 2,  
        53: 1,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 1,  
        46: 1,  
        42: 1,  
        48: 2,  
        44: 1,  
        35: 1,  
        31: 1,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 2,  
        56: 0,  
        1: 0,  
        21: 1,  
        28: 1,  
        12: 1,  
        2: 0,  
        18: 1,  
        27: 0,  
        25: 0,  
        3: 2,  
        24: 1,  
        10: 0,  
        5: 0,  
        13: 1,  
        4: 2,  
        15: 1,  
        26: 0,  
        7: 2,  
        8: 1,  
        9: 1,  
        14: 1,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 1,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 1,  
        55: 2,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 2,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 2,  
        40: 0,  
        19: 2,  
    },
    36: {  
        23: 1,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 2,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 0,  
        46: 2,  
        42: 1,  
        48: 1,  
        44: 1,  
        35: 1,  
        31: 0,  
        51: 1,  
        38: 2,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 1,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 1,  
        10: 1,  
        5: 0,  
        13: 3,  
        4: 2,  
        15: 0,  
        26: 1,  
        7: 0,  
        8: 1,  
        9: 1,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 1,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 2,  
        55: 0,  
        59: 1,  
        33: 2,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 2,  
        40: 2,  
        19: 1,  
    },
    45: {  
        23: 0,  
        37: 1,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 2,  
        45: 1,  
        53: 1,  
        60: 0,  
        16: 2,  
        49: 1,  
        20: 0,  
        46: 1,  
        42: 1,  
        48: 1,  
        44: 0,  
        35: 2,  
        31: 0,  
        51: 1,  
        38: 2,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 2,  
        24: 0,  
        10: 1,  
        5: 0,  
        13: 2,  
        4: 0,  
        15: 1,  
        26: 1,  
        7: 1,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 2,  
        41: 1,  
        6: 0,  
        40: 2,  
        19: 1,  
    },
    53: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 2,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 2,  
        13: 2,  
        4: 0,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 1,  
        19: 1,  
    },
    60: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 0,  
        21: 1,  
        28: 0,  
        12: 1,  
        2: 0,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 1,  
        24: 0,  
        10: 0,  
        5: 0,  
        13: 0,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 1,  
        9: 0,  
        14: 0,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 0,  
        19: 0,  
    },
    16: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 3,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 2,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 1,  
        18: 3,  
        27: 3,  
        25: 3,  
        3: 3,  
        24: 2,  
        10: 3,  
        5: 0,  
        13: 0,  
        4: 3,  
        15: 0,  
        26: 1,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 0,  
        32: 3,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 1,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    49: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 2,  
        52: 0,  
        36: 1,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 2,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 0,  
        21: 3,  
        28: 0,  
        12: 2,  
        2: 0,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 2,  
        24: 0,  
        10: 1,  
        5: 0,  
        13: 0,  
        4: 2,  
        15: 1,  
        26: 1,  
        7: 1,  
        8: 1,  
        9: 1,  
        14: 0,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 2,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 1,  
        30: 1,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    20: {  
        23: 1,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 3,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 2,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 0,  
        27: 1,  
        25: 1,  
        3: 2,  
        24: 2,  
        10: 2,  
        5: 2,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 1,  
        7: 3,  
        8: 0,  
        9: 2,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    46: {  
        23: 0,  
        37: 1,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 1,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 0,  
        46: 1,  
        42: 0,  
        48: 0,  
        44: 1,  
        35: 1,  
        31: 0,  
        51: 1,  
        38: 2,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 1,  
        25: 0,  
        3: 0,  
        24: 2,  
        10: 1,  
        5: 1,  
        13: 3,  
        4: 2,  
        15: 1,  
        26: 1,  
        7: 1,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 1,  
        11: 1,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 0,  
        41: 1,  
        6: 2,  
        40: 1,  
        19: 1,  
    },
    42: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 0,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 1,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 2,  
        44: 1,  
        35: 1,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 3,  
        13: 3,  
        4: 0,  
        15: 1,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 2,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 1,  
        41: 2,  
        6: 1,  
        40: 1,  
        19: 1,  
    },
    48: {  
        23: 0,  
        37: 0,  
        47: 2,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 1,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 0,  
        46: 1,  
        42: 1,  
        48: 1,  
        44: 0,  
        35: 1,  
        31: 0,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 2,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 1,  
        5: 0,  
        13: 2,  
        4: 0,  
        15: 2,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 2,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 2,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 2,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 0,  
        40: 2,  
        19: 1,  
    },
    44: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 1,  
        28: 1,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 1,  
        5: 2,  
        13: 2,  
        4: 0,  
        15: 1,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 1,  
        22: 2,  
        63: 0,  
        54: 0,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 1,  
        17: 1,  
        30: 1,  
        41: 0,  
        6: 2,  
        40: 1,  
        19: 1,  
    },
    35: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 1,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 1,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 1,  
        5: 1,  
        13: 2,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 1,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 2,  
        50: 2,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 2,  
        19: 1,  
    },
    31: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 2,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 2,  
        28: 0,  
        12: 1,  
        2: 3,  
        18: 2,  
        27: 2,  
        25: 0,  
        3: 1,  
        24: 1,  
        10: 2,  
        5: 2,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 2,  
        7: 2,  
        8: 0,  
        9: 2,  
        14: 2,  
        32: 1,  
        57: 1,  
        58: 1,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    51: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 1,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 1,  
        49: 0,  
        20: 0,  
        46: 1,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 1,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 1,  
        5: 1,  
        13: 3,  
        4: 2,  
        15: 0,  
        26: 1,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 2,  
        40: 0,  
        19: 1,  
    },
    38: {  
        23: 1,  
        37: 1,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 3,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 1,  
        35: 0,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 2,  
        13: 2,  
        4: 0,  
        15: 2,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 1,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 1,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 1,  
        55: 0,  
        59: 1,  
        33: 2,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 3,  
        40: 2,  
        19: 1,  
    },
    62: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 0,  
        21: 0,  
        28: 0,  
        12: 0,  
        2: 0,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 0,  
        13: 0,  
        4: 0,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 0,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 0,  
        19: 0,  
    },
    43: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 0,  
        45: 1,  
        53: 1,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 0,  
        46: 2,  
        42: 0,  
        48: 2,  
        44: 1,  
        35: 1,  
        31: 0,  
        51: 1,  
        38: 2,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 1,  
        10: 1,  
        5: 1,  
        13: 3,  
        4: 0,  
        15: 2,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 1,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 2,  
        55: 1,  
        59: 1,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 0,  
        40: 2,  
        19: 1,  
    },
    56: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 2,  
        1: 2,  
        21: 1,  
        28: 0,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 2,  
        24: 1,  
        10: 0,  
        5: 0,  
        13: 1,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 1,  
        8: 1,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 1,  
        40: 0,  
        19: 0,  
    },
    1: {  
        23: 3,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 3,  
        52: 0,  
        36: 1,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 3,  
        46: 1,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 3,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 2,  
        1: 2,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 2,  
        18: 3,  
        27: 3,  
        25: 3,  
        3: 3,  
        24: 3,  
        10: 3,  
        5: 0,  
        13: 2,  
        4: 3,  
        15: 1,  
        26: 3,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 3,  
        57: 2,  
        58: 0,  
        11: 3,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 1,  
        34: 1,  
        17: 3,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 1,  
    },
    21: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 1,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 2,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 2,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 0,  
        27: 3,  
        25: 1,  
        3: 3,  
        24: 2,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 3,  
        7: 1,  
        8: 2,  
        9: 2,  
        14: 2,  
        32: 1,  
        57: 0,  
        58: 1,  
        11: 3,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 1,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    28: {  
        23: 0,  
        37: 1,  
        47: 1,  
        39: 1,  
        29: 2,  
        52: 0,  
        36: 2,  
        45: 2,  
        53: 1,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 2,  
        46: 1,  
        42: 1,  
        48: 2,  
        44: 1,  
        35: 1,  
        31: 2,  
        51: 2,  
        38: 2,  
        62: 0,  
        43: 3,  
        56: 0,  
        1: 1,  
        21: 1,  
        28: 2,  
        12: 2,  
        2: 1,  
        18: 1,  
        27: 2,  
        25: 2,  
        3: 3,  
        24: 1,  
        10: 3,  
        5: 0,  
        13: 2,  
        4: 3,  
        15: 2,  
        26: 2,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 1,  
        32: 0,  
        57: 1,  
        58: 0,  
        11: 2,  
        22: 1,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 1,  
        59: 0,  
        33: 0,  
        61: 1,  
        34: 2,  
        17: 2,  
        30: 2,  
        41: 1,  
        6: 3,  
        40: 0,  
        19: 2,  
    },
    12: {  
        23: 1,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 2,  
        16: 3,  
        49: 0,  
        20: 3,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 1,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 2,  
        28: 1,  
        12: 3,  
        2: 3,  
        18: 1,  
        27: 3,  
        25: 3,  
        3: 2,  
        24: 3,  
        10: 2,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 1,  
        26: 2,  
        7: 3,  
        8: 2,  
        9: 2,  
        14: 3,  
        32: 1,  
        57: 0,  
        58: 1,  
        11: 3,  
        22: 1,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    2: {  
        23: 2,  
        37: 0,  
        47: 2,  
        39: 0,  
        29: 3,  
        52: 1,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 1,  
        49: 0,  
        20: 3,  
        46: 1,  
        42: 0,  
        48: 1,  
        44: 1,  
        35: 0,  
        31: 3,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 2,  
        18: 3,  
        27: 3,  
        25: 3,  
        3: 3,  
        24: 3,  
        10: 3,  
        5: 0,  
        13: 2,  
        4: 3,  
        15: 1,  
        26: 3,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 3,  
        57: 2,  
        58: 0,  
        11: 3,  
        22: 1,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 1,  
        17: 3,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    18: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 1,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 2,  
        27: 1,  
        25: 1,  
        3: 1,  
        24: 1,  
        10: 1,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 2,  
        7: 1,  
        8: 3,  
        9: 3,  
        14: 1,  
        32: 2,  
        57: 0,  
        58: 0,  
        11: 1,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 1,  
        40: 0,  
        19: 0,  
    },
    27: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 1,  
        31: 1,  
        51: 0,  
        38: 2,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 1,  
        28: 0,  
        12: 1,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 1,  
        3: 2,  
        24: 3,  
        10: 2,  
        5: 3,  
        13: 3,  
        4: 2,  
        15: 0,  
        26: 1,  
        7: 2,  
        8: 2,  
        9: 3,  
        14: 3,  
        32: 1,  
        57: 0,  
        58: 0,  
        11: 1,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    25: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 2,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 0,  
        12: 2,  
        2: 3,  
        18: 0,  
        27: 1,  
        25: 2,  
        3: 2,  
        24: 3,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 1,  
        26: 1,  
        7: 3,  
        8: 3,  
        9: 2,  
        14: 3,  
        32: 2,  
        57: 1,  
        58: 0,  
        11: 1,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    3: {  
        23: 2,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 3,  
        49: 0,  
        20: 3,  
        46: 0,  
        42: 1,  
        48: 0,  
        44: 0,  
        35: 1,  
        31: 2,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 2,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 2,  
        27: 3,  
        25: 1,  
        3: 3,  
        24: 2,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 1,  
        26: 3,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 2,  
        57: 1,  
        58: 1,  
        11: 3,  
        22: 1,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 1,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 0,  
        17: 3,  
        30: 0,  
        41: 1,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    24: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 2,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 1,  
        28: 1,  
        12: 3,  
        2: 3,  
        18: 2,  
        27: 1,  
        25: 1,  
        3: 2,  
        24: 1,  
        10: 2,  
        5: 2,  
        13: 3,  
        4: 2,  
        15: 0,  
        26: 1,  
        7: 2,  
        8: 3,  
        9: 2,  
        14: 3,  
        32: 2,  
        57: 0,  
        58: 2,  
        11: 1,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    10: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 3,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 2,  
        28: 0,  
        12: 2,  
        2: 3,  
        18: 1,  
        27: 2,  
        25: 2,  
        3: 3,  
        24: 2,  
        10: 2,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 3,  
        7: 2,  
        8: 2,  
        9: 2,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 1,  
        11: 3,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 1,  
        17: 3,  
        30: 1,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 1,  
    },
    5: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 3,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 0,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 1,  
        18: 3,  
        27: 3,  
        25: 2,  
        3: 3,  
        24: 2,  
        10: 3,  
        5: 1,  
        13: 1,  
        4: 3,  
        15: 0,  
        26: 2,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 2,  
        32: 2,  
        57: 0,  
        58: 0,  
        11: 3,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    13: {  
        23: 1,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 3,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 3,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 3,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 2,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 2,  
        18: 3,  
        27: 3,  
        25: 3,  
        3: 3,  
        24: 3,  
        10: 3,  
        5: 0,  
        13: 2,  
        4: 3,  
        15: 1,  
        26: 2,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 2,  
        32: 2,  
        57: 1,  
        58: 0,  
        11: 3,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 3,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 1,  
    },
    4: {  
        23: 1,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 1,  
        53: 0,  
        60: 2,  
        16: 3,  
        49: 0,  
        20: 3,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 2,  
        28: 1,  
        12: 3,  
        2: 3,  
        18: 1,  
        27: 2,  
        25: 3,  
        3: 2,  
        24: 2,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 1,  
        26: 3,  
        7: 2,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 2,  
        57: 0,  
        58: 2,  
        11: 3,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 0,  
        6: 1,  
        40: 0,  
        19: 0,  
    },
    15: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 1,  
        45: 1,  
        53: 1,  
        60: 0,  
        16: 3,  
        49: 2,  
        20: 0,  
        46: 2,  
        42: 1,  
        48: 2,  
        44: 1,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 1,  
        24: 2,  
        10: 1,  
        5: 3,  
        13: 3,  
        4: 2,  
        15: 2,  
        26: 0,  
        7: 1,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 2,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 2,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 2,  
        41: 2,  
        6: 3,  
        40: 2,  
        19: 2,  
    },
    26: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 1,  
        28: 0,  
        12: 1,  
        2: 3,  
        18: 0,  
        27: 1,  
        25: 1,  
        3: 2,  
        24: 3,  
        10: 1,  
        5: 3,  
        13: 3,  
        4: 2,  
        15: 0,  
        26: 2,  
        7: 2,  
        8: 1,  
        9: 1,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 1,  
        11: 1,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    7: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 1,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 2,  
        16: 3,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 1,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 1,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 3,  
        3: 2,  
        24: 2,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 2,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 2,  
        57: 0,  
        58: 1,  
        11: 2,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 0,  
        17: 3,  
        30: 0,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    8: {  
        23: 1,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 1,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 3,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 2,  
        28: 1,  
        12: 3,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 2,  
        3: 2,  
        24: 3,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 3,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 2,  
        57: 0,  
        58: 1,  
        11: 2,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 1,  
    },
    9: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 3,  
        49: 0,  
        20: 2,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 2,  
        27: 2,  
        25: 2,  
        3: 2,  
        24: 2,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 2,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 3,  
        57: 0,  
        58: 2,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    14: {  
        23: 3,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 3,  
        52: 0,  
        36: 0,  
        45: 1,  
        53: 0,  
        60: 1,  
        16: 0,  
        49: 0,  
        20: 3,  
        46: 2,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 3,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 1,  
        56: 2,  
        1: 2,  
        21: 3,  
        28: 0,  
        12: 3,  
        2: 2,  
        18: 2,  
        27: 3,  
        25: 3,  
        3: 3,  
        24: 2,  
        10: 3,  
        5: 0,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 3,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 2,  
        57: 2,  
        58: 0,  
        11: 3,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 3,  
        30: 1,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    32: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 0,  
        12: 3,  
        2: 3,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 1,  
        10: 1,  
        5: 3,  
        13: 2,  
        4: 3,  
        15: 0,  
        26: 1,  
        7: 1,  
        8: 2,  
        9: 3,  
        14: 3,  
        32: 1,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 1,  
        40: 0,  
        19: 0,  
    },
    57: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 1,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 1,  
        21: 0,  
        28: 0,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 1,  
        3: 0,  
        24: 0,  
        10: 1,  
        5: 0,  
        13: 0,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 1,  
        9: 0,  
        14: 1,  
        32: 0,  
        57: 2,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 0,  
        19: 0,  
    },
    58: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 1,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 0,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 0,  
        21: 1,  
        28: 0,  
        12: 2,  
        2: 1,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 2,  
        24: 2,  
        10: 1,  
        5: 0,  
        13: 0,  
        4: 2,  
        15: 0,  
        26: 0,  
        7: 1,  
        8: 2,  
        9: 1,  
        14: 0,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    11: {  
        23: 1,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 3,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 1,  
        56: 1,  
        1: 3,  
        21: 1,  
        28: 0,  
        12: 2,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 2,  
        3: 2,  
        24: 1,  
        10: 2,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 1,  
        7: 2,  
        8: 1,  
        9: 2,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 1,  
        11: 3,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 3,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    22: {  
        23: 2,  
        37: 2,  
        47: 1,  
        39: 2,  
        29: 3,  
        52: 1,  
        36: 2,  
        45: 2,  
        53: 1,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 3,  
        46: 2,  
        42: 2,  
        48: 2,  
        44: 1,  
        35: 1,  
        31: 3,  
        51: 2,  
        38: 2,  
        62: 0,  
        43: 2,  
        56: 1,  
        1: 1,  
        21: 2,  
        28: 1,  
        12: 2,  
        2: 2,  
        18: 3,  
        27: 2,  
        25: 2,  
        3: 3,  
        24: 2,  
        10: 3,  
        5: 0,  
        13: 2,  
        4: 3,  
        15: 2,  
        26: 2,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 0,  
        32: 2,  
        57: 0,  
        58: 0,  
        11: 3,  
        22: 2,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 2,  
        59: 1,  
        33: 0,  
        61: 0,  
        34: 2,  
        17: 2,  
        30: 2,  
        41: 1,  
        6: 3,  
        40: 1,  
        19: 2,  
    },
    63: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 0,  
        21: 0,  
        28: 0,  
        12: 0,  
        2: 1,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 0,  
        13: 2,  
        4: 0,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 0,  
        40: 0,  
        19: 0,  
    },
    54: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 1,  
        29: 0,  
        52: 0,  
        36: 1,  
        45: 1,  
        53: 1,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 1,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 2,  
        56: 0,  
        1: 0,  
        21: 1,  
        28: 0,  
        12: 1,  
        2: 0,  
        18: 0,  
        27: 1,  
        25: 0,  
        3: 3,  
        24: 0,  
        10: 1,  
        5: 0,  
        13: 0,  
        4: 2,  
        15: 1,  
        26: 0,  
        7: 2,  
        8: 0,  
        9: 1,  
        14: 0,  
        32: 2,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 2,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 1,  
    },
    50: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 1,  
        29: 2,  
        52: 0,  
        36: 1,  
        45: 2,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 1,  
        46: 1,  
        42: 2,  
        48: 2,  
        44: 1,  
        35: 0,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 2,  
        56: 0,  
        1: 0,  
        21: 2,  
        28: 1,  
        12: 2,  
        2: 0,  
        18: 1,  
        27: 1,  
        25: 1,  
        3: 2,  
        24: 0,  
        10: 2,  
        5: 0,  
        13: 0,  
        4: 3,  
        15: 2,  
        26: 2,  
        7: 3,  
        8: 1,  
        9: 2,  
        14: 0,  
        32: 1,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 2,  
        17: 2,  
        30: 1,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 1,  
    },
    55: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 1,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 1,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 2,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 1,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 1,  
        13: 1,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 1,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 1,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 0,  
        40: 0,  
        19: 1,  
    },
    59: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 1,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 1,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 2,  
        21: 0,  
        28: 0,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 0,  
        10: 0,  
        5: 0,  
        13: 2,  
        4: 0,  
        15: 1,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 2,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 1,  
        40: 1,  
        19: 0,  
    },
    33: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 3,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 0,  
        1: 0,  
        21: 3,  
        28: 0,  
        12: 2,  
        2: 0,  
        18: 2,  
        27: 1,  
        25: 3,  
        3: 3,  
        24: 0,  
        10: 3,  
        5: 0,  
        13: 0,  
        4: 3,  
        15: 0,  
        26: 1,  
        7: 3,  
        8: 2,  
        9: 3,  
        14: 0,  
        32: 2,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 0,  
        17: 1,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    61: {  
        23: 0,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 0,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 0,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 2,  
        21: 0,  
        28: 0,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 1,  
        10: 0,  
        5: 0,  
        13: 1,  
        4: 1,  
        15: 0,  
        26: 0,  
        7: 0,  
        8: 0,  
        9: 0,  
        14: 1,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 1,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 0,  
        61: 1,  
        34: 0,  
        17: 0,  
        30: 0,  
        41: 0,  
        6: 1,  
        40: 0,  
        19: 0,  
    },
    34: {  
        23: 0,  
        37: 1,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 1,  
        45: 1,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 1,  
        20: 0,  
        46: 1,  
        42: 1,  
        48: 2,  
        44: 1,  
        35: 1,  
        31: 1,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 1,  
        28: 2,  
        12: 1,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 2,  
        3: 1,  
        24: 2,  
        10: 1,  
        5: 2,  
        13: 3,  
        4: 2,  
        15: 2,  
        26: 0,  
        7: 0,  
        8: 3,  
        9: 1,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 1,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 2,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 2,  
        17: 0,  
        30: 2,  
        41: 1,  
        6: 1,  
        40: 2,  
        19: 1,  
    },
    17: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 0,  
        45: 0,  
        53: 0,  
        60: 1,  
        16: 1,  
        49: 0,  
        20: 1,  
        46: 0,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 0,  
        56: 1,  
        1: 3,  
        21: 0,  
        28: 0,  
        12: 1,  
        2: 3,  
        18: 1,  
        27: 2,  
        25: 0,  
        3: 1,  
        24: 1,  
        10: 2,  
        5: 3,  
        13: 2,  
        4: 3,  
        15: 0,  
        26: 2,  
        7: 2,  
        8: 3,  
        9: 2,  
        14: 3,  
        32: 1,  
        57: 1,  
        58: 0,  
        11: 0,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 0,  
        17: 2,  
        30: 0,  
        41: 0,  
        6: 2,  
        40: 0,  
        19: 0,  
    },
    30: {  
        23: 0,  
        37: 2,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 1,  
        45: 0,  
        53: 1,  
        60: 0,  
        16: 3,  
        49: 0,  
        20: 1,  
        46: 2,  
        42: 2,  
        48: 1,  
        44: 1,  
        35: 0,  
        31: 1,  
        51: 0,  
        38: 2,  
        62: 0,  
        43: 2,  
        56: 0,  
        1: 3,  
        21: 0,  
        28: 2,  
        12: 0,  
        2: 2,  
        18: 0,  
        27: 0,  
        25: 0,  
        3: 0,  
        24: 3,  
        10: 1,  
        5: 2,  
        13: 3,  
        4: 0,  
        15: 1,  
        26: 0,  
        7: 1,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 2,  
        50: 2,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 0,  
        34: 2,  
        17: 0,  
        30: 1,  
        41: 2,  
        6: 2,  
        40: 2,  
        19: 1,  
    },
    41: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 1,  
        29: 1,  
        52: 0,  
        36: 2,  
        45: 2,  
        53: 0,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 2,  
        46: 1,  
        42: 1,  
        48: 2,  
        44: 0,  
        35: 1,  
        31: 1,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 2,  
        56: 0,  
        1: 1,  
        21: 2,  
        28: 1,  
        12: 2,  
        2: 1,  
        18: 0,  
        27: 3,  
        25: 2,  
        3: 2,  
        24: 2,  
        10: 2,  
        5: 0,  
        13: 1,  
        4: 3,  
        15: 1,  
        26: 1,  
        7: 3,  
        8: 3,  
        9: 2,  
        14: 0,  
        32: 0,  
        57: 1,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 1,  
        59: 1,  
        33: 0,  
        61: 0,  
        34: 1,  
        17: 1,  
        30: 2,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 1,  
    },
    6: {  
        23: 2,  
        37: 0,  
        47: 0,  
        39: 0,  
        29: 0,  
        52: 0,  
        36: 1,  
        45: 0,  
        53: 0,  
        60: 2,  
        16: 3,  
        49: 0,  
        20: 3,  
        46: 1,  
        42: 0,  
        48: 0,  
        44: 0,  
        35: 0,  
        31: 2,  
        51: 0,  
        38: 0,  
        62: 0,  
        43: 2,  
        56: 1,  
        1: 3,  
        21: 2,  
        28: 1,  
        12: 3,  
        2: 3,  
        18: 3,  
        27: 3,  
        25: 2,  
        3: 3,  
        24: 3,  
        10: 3,  
        5: 3,  
        13: 3,  
        4: 3,  
        15: 0,  
        26: 3,  
        7: 3,  
        8: 3,  
        9: 3,  
        14: 3,  
        32: 3,  
        57: 1,  
        58: 1,  
        11: 3,  
        22: 0,  
        63: 1,  
        54: 0,  
        50: 0,  
        55: 0,  
        59: 0,  
        33: 2,  
        61: 0,  
        34: 0,  
        17: 3,  
        30: 0,  
        41: 0,  
        6: 3,  
        40: 0,  
        19: 0,  
    },
    40: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 1,  
        29: 1,  
        52: 0,  
        36: 1,  
        45: 2,  
        53: 1,  
        60: 0,  
        16: 0,  
        49: 0,  
        20: 2,  
        46: 1,  
        42: 1,  
        48: 2,  
        44: 2,  
        35: 1,  
        31: 1,  
        51: 0,  
        38: 1,  
        62: 0,  
        43: 2,  
        56: 1,  
        1: 0,  
        21: 2,  
        28: 0,  
        12: 2,  
        2: 0,  
        18: 3,  
        27: 0,  
        25: 2,  
        3: 3,  
        24: 2,  
        10: 1,  
        5: 0,  
        13: 1,  
        4: 3,  
        15: 2,  
        26: 0,  
        7: 3,  
        8: 2,  
        9: 2,  
        14: 1,  
        32: 3,  
        57: 0,  
        58: 0,  
        11: 2,  
        22: 0,  
        63: 0,  
        54: 0,  
        50: 0,  
        55: 1,  
        59: 0,  
        33: 0,  
        61: 0,  
        34: 2,  
        17: 1,  
        30: 2,  
        41: 0,  
        6: 2,  
        40: 1,  
        19: 2,  
    },
    19: {  
        23: 0,  
        37: 0,  
        47: 1,  
        39: 0,  
        29: 0,  
        52: 2,  
        36: 1,  
        45: 0,  
        53: 0,  
        60: 0,  
        16: 3,  
        49: 2,  
        20: 0,  
        46: 1,  
        42: 1,  
        48: 1,  
        44: 1,  
        35: 1,  
        31: 0,  
        51: 1,  
        38: 1,  
        62: 0,  
        43: 1,  
        56: 0,  
        1: 3,  
        21: 1,  
        28: 2,  
        12: 0,  
        2: 3,  
        18: 0,  
        27: 2,  
        25: 1,  
        3: 1,  
        24: 0,  
        10: 2,  
        5: 2,  
        13: 3,  
        4: 0,  
        15: 0,  
        26: 1,  
        7: 3,  
        8: 0,  
        9: 0,  
        14: 3,  
        32: 0,  
        57: 0,  
        58: 0,  
        11: 0,  
        22: 2,  
        63: 0,  
        54: 1,  
        50: 2,  
        55: 0,  
        59: 0,  
        33: 1,  
        61: 1,  
        34: 2,  
        17: 0,  
        30: 1,  
        41: 1,  
        6: 1,  
        40: 1,  
        19: 1,  
    },
}








ISO_8859_9_TURKISH_CHAR_TO_ORDER = {
    0: 255,  
    1: 255,  
    2: 255,  
    3: 255,  
    4: 255,  
    5: 255,  
    6: 255,  
    7: 255,  
    8: 255,  
    9: 255,  
    10: 255,  
    11: 255,  
    12: 255,  
    13: 255,  
    14: 255,  
    15: 255,  
    16: 255,  
    17: 255,  
    18: 255,  
    19: 255,  
    20: 255,  
    21: 255,  
    22: 255,  
    23: 255,  
    24: 255,  
    25: 255,  
    26: 255,  
    27: 255,  
    28: 255,  
    29: 255,  
    30: 255,  
    31: 255,  
    32: 255,  
    33: 255,  
    34: 255,  
    35: 255,  
    36: 255,  
    37: 255,  
    38: 255,  
    39: 255,  
    40: 255,  
    41: 255,  
    42: 255,  
    43: 255,  
    44: 255,  
    45: 255,  
    46: 255,  
    47: 255,  
    48: 255,  
    49: 255,  
    50: 255,  
    51: 255,  
    52: 255,  
    53: 255,  
    54: 255,  
    55: 255,  
    56: 255,  
    57: 255,  
    58: 255,  
    59: 255,  
    60: 255,  
    61: 255,  
    62: 255,  
    63: 255,  
    64: 255,  
    65: 23,  
    66: 37,  
    67: 47,  
    68: 39,  
    69: 29,  
    70: 52,  
    71: 36,  
    72: 45,  
    73: 53,  
    74: 60,  
    75: 16,  
    76: 49,  
    77: 20,  
    78: 46,  
    79: 42,  
    80: 48,  
    81: 69,  
    82: 44,  
    83: 35,  
    84: 31,  
    85: 51,  
    86: 38,  
    87: 62,  
    88: 65,  
    89: 43,  
    90: 56,  
    91: 255,  
    92: 255,  
    93: 255,  
    94: 255,  
    95: 255,  
    96: 255,  
    97: 1,  
    98: 21,  
    99: 28,  
    100: 12,  
    101: 2,  
    102: 18,  
    103: 27,  
    104: 25,  
    105: 3,  
    106: 24,  
    107: 10,  
    108: 5,  
    109: 13,  
    110: 4,  
    111: 15,  
    112: 26,  
    113: 64,  
    114: 7,  
    115: 8,  
    116: 9,  
    117: 14,  
    118: 32,  
    119: 57,  
    120: 58,  
    121: 11,  
    122: 22,  
    123: 255,  
    124: 255,  
    125: 255,  
    126: 255,  
    127: 255,  
    128: 180,  
    129: 179,  
    130: 178,  
    131: 177,  
    132: 176,  
    133: 175,  
    134: 174,  
    135: 173,  
    136: 172,  
    137: 171,  
    138: 170,  
    139: 169,  
    140: 168,  
    141: 167,  
    142: 166,  
    143: 165,  
    144: 164,  
    145: 163,  
    146: 162,  
    147: 161,  
    148: 160,  
    149: 159,  
    150: 101,  
    151: 158,  
    152: 157,  
    153: 156,  
    154: 155,  
    155: 154,  
    156: 153,  
    157: 152,  
    158: 151,  
    159: 106,  
    160: 150,  
    161: 149,  
    162: 148,  
    163: 147,  
    164: 146,  
    165: 145,  
    166: 144,  
    167: 100,  
    168: 143,  
    169: 142,  
    170: 141,  
    171: 140,  
    172: 139,  
    173: 138,  
    174: 137,  
    175: 136,  
    176: 94,  
    177: 80,  
    178: 93,  
    179: 135,  
    180: 105,  
    181: 134,  
    182: 133,  
    183: 63,  
    184: 132,  
    185: 131,  
    186: 130,  
    187: 129,  
    188: 128,  
    189: 127,  
    190: 126,  
    191: 125,  
    192: 124,  
    193: 104,  
    194: 73,  
    195: 99,  
    196: 79,  
    197: 85,  
    198: 123,  
    199: 54,  
    200: 122,  
    201: 98,  
    202: 92,  
    203: 121,  
    204: 120,  
    205: 91,  
    206: 103,  
    207: 119,  
    208: 68,  
    209: 118,  
    210: 117,  
    211: 97,  
    212: 116,  
    213: 115,  
    214: 50,  
    215: 90,  
    216: 114,  
    217: 113,  
    218: 112,  
    219: 111,  
    220: 55,  
    221: 41,  
    222: 40,  
    223: 86,  
    224: 89,  
    225: 70,  
    226: 59,  
    227: 78,  
    228: 71,  
    229: 82,  
    230: 88,  
    231: 33,  
    232: 77,  
    233: 66,  
    234: 84,  
    235: 83,  
    236: 110,  
    237: 75,  
    238: 61,  
    239: 96,  
    240: 30,  
    241: 67,  
    242: 109,  
    243: 74,  
    244: 87,  
    245: 102,  
    246: 34,  
    247: 95,  
    248: 81,  
    249: 108,  
    250: 76,  
    251: 72,  
    252: 17,  
    253: 6,  
    254: 19,  
    255: 107,  
}

ISO_8859_9_TURKISH_MODEL = SingleByteCharSetModel(
    charset_name="ISO-8859-9",
    language="Turkish",
    char_to_order_map=ISO_8859_9_TURKISH_CHAR_TO_ORDER,
    language_model=TURKISH_LANG_MODEL,
    typical_positive_ratio=0.97029,
    keep_ascii_letters=True,
    alphabet="ABCDEFGHIJKLMNOPRSTUVYZabcdefghijklmnoprstuvyzÂÇÎÖÛÜâçîöûüĞğİıŞş",
)
