
from .exceptions import *
from .ext import ExtType, Timestamp

import os
import sys


version = (1, 0, 4)
__version__ = "1.0.4"


if os.environ.get("MSGPACK_PUREPYTHON") or sys.version_info[0] == 2:
    from .fallback import Packer, unpackb, Unpacker
else:
    try:
        from ._cmsgpack import Packer, unpackb, Unpacker
    except ImportError:
        from .fallback import Packer, unpackb, Unpacker


def pack(o, stream, **kwargs):
    
    packer = Packer(**kwargs)
    stream.write(packer.pack(o))


def packb(o, **kwargs):
    
    return Packer(**kwargs).pack(o)


def unpack(stream, **kwargs):
    
    data = stream.read()
    return unpackb(data, **kwargs)



load = unpack
loads = unpackb

dump = pack
dumps = packb
